// (c) 2008-2009 Miaoxin Li
// This file is distributed as part of the IGG source code package
// and may not be redistributed in any form, without prior written
// permission from the author. Permission is granted for you to
// modify this file for your own personal use, but modified versions
// must retain this copyright notice and must not be distributed.
// Permission is granted for you to use this file to compile IGG.
// All computer programs have bugs. Use this file at your own risk.
// Saturday, January 17, 2009
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.cobi.igg3;

import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import javax.swing.DefaultComboBoxModel;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import org.apache.crimson.tree.XmlDocument;
import org.apache.http.conn.params.ConnManagerParams;
import org.apache.http.conn.params.ConnPerRouteBean;
import org.apache.http.conn.scheme.PlainSocketFactory;
import org.apache.http.conn.scheme.Scheme;
import org.apache.http.conn.scheme.SchemeRegistry;
import org.apache.http.params.BasicHttpParams;
import org.apache.http.params.HttpParams;
import org.apache.log4j.Logger;
import org.cobi.igg3.entity.PedFile;
import org.cobi.igg3.entity.Project;
import org.cobi.igg3.gui.IGG3App;
import org.cobi.igg3.gui.IGG3View;
import org.cobi.util.download.HttpClient4API;
import org.w3c.dom.DOMException;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.w3c.dom.Text;

/**
 *
 * @author mxli
 */
public class GlobalVariables implements Constants {
    //variables for shared by three FrameViews

    public static IGG3App currentApplication = IGG3App.getApplication();
    public static IGG3View mainView;
    public static Project currentProject;
    public static PedFile currentPedFile;
    public static String lastAccessedPath;
    public static ArrayList<String> latestAccessedProjects = new ArrayList<String>();
    public static Map<String, Long> resourceFileSize = new HashMap<String, Long>(); //update resources
    public static Logger logger = Logger.getLogger("logger");
    public static boolean hasNewLog = false;
    public static String chipCompany = "Affymetrix"; //to integrate genechips
    public static Map<String, Integer> initialChipBuff = new HashMap<String, Integer>();
    public static DefaultComboBoxModel allIntegrationModel = new DefaultComboBoxModel();
    public static DefaultComboBoxModel chipIntegrationModel = new DefaultComboBoxModel();
    public static String plinkPath;
    public static boolean hasProject = false;
    public static HttpParams httpParams = null;
    public static SchemeRegistry connectionSchemeRegistry = null;
    public static boolean hasUpdatedCore = false;
    public static boolean canConnect2Website = false;
    public static String needStartHint = "Yes";

    public static void buildInternetConnection() {
        httpParams = new BasicHttpParams();
        ConnManagerParams.setMaxTotalConnections(httpParams, MAX_TOTAL_CONNECTIONS);
        ConnPerRouteBean connPerRoute = new ConnPerRouteBean(MAX_PER_ROUTE_CONNECTIONS);
        connPerRoute.setDefaultMaxPerRoute(MAX_PER_ROUTE_CONNECTIONS);
        ConnManagerParams.setMaxConnectionsPerRoute(httpParams, connPerRoute);
        connectionSchemeRegistry = new SchemeRegistry();
        connectionSchemeRegistry.register(new Scheme("http", PlainSocketFactory.getSocketFactory(), 80));
        connectionSchemeRegistry.register(new Scheme("https", PlainSocketFactory.getSocketFactory(), 80));
        canConnect2Website = HttpClient4API.testConnection(IGG_RESOURCE_URL + "IGG.jar");
    }

    public static void initialGlobalVariables() {

    

        initialChipBuff.put("Affymetrix_Axiom_GW_ASI_SNP", new Integer(27849093));
        initialChipBuff.put("Affymetrix_Axiom_GW_CHB2", new Integer(27690252));
        initialChipBuff.put("Affymetrix_Axiom_GW_Hu-CHB_SNP", new Integer(28877471));
        initialChipBuff.put("Affymetrix_Axiom_GW_Hu_SNP", new Integer(27208635));
        initialChipBuff.put("Affymetrix_Axiom_GW_PanAFR", new Integer(86688113));

        initialChipBuff.put("Illumina_HumanHap1M", new Integer(1055536));
        initialChipBuff.put("Illumina_HumanHap650Y", new Integer(660919));
        initialChipBuff.put("Illumina_HumanHap610-Quad", new Integer(598822));
        initialChipBuff.put("Illumina_HumanHap550-Duo", new Integer(561467));
        initialChipBuff.put("Illumina_HumanHapCNV370", new Integer(353203));
        initialChipBuff.put("Illumina_HumanHap300-Duo", new Integer(318222));
        initialChipBuff.put("Illumina_Human_Linkage_IVb_Panel", new Integer(207081));
        initialChipBuff.put("Illumina_HumanLinkage-12", new Integer(6091));
        initialChipBuff.put("Affymetrix_GenomeWide_Human_SNP_Array_6.0", new Integer(932980));
        initialChipBuff.put("Affymetrix_GenomeWide_Human_SNP_Array_5.0", new Integer(443107));
        initialChipBuff.put("Affymetrix_Mapping_250K_Nsp_Array", new Integer(262218));
        initialChipBuff.put("Affymetrix_Mapping_250K_Sty_Array", new Integer(238231));
        initialChipBuff.put("Affymetrix_Mapping_50K_Hind_240_Array", new Integer(56937));
        initialChipBuff.put("Affymetrix_Mapping_50K_Xba_240_Array", new Integer(58626));
        initialChipBuff.put("Affymetrix_Mapping_10K_2.0_Array", new Integer(11433));
    }

    /**
     * Get the value of currentProject
     *
     * @return the value of currentProject
     */
    public static Project getCurrentProject() {
        return currentProject;
    }

    /**
     * Set the value of currentProject
     *
     * @param currentProject new value of currentProject
     */
    public static void setCurrentProject(Project currentProject) {
        GlobalVariables.currentProject = currentProject;
    }

    public static void writeEnvironmentalVariables() throws Exception {
// TODO add your handling code here:
        DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
        DocumentBuilder db = null;
        try {
            db = dbf.newDocumentBuilder();
        } catch (ParserConfigurationException pce) {
            throw new Exception(pce.toString());
        }

        Document doc = null;
        Element variable = null;
        Text value = null;
        doc = db.newDocument();
        Element root = doc.createElement("IGGLocalSettings");
        doc.appendChild(root);
        variable = doc.createElement("lastAccessedPath");
        root.appendChild(variable);
        value = doc.createTextNode(lastAccessedPath == null ? "" : lastAccessedPath);
        variable.appendChild(value);

        variable = doc.createElement("plinkPath");
        root.appendChild(variable);
        value = doc.createTextNode(plinkPath == null ? "" : plinkPath);
        variable.appendChild(value);
        int maxSize = 5;
        int startSize = 0;
        if (maxSize < latestAccessedProjects.size()) {
            startSize = latestAccessedProjects.size() - maxSize;
        }
        maxSize = latestAccessedProjects.size();
        for (int i = startSize; i < maxSize; i++) {
            variable = doc.createElement("latestAccessedProjects");
            root.appendChild(variable);
            value = doc.createTextNode(latestAccessedProjects.get(i));
            variable.appendChild(value);
        }

        variable = doc.createElement("needFileLoadHint");
        root.appendChild(variable);
        value = doc.createTextNode(needStartHint);
        variable.appendChild(value);

        Element resourceFiles = doc.createElement("resourceFiles");
        root.appendChild(resourceFiles);
        Iterator iter = resourceFileSize.keySet().iterator();
        while (iter.hasNext()) {
            Object key = iter.next();
            Element resourceFile = doc.createElement("resourceFile");
            resourceFiles.appendChild(resourceFile);

            Element fileName = doc.createElement("file");
            resourceFile.appendChild(fileName);
            Text name = doc.createTextNode(key.toString());
            fileName.appendChild(name);

            Element fileSize = doc.createElement("size");
            resourceFile.appendChild(fileSize);
            Text size = doc.createTextNode(resourceFileSize.get(key).toString());
            fileSize.appendChild(size);
        }
        FileOutputStream outStream = new FileOutputStream("igg.ini.xml");
        OutputStreamWriter outWriter = new OutputStreamWriter(outStream);
        ((XmlDocument) doc).write(outWriter, "UTF-8");
        outWriter.close();
        outStream.close();
    }

    public static void readEnvironmentalVariables() throws Exception {
// TODO add your handling code here:
        DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
        DocumentBuilder db = null;
        try {
            db = dbf.newDocumentBuilder();
        } catch (ParserConfigurationException pce) {
            throw new Exception(pce.toString());
        }
        Document doc = null;
        try {
            doc = db.parse("igg.ini.xml");
        } catch (DOMException dom) {
            throw new Exception(dom.getMessage());
        } catch (IOException ioe) {
            throw new Exception(ioe.toString() + " No Initial file!");
        }

        Element root = doc.getDocumentElement();
        NodeList nodes = root.getElementsByTagName("lastAccessedPath");
        if (nodes.getLength() == 1) {
            Element e = (Element) nodes.item(0);
            Text t = (Text) e.getFirstChild();
            if (t == null) {
                lastAccessedPath = "";
            } else {
                lastAccessedPath = (t.getNodeValue());
            }
        }
        nodes = root.getElementsByTagName("plinkPath");
        if (nodes.getLength() == 1) {
            Element e = (Element) nodes.item(0);
            Text t = (Text) e.getFirstChild();
            if (t == null) {
                plinkPath = "";
            } else {
                plinkPath = (t.getNodeValue());
            }
        }

        nodes = root.getElementsByTagName("needFileLoadHint");
        if (nodes.getLength() == 1) {
            Element e = (Element) nodes.item(0);
            Text t = (Text) e.getFirstChild();
            if (t == null) {
                needStartHint = "Yes";
            } else {
                needStartHint = (t.getNodeValue());
            }
        }

        nodes = root.getElementsByTagName("latestAccessedProjects");
        for (int i = 0; i < nodes.getLength(); i++) {
            Element subNode = (Element) nodes.item(i);
            Text t = (Text) subNode.getFirstChild();
            latestAccessedProjects.add(t.getNodeValue());
        }


        NodeList files = root.getElementsByTagName("resourceFile");
        String fileName = null;
        Long fileSize = null;

        for (int i = 0; i < files.getLength(); i++) {
            Element resourceFile = (Element) files.item(i);
            nodes = resourceFile.getElementsByTagName("file");
            if (nodes.getLength() == 1) {
                Element e = (Element) nodes.item(0);
                Text t = (Text) e.getFirstChild();
                fileName = (t.getNodeValue());
            }

            nodes = resourceFile.getElementsByTagName("size");
            if (nodes.getLength() == 1) {
                Element e = (Element) nodes.item(0);
                Text t = (Text) e.getFirstChild();
                fileSize = new Long(t.getNodeValue());
            }
            if (fileName != null) {
                resourceFileSize.put(fileName, fileSize);
            }
        }
    }

    public static void addInforLog(String msg) {
        logger.info(msg);
        hasNewLog = true;
    }
}
