// (c) 2008-2009 Miaoxin Li
// 
// This file is distributed as part of the IGG source code package   
// and may not be redistributed in any form, without prior written    
// permission from the author. Permission is granted for you to       
// modify this file for your own personal use, but modified versions  
// must retain this copyright notice and must not be distributed.     
// 
// Permission is granted for you to use this file to compile IGG.    
// 
// All computer programs have bugs. Use this file at your own risk.   
// 
package org.cobi.igg3;

import java.util.Calendar;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

/**
 *
 * @author mxli
 */
public class HashMapTest {

    public static void main(String[] args) {

        String rsIds = "AFFX-SNP_9976462__rs2810434";
        if (rsIds.startsWith("AFFX")) {
            int indexTmp = rsIds.indexOf("rs");
            if (indexTmp >= 0) {
                rsIds = rsIds.substring(indexTmp);
            }
        }
        System.out.println(rsIds);
        Map<Long, String> longMap = new HashMap<Long, String>();
        Map<String, String> stringMap = new HashMap<String, String>();
        System.out.println(Long.MAX_VALUE);
        int totalNum = 850001;
        long bs = Calendar.getInstance().getTimeInMillis();
        for (long i = 0; i < totalNum; i++) {
            longMap.put(i, "hello");
        }
        System.out.println("Construction LongMap" + (Calendar.getInstance().getTimeInMillis() - bs));

        bs = Calendar.getInstance().getTimeInMillis();
        for (long i = 0; i < totalNum; i++) {
            stringMap.put(String.valueOf(i), "hello");
        }
        System.out.println("Construction StringMap" + (Calendar.getInstance().getTimeInMillis() - bs));


        bs = Calendar.getInstance().getTimeInMillis();
        for (long i = 0; i < totalNum; i++) {
            String test = longMap.get(i);
        }
        System.out.println("Access LongMap" + (Calendar.getInstance().getTimeInMillis() - bs));

        bs = Calendar.getInstance().getTimeInMillis();
        for (long i = 0; i < totalNum; i++) {
            String test = stringMap.get(String.valueOf(i));
        }
        System.out.println("Access StringMap" + (Calendar.getInstance().getTimeInMillis() - bs));
    }

    public static void listHashMap() {
        java.util.HashMap hashmap = new java.util.HashMap();
        for (int i = 0; i < 1000; i++) {
            hashmap.put("" + i, "hello");
        }
        long bs = Calendar.getInstance().getTimeInMillis();
//Set set = hashmap.entrySet() ;
        java.util.Iterator it = hashmap.entrySet().iterator();
        while (it.hasNext()) {
            java.util.Map.Entry entry = (java.util.Map.Entry) it.next();
// entry.getKey() 返回与此项对应的�?// entry.getValue() 返回与此项对应的�?            System.out.println(entry.getValue());
        }
        System.out.println(Calendar.getInstance().getTimeInMillis() - bs);


    }
}
