// (c) 2008-2009 Miaoxin Li
// This file is distributed as part of the IGG source code package
// and may not be redistributed in any form, without prior written
// permission from the author. Permission is granted for you to
// modify this file for your own personal use, but modified versions
// must retain this copyright notice and must not be distributed.
// Permission is granted for you to use this file to compile IGG.
// All computer programs have bugs. Use this file at your own risk.
// Saturday, January 17, 2009
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.cobi.igg3.controller;

import cern.colt.list.LongArrayList;
import java.io.BufferedOutputStream;
import java.io.BufferedWriter;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import org.cobi.igg3.entity.AnnotSNP;
import org.cobi.igg3.entity.ChromSNPGtySet;
import org.cobi.igg3.entity.PedFile;
import org.cobi.igg3.entity.StatusGtySet;
import org.cobi.igg3.genetformator.BeagleFiles;
import org.cobi.igg3.genetformator.ImputeFiles;
import org.cobi.igg3.genetformator.MerlinFiles;
import org.cobi.igg3.genetformator.PhaseFiles;
import org.cobi.igg3.genetformator.PlinkFiles;
import org.cobi.igg3.gui.IGG3View;
import org.cobi.igg3.GlobalVariables;

/**
 *
 * @author Miaoxin Li
 */
public class ImputationExporter extends BasicGenetExporter {

    GenotypeQC genotypeQC = null;

    public ImputationExporter() {
        genotypeQC = new GenotypeQC();
    }

    public String exportPlink2ImputationTraditional() throws Exception {
        List<String> chroms = integration.getChromResult();
        ChromSNPGtySet chromSet = new ChromSNPGtySet();
        String infor;
        List<String> chromArray = new ArrayList<String>();

        String path = exportSetting.getExportPath();
        String prefix = exportSetting.getPrefixFileName();

        boolean seperateByChrom = exportSetting.isSeparateByChrom();
        PedFile hapPed = null;
        if (integration.isHapMapSet()) {
            hapPed = new PedFile();
            hapPed.parseHapMapPed(IGG_RESOURCE_HAPMAP_FOLDER + File.separator + "pedinfor" + File.separator + "hap3Sample.txt");
        }

        PlinkFiles inputer = new PlinkFiles();
        String msg;
        if (seperateByChrom) {
            Map<String, LongArrayList> selectedRegions = exportSetting.getSelectedRegions();
            if (selectedRegions != null && selectedRegions.size() > 0) {
                for (int k = 0; k < chroms.size(); k++) {
                    String chrom = chroms.get(k);
                    chrom = chrom.substring(0, chrom.indexOf(' '));
                    LongArrayList regions = selectedRegions.get(chrom);
                    if (regions == null) {
                        continue;
                    }
                    chromSet.setChromName(chrom);
                    BufferedWriter bwGeneticMaps = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".map"));
                    chromSet.readAllObjects(integration.getResultPath());

                    List<AnnotSNP> mainSnpMap = chromSet.getSnpInfoList();
                    Map<String, StatusGtySet> indivGtyMap = chromSet.getIndiviGty();
                    filterSNPsbyRegion(mainSnpMap, regions);
                    msg = mainSnpMap.size() + " SNPs within the SELECTED region on Chromosome " + chrom;
                    msg = msg + "\nChecking Genotype Quality on Chromosome " + chrom;
                    GlobalVariables.mainView.setBriefRunningInfor(msg);
                    GlobalVariables.addInforLog(msg);
                    preprocessSNPGty(mainSnpMap, indivGtyMap, chrom);

                    inputer.writeMapFile(bwGeneticMaps, mainSnpMap);
                    bwGeneticMaps.close();

                    msg = "Transforming Genotypes on Chromosome " + chrom;
                    GlobalVariables.mainView.setBriefRunningInfor(msg);
                    GlobalVariables.addInforLog(msg);
                    generalLinkPedCharAllele(mainSnpMap, indivGtyMap, chrom, hapPed);
                    chromArray.add(chrom);
                }
            } else {
                for (int k = 0; k < chroms.size(); k++) {
                    String chrom = chroms.get(k);
                    chrom = chrom.substring(0, chrom.indexOf(' '));
                    chromSet.setChromName(chrom);
                    BufferedWriter bwGeneticMaps = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".map"));

                    chromSet.readAllObjects(integration.getResultPath());

                    List<AnnotSNP> mainSnpMap = chromSet.getSnpInfoList();
                    Map<String, StatusGtySet> indivGtyMap = chromSet.getIndiviGty();
                    msg = "Checking Genotype Quality on Chromosome " + chrom;
                    GlobalVariables.mainView.setBriefRunningInfor(msg);
                    GlobalVariables.addInforLog(msg);
                    preprocessSNPGty(mainSnpMap, indivGtyMap, chrom);
                    inputer.writeMapFile(bwGeneticMaps, mainSnpMap);
                    bwGeneticMaps.close();

                    msg = "Transforming Genotypes on Chromosome " + chrom;
                    GlobalVariables.mainView.setBriefRunningInfor(msg);
                    GlobalVariables.addInforLog(msg);
                    generalLinkPedCharAllele(mainSnpMap, indivGtyMap, chrom, hapPed);
                    chromArray.add(chrom);
                }
            }
            msg = "Generating Pedigree File";
            GlobalVariables.mainView.setBriefRunningInfor(msg);
            GlobalVariables.addInforLog(msg);

            infor = "Files are expored into " + path + "(chromosome#)\n " + prefix + ".#" + ".ped, "
                    + prefix + ".#" + ".map"
                    + "\nAn example command to run plink for genotype imputation on chromosome #:\n"
                    + "./plink --file " + prefix + ".# --all --proxy-impute all --proxy-verbose --make-bed --out outname";


        } else {
            BufferedWriter bwGeneticMaps = new BufferedWriter(new FileWriter(path + prefix + ".map"));
            Map<String, LongArrayList> selectedRegions = exportSetting.getSelectedRegions();
            if (selectedRegions != null && selectedRegions.size() > 0) {
                for (int k = 0; k < chroms.size(); k++) {
                    String chrom = chroms.get(k);
                    chrom = chrom.substring(0, chrom.indexOf(' '));
                    LongArrayList regions = selectedRegions.get(chrom);
                    if (regions == null) {
                        continue;
                    }
                    chromSet.setChromName(chrom);
                    chromSet.readAllObjects(integration.getResultPath());

                    List<AnnotSNP> mainSnpMap = chromSet.getSnpInfoList();
                    Map<String, StatusGtySet> indivGtyMap = chromSet.getIndiviGty();
                    filterSNPsbyRegion(mainSnpMap, regions);
                    msg = mainSnpMap.size() + " SNPs within the SELECTED region on Chromosome " + chrom;
                    msg = msg + "\nChecking Genotype Quality on Chromosome " + chrom;
                    GlobalVariables.mainView.setBriefRunningInfor(msg);
                    GlobalVariables.addInforLog(msg);
                    preprocessSNPGty(mainSnpMap, indivGtyMap, chrom);

                    inputer.writeMapFile(bwGeneticMaps, mainSnpMap);

                    msg = "Transforming Genotypes on Chromosome " + chrom;
                    GlobalVariables.mainView.setBriefRunningInfor(msg);
                    GlobalVariables.addInforLog(msg);
                    generalLinkPedGenotypeCharAllele(mainSnpMap, indivGtyMap, chrom);
                    chromArray.add(chrom);
                }
            } else {
                for (int k = 0; k < chroms.size(); k++) {
                    String chrom = chroms.get(k);
                    chrom = chrom.substring(0, chrom.indexOf(' '));
                    chromSet.setChromName(chrom);
                    chromSet.readAllObjects(integration.getResultPath());

                    List<AnnotSNP> mainSnpMap = chromSet.getSnpInfoList();
                    Map<String, StatusGtySet> indivGtyMap = chromSet.getIndiviGty();
                    msg = "Checking Genotype Quality on Chromosome " + chrom;
                    GlobalVariables.mainView.setBriefRunningInfor(msg);
                    GlobalVariables.addInforLog(msg);
                    preprocessSNPGty(mainSnpMap, indivGtyMap, chrom);

                    inputer.writeMapFile(bwGeneticMaps, mainSnpMap);

                    msg = "Transforming Genotypes on Chromosome " + chrom;
                    GlobalVariables.mainView.setBriefRunningInfor(msg);
                    GlobalVariables.addInforLog(msg);
                    generalLinkPedGenotypeCharAllele(mainSnpMap, indivGtyMap, chrom);
                    chromArray.add(chrom);
                }
            }
            bwGeneticMaps.close();

            msg = "Generating Pedigree File";
            GlobalVariables.mainView.setBriefRunningInfor(msg);
            GlobalVariables.addInforLog(msg);
            mergeGeneralLinkPedGenotypeFiles(chromArray, path + File.separator + prefix + ".ped", hapPed);

            infor = "Files are expored into " + path + "\n " + prefix + ".ped, " + prefix + ".map."
                    + "\nAn example command to run plink for genotype imputation:\n"
                    + "./plink --file " + prefix + " --all --proxy-impute all --proxy-verbose --make-bed --out outname";

        }
        return infor;
    }

    public String exportPlink2ImputationBinary() throws Exception {

        List<String> chroms = integration.getChromResult();
        ChromSNPGtySet chromSet = new ChromSNPGtySet();
        String infor, msg;
        List<String> chromArray = new ArrayList<String>();

        String path = exportSetting.getExportPath();
        String prefix = exportSetting.getPrefixFileName();

        boolean seperateByChrom = exportSetting.isSeparateByChrom();
        PedFile hapPed = null;
        if (integration.isHapMapSet()) {
            hapPed = new PedFile();
            hapPed.parseHapMapPed(IGG_RESOURCE_HAPMAP_FOLDER + File.separator + "pedinfor" + File.separator + "hap3Sample.txt");
        }

        PlinkFiles inputer = new PlinkFiles();
        List<String[]> phenotypeClasses = exportSetting.getTraitProper();

        if (seperateByChrom) {
            Map<String, LongArrayList> selectedRegions = exportSetting.getSelectedRegions();
            if (selectedRegions != null && selectedRegions.size() > 0) {
                for (int k = 0; k < chroms.size(); k++) {
                    String chrom = chroms.get(k);
                    chrom = chrom.substring(0, chrom.indexOf(' '));
                    LongArrayList regions = selectedRegions.get(chrom);
                    if (regions == null) {
                        continue;
                    }
                    chromSet.setChromName(chrom);

                    BufferedWriter bwPedFile = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".fam"));
                    inputer.writePedigreeFileBinaryFormat(bwPedFile, integration, hapPed, phenotypeClasses);
                    bwPedFile.close();
                    DataOutputStream bedOut = new DataOutputStream(new BufferedOutputStream(new FileOutputStream(path + prefix + "." + chrom + ".bed")));
                    inputer.writeBinaryGenotypesHead(bedOut);

                    BufferedWriter bwGeneticMaps = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".bim"));
                    chromSet.readAllObjects(integration.getResultPath());

                    List<AnnotSNP> mainSnpMap = chromSet.getSnpInfoList();
                    Map<String, StatusGtySet> indivGtyMap = chromSet.getIndiviGty();
                    filterSNPsbyRegion(mainSnpMap, regions);
                    msg = mainSnpMap.size() + " SNPs within the SELECTED region on Chromosome " + chrom;
                    msg = msg + "\nChecking Genotype Quality on Chromosome " + chrom;
                    GlobalVariables.mainView.setBriefRunningInfor(msg);
                    GlobalVariables.addInforLog(msg);
                    preprocessSNPGty(mainSnpMap, indivGtyMap, chrom);

                    inputer.writeMapFileBinaryFormat(bwGeneticMaps, mainSnpMap);
                    bwGeneticMaps.close();

                    msg = "Transforming Genotypes on Chromosome " + chrom;
                    GlobalVariables.mainView.setBriefRunningInfor(msg);
                    GlobalVariables.addInforLog(msg);
                    inputer.writeBinaryGenotypesBody(bedOut, mainSnpMap, indivGtyMap, exportSetting, integration);
                    bedOut.close();
                    chromArray.add(chrom);
                }
            } else {
                for (int k = 0; k < chroms.size(); k++) {
                    String chrom = chroms.get(k);
                    chrom = chrom.substring(0, chrom.indexOf(' '));
                    chromSet.setChromName(chrom);
                    BufferedWriter bwPedFile = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".fam"));
                    inputer.writePedigreeFileBinaryFormat(bwPedFile, integration, hapPed, phenotypeClasses);
                    bwPedFile.close();


                    DataOutputStream bedOut = new DataOutputStream(new BufferedOutputStream(new FileOutputStream(path + prefix + "." + chrom + ".bed")));
                    inputer.writeBinaryGenotypesHead(bedOut);
                    BufferedWriter bwGeneticMaps = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".bim"));
                    chromSet.readAllObjects(integration.getResultPath());

                    List<AnnotSNP> mainSnpMap = chromSet.getSnpInfoList();
                    Map<String, StatusGtySet> indivGtyMap = chromSet.getIndiviGty();
                    msg = "Checking Genotype Quality on Chromosome " + chrom;
                    GlobalVariables.mainView.setBriefRunningInfor(msg);
                    GlobalVariables.addInforLog(msg);
                    preprocessSNPGty(mainSnpMap, indivGtyMap, chrom);
                    inputer.writeMapFileBinaryFormat(bwGeneticMaps, mainSnpMap);
                    bwGeneticMaps.close();


                    msg = "Transforming Genotypes on Chromosome " + chrom;
                    GlobalVariables.mainView.setBriefRunningInfor(msg);
                    GlobalVariables.addInforLog(msg);
                    inputer.writeBinaryGenotypesBody(bedOut, mainSnpMap, indivGtyMap, exportSetting, integration);
                    bedOut.close();
                    chromArray.add(chrom);
                }
            }
            msg = "Generating Pedigree File";
            GlobalVariables.mainView.setBriefRunningInfor(msg);
            GlobalVariables.addInforLog(msg);

            infor = "Files are expored into " + path + "(chromosome#)\n " + prefix + ".#" + ".fam, "
                    + prefix + ".#" + ".bim " + prefix + ".#" + ".bed."
                    + "\nAn example command to run plink for genotype imputation on chromosome #:\n"
                    + "./plink --bfile " + prefix + ".# --all --proxy-impute all --proxy-verbose --make-bed --out outname";


        } else {
            BufferedWriter bwPedFile = new BufferedWriter(new FileWriter(path + prefix + ".fam"));
            inputer.writePedigreeFileBinaryFormat(bwPedFile, integration, hapPed, phenotypeClasses);
            bwPedFile.close();
            DataOutputStream bedOut = new DataOutputStream(new BufferedOutputStream(new FileOutputStream(path + prefix + ".bed")));
            inputer.writeBinaryGenotypesHead(bedOut);
            BufferedWriter bwGeneticMaps = new BufferedWriter(new FileWriter(path + prefix + ".bim"));
            Map<String, LongArrayList> selectedRegions = exportSetting.getSelectedRegions();
            if (selectedRegions != null && selectedRegions.size() > 0) {
                for (int k = 0; k < chroms.size(); k++) {
                    String chrom = chroms.get(k);
                    chrom = chrom.substring(0, chrom.indexOf(' '));
                    LongArrayList regions = selectedRegions.get(chrom);
                    if (regions == null) {
                        continue;
                    }
                    chromSet.setChromName(chrom);
                    chromSet.readAllObjects(integration.getResultPath());

                    List<AnnotSNP> mainSnpMap = chromSet.getSnpInfoList();
                    Map<String, StatusGtySet> indivGtyMap = chromSet.getIndiviGty();
                    filterSNPsbyRegion(mainSnpMap, regions);
                    msg = mainSnpMap.size() + " SNPs within the SELECTED region on Chromosome " + chrom;
                    msg = msg + "\nChecking Genotype Quality on Chromosome " + chrom;
                    GlobalVariables.mainView.setBriefRunningInfor(msg);
                    GlobalVariables.addInforLog(msg);
                    preprocessSNPGty(mainSnpMap, indivGtyMap, chrom);

                    inputer.writeMapFileBinaryFormat(bwGeneticMaps, mainSnpMap);

                    msg = "Transforming Genotypes on Chromosome " + chrom;
                    GlobalVariables.mainView.setBriefRunningInfor(msg);
                    GlobalVariables.addInforLog(msg);
                    inputer.writeBinaryGenotypesBody(bedOut, mainSnpMap, indivGtyMap, exportSetting, integration);
                    chromArray.add(chrom);
                }
            } else {
                for (int k = 0; k < chroms.size(); k++) {
                    String chrom = chroms.get(k);
                    chrom = chrom.substring(0, chrom.indexOf(' '));
                    chromSet.setChromName(chrom);
                    chromSet.readAllObjects(integration.getResultPath());

                    List<AnnotSNP> mainSnpMap = chromSet.getSnpInfoList();
                    Map<String, StatusGtySet> indivGtyMap = chromSet.getIndiviGty();
                    msg = "Checking Genotype Quality on Chromosome " + chrom;
                    GlobalVariables.mainView.setBriefRunningInfor(msg);
                    GlobalVariables.addInforLog(msg);
                    preprocessSNPGty(mainSnpMap, indivGtyMap, chrom);

                    inputer.writeMapFileBinaryFormat(bwGeneticMaps, mainSnpMap);

                    msg = "Transforming Genotypes on Chromosome " + chrom;
                    GlobalVariables.mainView.setBriefRunningInfor(msg);
                    GlobalVariables.addInforLog(msg);
                    inputer.writeBinaryGenotypesBody(bedOut, mainSnpMap, indivGtyMap, exportSetting, integration);
                    chromArray.add(chrom);
                }
            }
            bwGeneticMaps.close();
            bedOut.close();
            infor = "Files are expored into " + path + "\n " + prefix + ".fam, " + prefix + ".bim " + prefix + ".bed."
                    + "\nAn example command to run plink for genotype imputation:\n"
                    + "./plink --bfile " + prefix + " --all --proxy-impute all --proxy-verbose --make-bed --out outname";

        }

        return infor;
    }

    public String exportMach2Imputation() throws Exception {
        if (integration.isHapMapPhased()) {
            return exportMach2PhaseImputation();
        } else {
            return exportMach2UnPhaseImputation();
        }
    }

    public String exportMach2UnPhaseImputation() throws Exception {
        List<String> chroms = integration.getChromResult();
        ChromSNPGtySet chromSet = new ChromSNPGtySet();
        String infor;
        String path = exportSetting.getExportPath();
        String prefix = exportSetting.getPrefixFileName();

        PedFile hapPed = null;
        if (integration.isHapMapSet()) {
            hapPed = new PedFile();
            hapPed.parseHapMapPed(IGG_RESOURCE_HAPMAP_FOLDER + File.separator + "pedinfor" + File.separator + "hap3Sample.txt");
        }

        MerlinFiles inputer = new MerlinFiles();
        String msg;
        Map<String, LongArrayList> selectedRegions = exportSetting.getSelectedRegions();
        if (selectedRegions != null && selectedRegions.size() > 0) {
            for (int k = 0; k < chroms.size(); k++) {
                String chrom = chroms.get(k);
                chrom = chrom.substring(0, chrom.indexOf(' '));
                LongArrayList regions = selectedRegions.get(chrom);
                if (regions == null) {
                    continue;
                }
                chromSet.setChromName(chrom);
                List<String[]> phenotypeClasses = exportSetting.getTraitProper();
                BufferedWriter bwPedFileDescription = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".dat"));
                BufferedWriter bwGeneticMaps = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".map"));
                BufferedWriter bwAlleleFrequencies = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".freq"));

                //write the description file
                for (int i = 0; i < phenotypeClasses.size(); i++) {
                    //Phentype types:  A - affection status, T - Quantitative Trait and C - Covariate)
                    if (phenotypeClasses.get(i)[1].startsWith("Affection Status")) {
                        bwPedFileDescription.write("A ");
                    } else if (phenotypeClasses.get(i)[1].startsWith("Quantitative Trait")) {
                        bwPedFileDescription.write("T ");
                    } else if (phenotypeClasses.get(i)[1].startsWith("Covariate")) {
                        bwPedFileDescription.write("C ");
                    }
                    bwPedFileDescription.write(phenotypeClasses.get(i)[0]);
                    bwPedFileDescription.write("\n");
                }
                bwGeneticMaps.write("CHROMOSOME  MARKER  POSITION\n");

                chromSet.readAllObjects(integration.getResultPath());

                List<AnnotSNP> mainSnpMap = chromSet.getSnpInfoList();
                Map<String, StatusGtySet> mainIndivGtyMap = chromSet.getIndiviGty();
                filterSNPsbyRegion(mainSnpMap, regions);
                msg = mainSnpMap.size() + " SNPs within the SELECTED region on Chromosome " + chrom;
                msg = msg + "\nChecking Genotype Quality on Chromosome " + chrom;
                GlobalVariables.mainView.setBriefRunningInfor(msg);
                GlobalVariables.addInforLog(msg);

                preprocessSNPGty(mainSnpMap, mainIndivGtyMap, chrom);

                inputer.writePedFileDescriptionMerlin(bwPedFileDescription, mainSnpMap);
                inputer.writeGeneticMapsMerlin(bwGeneticMaps, mainSnpMap);
                inputer.writeAlleleFrequenciesMerlin(bwAlleleFrequencies, mainSnpMap);

                bwPedFileDescription.close();
                bwGeneticMaps.close();
                bwAlleleFrequencies.close();

                msg = "Transforming Genotypes on Chromosome " + chrom;
                GlobalVariables.mainView.setBriefRunningInfor(msg);
                GlobalVariables.addInforLog(msg);
                generalLinkPedCharAllele(mainSnpMap, mainIndivGtyMap, chrom, hapPed);
            }
        } else {
            for (int k = 0; k < chroms.size(); k++) {
                String chrom = chroms.get(k);
                chrom = chrom.substring(0, chrom.indexOf(' '));
                chromSet.setChromName(chrom);
                List<String[]> phenotypeClasses = exportSetting.getTraitProper();
                BufferedWriter bwPedFileDescription = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".dat"));
                BufferedWriter bwGeneticMaps = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".map"));
                BufferedWriter bwAlleleFrequencies = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".freq"));

                //write the description file
                for (int i = 0; i < phenotypeClasses.size(); i++) {
                    //Phentype types:  A - affection status, T - Quantitative Trait and C - Covariate)
                    if (phenotypeClasses.get(i)[1].startsWith("Affection Status")) {
                        bwPedFileDescription.write("A ");
                    } else if (phenotypeClasses.get(i)[1].startsWith("Quantitative Trait")) {
                        bwPedFileDescription.write("T ");
                    } else if (phenotypeClasses.get(i)[1].startsWith("Covariate")) {
                        bwPedFileDescription.write("C ");
                    }
                    bwPedFileDescription.write(phenotypeClasses.get(i)[0]);
                    bwPedFileDescription.write("\n");
                }
                bwGeneticMaps.write("CHROMOSOME  MARKER  POSITION\n");

                chromSet.readAllObjects(integration.getResultPath());

                List<AnnotSNP> mainSnpMap = chromSet.getSnpInfoList();
                Map<String, StatusGtySet> mainIndivGtyMap = chromSet.getIndiviGty();
                msg = "Checking Genotype Quality on Chromosome " + chrom;
                GlobalVariables.mainView.setBriefRunningInfor(msg);
                GlobalVariables.addInforLog(msg);

                preprocessSNPGty(mainSnpMap, mainIndivGtyMap, chrom);

                inputer.writePedFileDescriptionMerlin(bwPedFileDescription, mainSnpMap);
                inputer.writeGeneticMapsMerlin(bwGeneticMaps, mainSnpMap);
                inputer.writeAlleleFrequenciesMerlin(bwAlleleFrequencies, mainSnpMap);

                bwPedFileDescription.close();
                bwGeneticMaps.close();
                bwAlleleFrequencies.close();

                msg = "Transforming Genotypes on Chromosome " + chrom;
                GlobalVariables.mainView.setBriefRunningInfor(msg);
                GlobalVariables.addInforLog(msg);
                generalLinkPedCharAllele(mainSnpMap, mainIndivGtyMap, chrom, hapPed);
            }
        }
        msg = "Generating Pedigree File";
        GlobalVariables.mainView.setBriefRunningInfor(msg);
        GlobalVariables.addInforLog(msg);
        infor = "Files are expored into " + path + "(chromosome#)\n " + prefix + ".#.ped, " + prefix + ".#.dat, " + prefix + ".#.map, "
                + prefix + ".#.freq."
                + "\nAn example command to run mach for genotype imputation on chromosome #:\n"
                + "./mach1 -d " + prefix + ".#.dat -p " + prefix + ".#.ped  --rounds 50 --greedy --geno --prefix filename";
        return infor;
    }

    public String exportMach2PhaseImputation() throws Exception {
        List<String> chroms = integration.getChromResult();
        ChromSNPGtySet chromSet = new ChromSNPGtySet();
        String infor;
        String path = exportSetting.getExportPath();
        String prefix = exportSetting.getPrefixFileName();

        PedFile hapPed = null;
        if (integration.isHapMapSet()) {
            hapPed = new PedFile();
            hapPed.parseHapMapPed(IGG_RESOURCE_HAPMAP_FOLDER + File.separator + "pedinfor" + File.separator + "hap3Sample.txt");
        }

        MerlinFiles inputer = new MerlinFiles();
        String msg;
        Map<String, LongArrayList> selectedRegions = exportSetting.getSelectedRegions();
        if (selectedRegions != null && selectedRegions.size() > 0) {
            for (int k = 0; k < chroms.size(); k++) {
                String chrom = chroms.get(k);
                chrom = chrom.substring(0, chrom.indexOf(' '));
                LongArrayList regions = selectedRegions.get(chrom);
                if (regions == null) {
                    continue;
                }
                chromSet.setChromName(chrom);
                List<String[]> phenotypeClasses = exportSetting.getTraitProper();
                BufferedWriter bwPedFileDescription = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".dat"));
                BufferedWriter bwGeneticMaps = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".map"));
                BufferedWriter bwAlleleFrequencies = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".freq"));
                BufferedWriter bwHaplos = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".haplos"));
                BufferedWriter bwSNPs = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".snps"));
                //write the description file 
                for (int i = 0; i < phenotypeClasses.size(); i++) {
                    //Phentype types:  A - affection status, T - Quantitative Trait and C - Covariate)
                    if (phenotypeClasses.get(i)[1].startsWith("Affection Status")) {
                        bwPedFileDescription.write("A ");
                    } else if (phenotypeClasses.get(i)[1].startsWith("Quantitative Trait")) {
                        bwPedFileDescription.write("T ");
                    } else if (phenotypeClasses.get(i)[1].startsWith("Covariate")) {
                        bwPedFileDescription.write("C ");
                    }
                    bwPedFileDescription.write(phenotypeClasses.get(i)[0]);
                    bwPedFileDescription.write("\n");
                }
                bwGeneticMaps.write("CHROMOSOME  MARKER  POSITION\n");

                chromSet.readAllObjects(integration.getResultPath());

                List<AnnotSNP> mainSnpMap = chromSet.getSnpInfoList();
                Map<String, StatusGtySet> mainIndivGtyMap = chromSet.getIndiviGty();
                filterSNPsbyRegion(mainSnpMap, regions);
                msg = mainSnpMap.size() + " SNPs within the SELECTED region on Chromosome " + chrom;
                msg = msg + "\nChecking Genotype Quality on Chromosome " + chrom;
                GlobalVariables.mainView.setBriefRunningInfor(msg);
                GlobalVariables.addInforLog(msg);

                preprocessSNPGty(mainSnpMap, mainIndivGtyMap, chrom);
                List<AnnotSNP> hapSnpMap = new ArrayList<AnnotSNP>();
                Map<String, StatusGtySet> hapIndivGtyMap = new HashMap<String, StatusGtySet>();
                splitHapSNPGty(mainSnpMap, mainIndivGtyMap, hapSnpMap, hapIndivGtyMap);
                genotypeQC.removeAllMissing(hapSnpMap, hapIndivGtyMap);

                inputer.writePedFileDescriptionMerlin(bwPedFileDescription, mainSnpMap);
                inputer.writeGeneticMapsMerlin(bwGeneticMaps, mainSnpMap);
                inputer.writeAlleleFrequenciesMerlin(bwAlleleFrequencies, mainSnpMap);
                inputer.writePhaseFilesMACH(bwSNPs, bwHaplos, hapSnpMap, hapIndivGtyMap, integration);
                bwPedFileDescription.close();
                bwGeneticMaps.close();
                bwAlleleFrequencies.close();
                bwHaplos.close();
                bwSNPs.close();

                msg = "Transforming Genotypes on Chromosome " + chrom;
                GlobalVariables.mainView.setBriefRunningInfor(msg);
                GlobalVariables.addInforLog(msg);
                generalLinkPedCharAllele(mainSnpMap, mainIndivGtyMap, chrom, null);
            }
        } else {
            for (int k = 0; k < chroms.size(); k++) {
                String chrom = chroms.get(k);
                chrom = chrom.substring(0, chrom.indexOf(' '));
                chromSet.setChromName(chrom);
                List<String[]> phenotypeClasses = exportSetting.getTraitProper();
                BufferedWriter bwPedFileDescription = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".dat"));
                BufferedWriter bwGeneticMaps = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".map"));
                BufferedWriter bwAlleleFrequencies = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".freq"));
                BufferedWriter bwHaplos = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".haplos"));
                BufferedWriter bwSNPs = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".snps"));
                //write the description file 
                for (int i = 0; i < phenotypeClasses.size(); i++) {
                    //Phentype types:  A - affection status, T - Quantitative Trait and C - Covariate)
                    if (phenotypeClasses.get(i)[1].startsWith("Affection Status")) {
                        bwPedFileDescription.write("A ");
                    } else if (phenotypeClasses.get(i)[1].startsWith("Quantitative Trait")) {
                        bwPedFileDescription.write("T ");
                    } else if (phenotypeClasses.get(i)[1].startsWith("Covariate")) {
                        bwPedFileDescription.write("C ");
                    }
                    bwPedFileDescription.write(phenotypeClasses.get(i)[0]);
                    bwPedFileDescription.write("\n");
                }
                bwGeneticMaps.write("CHROMOSOME  MARKER  POSITION\n");

                chromSet.readAllObjects(integration.getResultPath());

                List<AnnotSNP> mainSnpMap = chromSet.getSnpInfoList();
                Map<String, StatusGtySet> mainIndivGtyMap = chromSet.getIndiviGty();
                msg = "Checking Genotype Quality on Chromosome " + chrom;
                GlobalVariables.mainView.setBriefRunningInfor(msg);
                GlobalVariables.addInforLog(msg);

                preprocessSNPGty(mainSnpMap, mainIndivGtyMap, chrom);
                List<AnnotSNP> hapSnpMap = new ArrayList<AnnotSNP>();
                Map<String, StatusGtySet> hapIndivGtyMap = new HashMap<String, StatusGtySet>();
                splitHapSNPGty(mainSnpMap, mainIndivGtyMap, hapSnpMap, hapIndivGtyMap);
                genotypeQC.removeAllMissing(hapSnpMap, hapIndivGtyMap);
                genotypeQC.correctFrequency(mainSnpMap, mainIndivGtyMap);

                inputer.writePedFileDescriptionMerlin(bwPedFileDescription, mainSnpMap);
                inputer.writeGeneticMapsMerlin(bwGeneticMaps, mainSnpMap);
                inputer.writeAlleleFrequenciesMerlin(bwAlleleFrequencies, mainSnpMap);
                inputer.writePhaseFilesMACH(bwSNPs, bwHaplos, hapSnpMap, hapIndivGtyMap, integration);
                bwPedFileDescription.close();
                bwGeneticMaps.close();
                bwAlleleFrequencies.close();
                bwHaplos.close();
                bwSNPs.close();

                msg = "Transforming Genotypes on Chromosome " + chrom;
                GlobalVariables.mainView.setBriefRunningInfor(msg);
                GlobalVariables.addInforLog(msg);
                generalLinkPedCharAllele(mainSnpMap, mainIndivGtyMap, chrom, null);
            }
        }
        msg = "Generating Pedigree File";
        GlobalVariables.mainView.setBriefRunningInfor(msg);
        GlobalVariables.addInforLog(msg);
        infor = "Files are expored into " + path + "(chromosome#)\n " + prefix + ".#.ped, " + prefix + ".#.dat, " + prefix + ".#.map, "
                + prefix + ".#.freq " + prefix + ".#.snps, " + prefix + ".#.haplos."
                + "\nAn example command to run mach for genotype imputation on chromosome #:\n"
                + "./mach1 -d " + prefix + ".#.dat -p " + prefix + ".#.ped -h " + prefix + ".#.haplos -s " + prefix + ".#.snps "
                + "--rounds 50 --greedy --geno --prefix filename";
        return infor;
    }

    public String exportMerlin2Imputation() throws Exception {
        List<String> chroms = integration.getChromResult();
        ChromSNPGtySet chromSet = new ChromSNPGtySet();
        String infor;
        String path = exportSetting.getExportPath();
        String prefix = exportSetting.getPrefixFileName();

        PedFile hapPed = null;
        if (integration.isHapMapSet()) {
            hapPed = new PedFile();
            hapPed.parseHapMapPed(IGG_RESOURCE_HAPMAP_FOLDER + File.separator + "pedinfor" + File.separator + "hap3Sample.txt");
        }

        File a2NFile = new File(exportSetting.getExportPath() + File.separator + exportSetting.getPrefixFileName() + ".allele2number.txt");
        BufferedWriter bwA2N = null;
        if (exportSetting.isNumberAllele()) {
            bwA2N = new BufferedWriter(new FileWriter(a2NFile));
            bwA2N.write("Chromosome Position SNPID 1Allele 2Allele");
            bwA2N.newLine();
        }

        MerlinFiles inputer = new MerlinFiles();
        String msg;
        Map<String, LongArrayList> selectedRegions = exportSetting.getSelectedRegions();
        if (selectedRegions != null && selectedRegions.size() > 0) {
            for (int k = 0; k < chroms.size(); k++) {
                String chrom = chroms.get(k);
                chrom = chrom.substring(0, chrom.indexOf(' '));
                LongArrayList regions = selectedRegions.get(chrom);
                if (regions == null) {
                    continue;
                }
                chromSet.setChromName(chrom);
                List<String[]> phenotypeClasses = exportSetting.getTraitProper();
                BufferedWriter bwPedFileDescription = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".dat"));
                BufferedWriter bwGeneticMaps = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".map"));
                BufferedWriter bwAlleleFrequencies = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".freq"));

                //write the description file 
                for (int i = 0; i < phenotypeClasses.size(); i++) {
                    //Phentype types:  A - affection status, T - Quantitative Trait and C - Covariate)
                    if (phenotypeClasses.get(i)[1].startsWith("Affection Status")) {
                        bwPedFileDescription.write("A ");
                    } else if (phenotypeClasses.get(i)[1].startsWith("Quantitative Trait")) {
                        bwPedFileDescription.write("T ");
                    } else if (phenotypeClasses.get(i)[1].startsWith("Covariate")) {
                        bwPedFileDescription.write("C ");
                    }
                    bwPedFileDescription.write(phenotypeClasses.get(i)[0]);
                    bwPedFileDescription.write("\n");
                }
                bwGeneticMaps.write("CHROMOSOME  MARKER  POSITION\n");

                chromSet.readAllObjects(integration.getResultPath());

                List<AnnotSNP> mainSnpMap = chromSet.getSnpInfoList();
                Map<String, StatusGtySet> mainIndivGtyMap = chromSet.getIndiviGty();
                filterSNPsbyRegion(mainSnpMap, regions);
                msg = mainSnpMap.size() + " SNPs within the SELECTED region on Chromosome " + chrom;
                msg = msg + "\nChecking Genotype Quality on Chromosome " + chrom;
                GlobalVariables.mainView.setBriefRunningInfor(msg);
                GlobalVariables.addInforLog(msg);

                preprocessSNPGty(mainSnpMap, mainIndivGtyMap, chrom);

                inputer.writePedFileDescriptionMerlin(bwPedFileDescription, mainSnpMap);
                inputer.writeGeneticMapsMerlin(bwGeneticMaps, mainSnpMap);
                inputer.writeAlleleFrequenciesMerlin(bwAlleleFrequencies, mainSnpMap);

                bwPedFileDescription.close();
                bwGeneticMaps.close();
                bwAlleleFrequencies.close();


                msg = "Transforming Genotypes on Chromosome " + chrom;
                GlobalVariables.mainView.setBriefRunningInfor(msg);
                GlobalVariables.addInforLog(msg);
                generalLinkPedNumberAllele(bwA2N, mainSnpMap, mainIndivGtyMap, chrom, hapPed);
            }
        } else {
            for (int k = 0; k < chroms.size(); k++) {
                String chrom = chroms.get(k);
                chrom = chrom.substring(0, chrom.indexOf(' '));
                chromSet.setChromName(chrom);
                List<String[]> phenotypeClasses = exportSetting.getTraitProper();
                BufferedWriter bwPedFileDescription = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".dat"));
                BufferedWriter bwGeneticMaps = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".map"));
                BufferedWriter bwAlleleFrequencies = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".freq"));

                //write the description file 
                for (int i = 0; i < phenotypeClasses.size(); i++) {
                    //Phentype types:  A - affection status, T - Quantitative Trait and C - Covariate)
                    if (phenotypeClasses.get(i)[1].startsWith("Affection Status")) {
                        bwPedFileDescription.write("A ");
                    } else if (phenotypeClasses.get(i)[1].startsWith("Quantitative Trait")) {
                        bwPedFileDescription.write("T ");
                    } else if (phenotypeClasses.get(i)[1].startsWith("Covariate")) {
                        bwPedFileDescription.write("C ");
                    }
                    bwPedFileDescription.write(phenotypeClasses.get(i)[0]);
                    bwPedFileDescription.write("\n");
                }
                bwGeneticMaps.write("CHROMOSOME  MARKER  POSITION\n");

                chromSet.readAllObjects(integration.getResultPath());

                List<AnnotSNP> mainSnpMap = chromSet.getSnpInfoList();
                Map<String, StatusGtySet> mainIndivGtyMap = chromSet.getIndiviGty();
                msg = "Checking Genotype Quality on Chromosome " + chrom;
                GlobalVariables.mainView.setBriefRunningInfor(msg);
                GlobalVariables.addInforLog(msg);

                preprocessSNPGty(mainSnpMap, mainIndivGtyMap, chrom);


                inputer.writePedFileDescriptionMerlin(bwPedFileDescription, mainSnpMap);
                inputer.writeGeneticMapsMerlin(bwGeneticMaps, mainSnpMap);
                inputer.writeAlleleFrequenciesMerlin(bwAlleleFrequencies, mainSnpMap);
                bwPedFileDescription.close();
                bwGeneticMaps.close();
                bwAlleleFrequencies.close();

                msg = "Transforming Genotypes on Chromosome " + chrom;
                GlobalVariables.mainView.setBriefRunningInfor(msg);
                GlobalVariables.addInforLog(msg);
                generalLinkPedNumberAllele(bwA2N, mainSnpMap, mainIndivGtyMap, chrom, hapPed);
            }
        }
        if (exportSetting.isNumberAllele()) {
            msg = "The original allele names and numbered allele names are saved in " + a2NFile.getCanonicalPath();
            GlobalVariables.mainView.setBriefRunningInfor(msg);
            GlobalVariables.addInforLog(msg);
            bwA2N.close();
        }

        msg = "Generating Pedigree File";
        GlobalVariables.mainView.setBriefRunningInfor(msg);
        GlobalVariables.addInforLog(msg);
        infor = "Files are expored into " + path + "(chromosome#)\n " + prefix + ".#.ped, " + prefix + ".#.dat, " + prefix + ".#.map, "
                + prefix + ".#.freq"
                + "\nAn example command to run merlin for genotype imputation on chromosome #:\n"
                + "./merlin -d " + prefix + ".#.dat -p " + prefix + ".#.ped -m " + prefix + ".#.map "
                + "--infer";
        return infor;
    }

    public String exportImpute2Imputation() throws Exception {
        if (integration.isHapMapPhased()) {
            return exportImpute2PhaseImputation();
        } else {
            return exportImpute2UnPhaseImputation();
        }
    }

    private String exportImpute2UnPhaseImputation() throws Exception {
        List<String> chroms = integration.getChromResult();
        ChromSNPGtySet chromSet = new ChromSNPGtySet();
        String infor;

        String path = exportSetting.getExportPath();
        String prefix = exportSetting.getPrefixFileName();

        PedFile hapPed = null;
        if (integration.isHapMapSet()) {
            hapPed = new PedFile();
            hapPed.parseHapMapPed(IGG_RESOURCE_HAPMAP_FOLDER + File.separator + "pedinfor" + File.separator + "hap3Sample.txt");
        }

        ImputeFiles inputer = new ImputeFiles();
        String msg;
        Map<String, LongArrayList> selectedRegions = exportSetting.getSelectedRegions();
        if (selectedRegions != null && selectedRegions.size() > 0) {
            for (int k = 0; k < chroms.size(); k++) {
                String chrom = chroms.get(k);
                chrom = chrom.substring(0, chrom.indexOf(' '));
                LongArrayList regions = selectedRegions.get(chrom);
                if (regions == null) {
                    continue;
                }
                chromSet.setChromName(chrom);

                chromSet.readAllObjects(integration.getResultPath());
                System.gc();
                System.runFinalization();

                List<AnnotSNP> mainSnpMap = chromSet.getSnpInfoList();
                Map<String, StatusGtySet> mainIndivGtyMap = chromSet.getIndiviGty();
                filterSNPsbyRegion(mainSnpMap, regions);
                msg = mainSnpMap.size() + " SNPs within the SELECTED region on Chromosome " + chrom;
                msg = msg + "\nChecking Genotype Quality on Chromosome " + chrom;
                GlobalVariables.mainView.setBriefRunningInfor(msg);
                GlobalVariables.addInforLog(msg);

                preprocessSNPGty(mainSnpMap, mainIndivGtyMap, chrom);
                List<AnnotSNP> hapSnpMap = new ArrayList<AnnotSNP>();
                Map<String, StatusGtySet> hapIndivGtyMap = new HashMap<String, StatusGtySet>();
                splitHapSNPGty(mainSnpMap, mainIndivGtyMap, hapSnpMap, hapIndivGtyMap);
                //It seems the new version of imput2 allows missing
                genotypeQC.removeAllMissing(mainSnpMap, mainIndivGtyMap);
                //genotypeQC.removeAllMissing(hapSnpMap, hapIndivGtyMap);
                genotypeQC.removeAllMissing(hapSnpMap, hapIndivGtyMap);

                System.gc();
                System.runFinalization();

                BufferedWriter bwSampleFile = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".sample"));
                BufferedWriter bwStudyGeno = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".study.gens"));
                BufferedWriter bwStudyStrand = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".study.strand"));
                BufferedWriter bwHapMapGenotypes = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".reference.gens"));
                BufferedWriter bwHapMapStrand = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".reference.strand"));
                BufferedWriter shStrand = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".sh"));

                //write the description file
                List<String[]> phenotypeClasses = exportSetting.getTraitProper();
                inputer.writeSampleFilesIMPUTE(bwSampleFile, phenotypeClasses);
                bwSampleFile.close();
                List<String> indiLabels = GlobalVariables.currentPedFile.getIndividualLabel();
                inputer.writeGenotypeFilesIMPUTE(bwStudyGeno, mainSnpMap, mainIndivGtyMap, indiLabels);
                bwStudyGeno.close();
                inputer.writeStrandFilesIMPUTE(bwStudyStrand, mainSnpMap);
                bwStudyStrand.close();


                List<String> hapIndiLabels = new ArrayList<String>();
                Iterator hapIndiLabelIter = integration.getHapIndivLabels().iterator();
                while (hapIndiLabelIter.hasNext()) {
                    hapIndiLabels.add(hapIndiLabelIter.next().toString());
                }

                inputer.writeGenotypeFilesIMPUTE(bwHapMapGenotypes, hapSnpMap, hapIndivGtyMap, hapIndiLabels);
                bwHapMapGenotypes.close();
                inputer.writeStrandFilesIMPUTE(bwHapMapStrand, hapSnpMap);
                bwHapMapStrand.close();

                msg = "Transforming Genotypes on Chromosome " + chrom;
                GlobalVariables.mainView.setBriefRunningInfor(msg);
                GlobalVariables.addInforLog(msg);
            }
        } else {
            for (int k = 0; k < chroms.size(); k++) {
                String chrom = chroms.get(k);
                chrom = chrom.substring(0, chrom.indexOf(' '));
                chromSet.setChromName(chrom);
                chromSet.readAllObjects(integration.getResultPath());
                List<AnnotSNP> mainSnpMap = chromSet.getSnpInfoList();
                Map<String, StatusGtySet> mainIndivGtyMap = chromSet.getIndiviGty();
                msg = "Checking Genotype Quality on Chromosome " + chrom;
                GlobalVariables.mainView.setBriefRunningInfor(msg);
                GlobalVariables.addInforLog(msg);

                preprocessSNPGty(mainSnpMap, mainIndivGtyMap, chrom);

                List<AnnotSNP> hapSnpMap = new ArrayList<AnnotSNP>();
                Map<String, StatusGtySet> hapIndivGtyMap = new HashMap<String, StatusGtySet>();
                splitHapSNPGty(mainSnpMap, mainIndivGtyMap, hapSnpMap, hapIndivGtyMap);
                //It seems the new version of imput2 allows missing
                genotypeQC.removeAllMissing(mainSnpMap, mainIndivGtyMap);
                //genotypeQC.removeAllMissing(hapSnpMap, hapIndivGtyMap);
                genotypeQC.removeAllMissing(hapSnpMap, hapIndivGtyMap);

                List<String[]> phenotypeClasses = exportSetting.getTraitProper();
                BufferedWriter bwSampleFile = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".sample"));
                BufferedWriter bwStudyGeno = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".study.gens"));
                BufferedWriter bwStudyStrand = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".study.strand"));
                BufferedWriter bwHapMapGenotypes = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".reference.gens"));
                BufferedWriter bwHapMapStrand = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".reference.strand"));
                //write the description file

                inputer.writeSampleFilesIMPUTE(bwSampleFile, phenotypeClasses);
                bwSampleFile.close();
                List<String> indiLabels = GlobalVariables.currentPedFile.getIndividualLabel();
                inputer.writeGenotypeFilesIMPUTE(bwStudyGeno, mainSnpMap, mainIndivGtyMap, indiLabels);

                bwStudyGeno.close();
                inputer.writeStrandFilesIMPUTE(bwStudyStrand, mainSnpMap);
                bwStudyStrand.close();

                List<String> hapIndiLabels = new ArrayList<String>();
                Iterator hapIndiLabelIter = integration.getHapIndivLabels().iterator();
                while (hapIndiLabelIter.hasNext()) {
                    hapIndiLabels.add(hapIndiLabelIter.next().toString());
                }
                inputer.writeGenotypeFilesIMPUTE(bwHapMapGenotypes, hapSnpMap, hapIndivGtyMap, hapIndiLabels);
                bwHapMapGenotypes.close();
                inputer.writeStrandFilesIMPUTE(bwHapMapStrand, hapSnpMap);
                bwHapMapStrand.close();

                msg = "Transforming Genotypes on Chromosome " + chrom;
                GlobalVariables.mainView.setBriefRunningInfor(msg);
                GlobalVariables.addInforLog(msg);
            }
        }
        msg = "Generating Pedigree File";
        GlobalVariables.mainView.setBriefRunningInfor(msg);
        GlobalVariables.addInforLog(msg);
        infor = "Files are expored into " + path + "(chromosome#)\n " + prefix + ".#.sample, " + prefix + ".#.study.gens, " + prefix + ".#.study.strand, "
                + prefix + ".#.reference.gens " + prefix + ".#.reference.strand.\n"
                + "You also need download a map file from HapMap Project, http://hapmap.ncbi.nlm.nih.gov/downloads/recombination/latest/rates/"
                + "\nAn example command to run Impute for genotype imputation on chromosome #:\n"
                + "./impute  -m genetic_map_chr#.txt  -g_ref " + prefix + ".#.reference.gens -s_ref " + prefix + ".#.reference.strand " + "-g " + prefix + ".#.study.gens -s " + prefix + ".#.study.strand "
                + " -Ne 1100  -int postion1  postion2  -buffer 250 -k 10 -iter 10 -burnin 3 -pgs -o test -i filename";

        return infor;
    }

    private String exportImpute2PhaseImputation() throws Exception {
        List<String> chroms = integration.getChromResult();
        ChromSNPGtySet chromSet = new ChromSNPGtySet();
        String infor;

        String path = exportSetting.getExportPath();
        String prefix = exportSetting.getPrefixFileName();

        PedFile hapPed = null;
        if (integration.isHapMapSet()) {
            hapPed = new PedFile();
            hapPed.parseHapMapPed(IGG_RESOURCE_HAPMAP_FOLDER + File.separator + "pedinfor" + File.separator + "hap3Sample.txt");
        }

        ImputeFiles inputer = new ImputeFiles();
        String msg;
        Map<String, LongArrayList> selectedRegions = exportSetting.getSelectedRegions();
        if (selectedRegions != null && selectedRegions.size() > 0) {
            for (int k = 0; k < chroms.size(); k++) {
                String chrom = chroms.get(k);
                chrom = chrom.substring(0, chrom.indexOf(' '));
                LongArrayList regions = selectedRegions.get(chrom);
                if (regions == null) {
                    continue;
                }
                chromSet.setChromName(chrom);

                chromSet.readAllObjects(integration.getResultPath());
                System.gc();
                System.runFinalization();

                List<AnnotSNP> mainSnpMap = chromSet.getSnpInfoList();
                Map<String, StatusGtySet> mainIndivGtyMap = chromSet.getIndiviGty();
                filterSNPsbyRegion(mainSnpMap, regions);
                msg = mainSnpMap.size() + " SNPs within the SELECTED region on Chromosome " + chrom;
                msg = msg + "\nChecking Genotype Quality on Chromosome " + chrom;
                GlobalVariables.mainView.setBriefRunningInfor(msg);
                GlobalVariables.addInforLog(msg);

                preprocessSNPGty(mainSnpMap, mainIndivGtyMap, chrom);
                List<AnnotSNP> hapSnpMap = new ArrayList<AnnotSNP>();
                Map<String, StatusGtySet> hapIndivGtyMap = new HashMap<String, StatusGtySet>();
                splitHapSNPGty(mainSnpMap, mainIndivGtyMap, hapSnpMap, hapIndivGtyMap);
                genotypeQC.removeAllMissing(mainSnpMap, mainIndivGtyMap);
                //genotypeQC.removeOnceMissing(hapSnpMap, hapIndivGtyMap);
                genotypeQC.removeAllMissing(hapSnpMap, hapIndivGtyMap);
                System.gc();
                System.runFinalization();

                BufferedWriter bwSampleFile = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".sample"));
                BufferedWriter bwGeno = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".study.gens"));
                BufferedWriter bwHaplos = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".hapmap.haps"));
                BufferedWriter bwSNPs = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".hapmap.legend"));
                BufferedWriter bwStrand = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".study.strand"));
                BufferedWriter shStrand = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".sh"));

                //write the description file 
                List<String[]> phenotypeClasses = exportSetting.getTraitProper();
                inputer.writeSampleFilesIMPUTE(bwSampleFile, phenotypeClasses);
                bwSampleFile.close();
                List<String> indiLabels = GlobalVariables.currentPedFile.getIndividualLabel();
                inputer.writeGenotypeFilesIMPUTE(bwGeno, mainSnpMap, mainIndivGtyMap, indiLabels);
                bwGeno.close();
                String shInfo = inputer.writeLegendHaploFilesIMPUTE(bwSNPs, bwHaplos, hapSnpMap, hapIndivGtyMap, integration, chrom, prefix);
                shStrand.write(shInfo);
                bwHaplos.close();
                bwSNPs.close();
                inputer.writeStrandFilesIMPUTE(bwStrand, mainSnpMap);
                bwStrand.close();
                shStrand.close();
                msg = "Transforming Genotypes on Chromosome " + chrom;
                GlobalVariables.mainView.setBriefRunningInfor(msg);
                GlobalVariables.addInforLog(msg);
            }
        } else {
            for (int k = 0; k < chroms.size(); k++) {
                String chrom = chroms.get(k);
                chrom = chrom.substring(0, chrom.indexOf(' '));
                chromSet.setChromName(chrom);
                chromSet.readAllObjects(integration.getResultPath());
                List<AnnotSNP> mainSnpMap = chromSet.getSnpInfoList();
                Map<String, StatusGtySet> mainIndivGtyMap = chromSet.getIndiviGty();
                msg = "Checking Genotype Quality on Chromosome " + chrom;
                GlobalVariables.mainView.setBriefRunningInfor(msg);
                GlobalVariables.addInforLog(msg);

                preprocessSNPGty(mainSnpMap, mainIndivGtyMap, chrom);

                List<AnnotSNP> hapSnpMap = new ArrayList<AnnotSNP>();
                Map<String, StatusGtySet> hapIndivGtyMap = new HashMap<String, StatusGtySet>();
                splitHapSNPGty(mainSnpMap, mainIndivGtyMap, hapSnpMap, hapIndivGtyMap);

                genotypeQC.removeAllMissing(mainSnpMap, mainIndivGtyMap);
                //genotypeQC.removeOnceMissing(hapSnpMap, hapIndivGtyMap);
                genotypeQC.removeAllMissing(hapSnpMap, hapIndivGtyMap);

                List<String[]> phenotypeClasses = exportSetting.getTraitProper();
                BufferedWriter bwSampleFile = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".sample"));
                BufferedWriter bwGeno = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".study.gens"));
                BufferedWriter bwHaplos = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".hapmap.haps"));
                BufferedWriter bwSNPs = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".hapmap.legend"));
                BufferedWriter bwStrand = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".study.strand"));
                BufferedWriter shStrand = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".sh"));
                //write the description file 
                String shInfo = inputer.writeLegendHaploFilesIMPUTE(bwSNPs, bwHaplos, hapSnpMap, hapIndivGtyMap, integration, chrom, prefix);
                shStrand.write(shInfo);
                bwHaplos.close();
                hapSnpMap = null;
                hapIndivGtyMap = null;
                List<String> indiLabels = GlobalVariables.currentPedFile.getIndividualLabel();
                inputer.writeGenotypeFilesIMPUTE(bwGeno, mainSnpMap, mainIndivGtyMap, indiLabels);
                bwGeno.close();
                mainIndivGtyMap = null;

                inputer.writeSampleFilesIMPUTE(bwSampleFile, phenotypeClasses);
                bwSampleFile.close();

                bwSNPs.close();
                inputer.writeStrandFilesIMPUTE(bwStrand, mainSnpMap);
                bwStrand.close();
                shStrand.close();
                msg = "Transforming Genotypes on Chromosome " + chrom;
                GlobalVariables.mainView.setBriefRunningInfor(msg);
                GlobalVariables.addInforLog(msg);
            }
        }
        msg = "Generating Pedigree File";
        GlobalVariables.mainView.setBriefRunningInfor(msg);
        GlobalVariables.addInforLog(msg);
        infor = "Files are expored into " + path + "(chromosome#)\n " + prefix + ".#.sample, " + prefix + ".#.study.gens, " + prefix + ".#.hapmap.haps, "
                + prefix + ".#.hapmap.legend " + prefix + ".#.strand.\n"
                + "You also need download a map file from HapMap Project,http://hapmap.ncbi.nlm.nih.gov/downloads/recombination/latest/rates/"
                + "\nAn example command to run Impute for genotype imputation on chromosome #:\n"
                + "./impute -h " + prefix + ".#.hapmap.haps -l " + prefix + ".#.hapmap.legend -m genetic_map_chr#.txt -g " + prefix + ".#.study.gens -strand_g "
                + prefix + ".#.strand "
                + " -Ne 1100  -int postion1  postion2  -pgs -o test -i filename\n"
                + "In addition, a set of sh files have been generated to separate a chromosome into consecutive regions in 5 MB length (which ensure a high quality imputation by IMPUTE v2. "
                + "\nYou can simply run a sh file by the command: nohup " + prefix + ".#.sh &";

        return infor;
    }

    public String exportBEAGLE2Imputation() throws Exception {
        List<String> chroms = integration.getChromResult();
        ChromSNPGtySet chromSet = new ChromSNPGtySet();
        String infor;
        String path = exportSetting.getExportPath();
        String prefix = exportSetting.getPrefixFileName();

        PedFile hapPed = null;
        if (integration.isHapMapSet()) {
            hapPed = new PedFile();
            hapPed.parseHapMapPed(IGG_RESOURCE_HAPMAP_FOLDER + File.separator + "pedinfor" + File.separator + "hap3Sample.txt");
        }

        BeagleFiles inputer = new BeagleFiles();
        String msg;
        Map<String, LongArrayList> selectedRegions = exportSetting.getSelectedRegions();
        if (selectedRegions != null && selectedRegions.size() > 0) {
            for (int k = 0; k < chroms.size(); k++) {
                String chrom = chroms.get(k);
                chrom = chrom.substring(0, chrom.indexOf(' '));
                LongArrayList regions = selectedRegions.get(chrom);
                if (regions == null) {
                    continue;
                }
                chromSet.setChromName(chrom);
                List<String[]> phenotypeClasses = exportSetting.getTraitProper();
                BufferedWriter bwPrj = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".prj.bgl"));
                BufferedWriter bwHap = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".hap.phased"));
                BufferedWriter bwSNPs = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".markers"));
                //write the description file 

                chromSet.readAllObjects(integration.getResultPath());

                List<AnnotSNP> mainSnpMap = chromSet.getSnpInfoList();
                Map<String, StatusGtySet> mainIndivGtyMap = chromSet.getIndiviGty();
                filterSNPsbyRegion(mainSnpMap, regions);
                msg = mainSnpMap.size() + " SNPs within the SELECTED region on Chromosome " + chrom;
                msg = msg + "\nChecking Genotype Quality on Chromosome " + chrom;
                GlobalVariables.mainView.setBriefRunningInfor(msg);
                GlobalVariables.addInforLog(msg);

                preprocessSNPGty(mainSnpMap, mainIndivGtyMap, chrom);

                inputer.writeBeagleFile(bwPrj, bwHap, mainSnpMap, mainIndivGtyMap, hapPed, phenotypeClasses);
                inputer.writeMarkerFile(bwSNPs, mainSnpMap);
                bwPrj.close();
                bwHap.close();
                bwSNPs.close();
                msg = "Transforming Genotypes on Chromosome " + chrom;
                GlobalVariables.mainView.setBriefRunningInfor(msg);
                GlobalVariables.addInforLog(msg);
            }
        } else {
            for (int k = 0; k < chroms.size(); k++) {
                String chrom = chroms.get(k);
                chrom = chrom.substring(0, chrom.indexOf(' '));
                chromSet.setChromName(chrom);
                List<String[]> phenotypeClasses = exportSetting.getTraitProper();
                BufferedWriter bwPrj = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".prj.bgl"));
                BufferedWriter bwHap = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".hap.phased"));
                BufferedWriter bwSNPs = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".markers"));
                //write the description file 

                chromSet.readAllObjects(integration.getResultPath());

                List<AnnotSNP> mainSnpMap = chromSet.getSnpInfoList();
                Map<String, StatusGtySet> mainIndivGtyMap = chromSet.getIndiviGty();
                msg = "Checking Genotype Quality on Chromosome " + chrom;
                GlobalVariables.mainView.setBriefRunningInfor(msg);
                GlobalVariables.addInforLog(msg);

                preprocessSNPGty(mainSnpMap, mainIndivGtyMap, chrom);

                inputer.writeBeagleFile(bwPrj, bwHap, mainSnpMap, mainIndivGtyMap, hapPed, phenotypeClasses);
                inputer.writeMarkerFile(bwSNPs, mainSnpMap);
                bwPrj.close();
                bwHap.close();
                bwSNPs.close();
                msg = "Transforming Genotypes on Chromosome " + chrom;
                GlobalVariables.mainView.setBriefRunningInfor(msg);
                GlobalVariables.addInforLog(msg);
            }
        }
        msg = "Generating Pedigree File";
        GlobalVariables.mainView.setBriefRunningInfor(msg);
        GlobalVariables.addInforLog(msg);
        infor = "Files are expored into " + path + "(chromosome#)\n " + prefix + ".#.prj.bgl, " + prefix + ".#.hap.phased, " + prefix + ".#.markers, "
                + "An example command to  run beagle for for genotype imputation on chromosome #:\n"
                + "java -Xmx100m -jar beagle.jar unphased=" + prefix + ".#.prj.bgl phased=" + prefix + ".1.hap.phased markers="
                + prefix + ".#.markers missing=? log=log out=output";

        return infor;
    }

    public String exportPHASE2Imputation() throws Exception {
        List<String> chroms = integration.getChromResult();
        ChromSNPGtySet chromSet = new ChromSNPGtySet();
        String infor;
        String path = exportSetting.getExportPath();
        String prefix = exportSetting.getPrefixFileName();

        PedFile hapPed = null;
        if (integration.isHapMapSet()) {
            hapPed = new PedFile();
            hapPed.parseHapMapPed(IGG_RESOURCE_HAPMAP_FOLDER + File.separator + "pedinfor" + File.separator + "hap3Sample.txt");
        }

        PhaseFiles inputer = new PhaseFiles();
        String msg;
        Map<String, LongArrayList> selectedRegions = exportSetting.getSelectedRegions();
        if (selectedRegions != null && selectedRegions.size() > 0) {
            for (int k = 0; k < chroms.size(); k++) {
                String chrom = chroms.get(k);
                chrom = chrom.substring(0, chrom.indexOf(' '));
                LongArrayList regions = selectedRegions.get(chrom);
                if (regions == null) {
                    continue;
                }
                chromSet.setChromName(chrom);
                List<String[]> phenotypeClasses = exportSetting.getTraitProper();
                BufferedWriter prjBw = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".inp"));
                BufferedWriter hapBw = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".phasedhap"));
                //read the description file 
                chromSet.readAllObjects(integration.getResultPath());

                List<AnnotSNP> mainSnpMap = chromSet.getSnpInfoList();
                Map<String, StatusGtySet> mainIndivGtyMap = chromSet.getIndiviGty();
                filterSNPsbyRegion(mainSnpMap, regions);
                msg = mainSnpMap.size() + " SNPs within the SELECTED region on Chromosome " + chrom;
                msg = msg + "\nChecking Genotype Quality on Chromosome " + chrom;
                GlobalVariables.mainView.setBriefRunningInfor(msg);
                GlobalVariables.addInforLog(msg);
                preprocessSNPGty(mainSnpMap, mainIndivGtyMap, chrom);

                inputer.writeInputFilePhase(prjBw, hapBw, mainSnpMap, mainIndivGtyMap, hapPed, phenotypeClasses, integration);
                prjBw.close();
                hapBw.close();
                msg = "Transforming Genotypes on Chromosome " + chrom;
                GlobalVariables.mainView.setBriefRunningInfor(msg);
                GlobalVariables.addInforLog(msg);
            }
        } else {
            for (int k = 0; k < chroms.size(); k++) {
                String chrom = chroms.get(k);
                chrom = chrom.substring(0, chrom.indexOf(' '));
                chromSet.setChromName(chrom);
                List<String[]> phenotypeClasses = exportSetting.getTraitProper();
                BufferedWriter prjBw = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".inp"));
                BufferedWriter hapBw = new BufferedWriter(new FileWriter(path + prefix + "." + chrom + ".phasedhap"));
                //write the description file 
                chromSet.readAllObjects(integration.getResultPath());

                List<AnnotSNP> mainSnpMap = chromSet.getSnpInfoList();
                Map<String, StatusGtySet> mainIndivGtyMap = chromSet.getIndiviGty();
                msg = "Checking Genotype Quality on Chromosome " + chrom;
                GlobalVariables.mainView.setBriefRunningInfor(msg);
                GlobalVariables.addInforLog(msg);
                preprocessSNPGty(mainSnpMap, mainIndivGtyMap, chrom);
                /*
                Map<Long, AnnotSNP> hapSnpMap = new HashMap<Long, AnnotSNP>();
                Map<String, StatusGtySet> hapIndivGtyMap = new HashMap<String, StatusGtySet>();
                splitHapSNPGty(mainSnpMap, mainIndivGtyMap, hapSnpMap, hapIndivGtyMap);
                 */

                inputer.writeInputFilePhase(prjBw, hapBw, mainSnpMap, mainIndivGtyMap, hapPed, phenotypeClasses, integration);
                prjBw.close();
                hapBw.close();
                msg = "Transforming Genotypes on Chromosome " + chrom;
                GlobalVariables.mainView.setBriefRunningInfor(msg);
                GlobalVariables.addInforLog(msg);
            }
        }
        msg = "Generating Pedigree File";
        GlobalVariables.mainView.setBriefRunningInfor(msg);
        GlobalVariables.addInforLog(msg);
        infor = "Files are expored into " + path + "(chromosome#)\n " + prefix + ".#.inp " + prefix + ".#.phasedhap."
                + "\nAn example command to  run fastPHASE for for genotype imputation on chromosome #:\n"
                + "fastPHASE -K20 -T20 -C25 -H-4 -Z -ooutput -b" + prefix + ".#.phasedhap " + prefix + ".#.inp";

        return infor;
    }

    private void splitHapSNPGty(List<AnnotSNP> mainSnpMap, Map<String, StatusGtySet> mainIndivGtyMap,
            List<AnnotSNP> hapSnpMap, Map<String, StatusGtySet> hapIndivGtyMap) throws Exception {
        String indivLable;
        Iterator hapIndiLabelIter = integration.getHapIndivLabels().iterator();
        while (hapIndiLabelIter.hasNext()) {
            indivLable = hapIndiLabelIter.next().toString();
            StatusGtySet indivGty = mainIndivGtyMap.get(indivLable);
            if (indivGty != null) {
                hapIndivGtyMap.put(indivLable, mainIndivGtyMap.remove(indivLable));
            }
        }
        hapSnpMap.addAll(mainSnpMap);
    }
}
