// (c) 2008-2009 Miaoxin Li
// This file is distributed as part of the IGG source code package
// and may not be redistributed in any form, without prior written
// permission from the author. Permission is granted for you to
// modify this file for your own personal use, but modified versions
// must retain this copyright notice and must not be distributed.
// Permission is granted for you to use this file to compile IGG.
// All computer programs have bugs. Use this file at your own risk.
// Saturday, January 17, 2009
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.cobi.igg3.controller;

import java.io.File;
import java.util.List;
import org.cobi.igg3.Constants;

/**
 *
 * @author Miaoxin Li
 */
public class ResourceManager implements Constants {

    public ResourceManager() {
    }

    public String checkUnavailableChipAnnotFiles(List<String> chipTypes) throws Exception {
        StringBuilder notExistFiles = new StringBuilder();
        for (int i = 0; i < chipTypes.size(); i++) {
            String annotaionFileName = chipTypes.get(i);
            File annotationFile = new File(IGG_RESOURCE_CHIP_FOLDER + annotaionFileName + ".txt");
            if (!annotationFile.exists()) {
                notExistFiles.append(annotaionFileName);
                notExistFiles.append('\n');
            }
        }
        return notExistFiles.toString();
    }

    public String checkUnavailableChipAnnotFile(String chipType) throws Exception {
        StringBuilder notExistFiles = new StringBuilder();

        String annotaionFileName = chipType;
        File annotationFile = new File(IGG_RESOURCE_CHIP_FOLDER + annotaionFileName + ".txt");
        if (!annotationFile.exists()) {
            notExistFiles.append(annotaionFileName);
            notExistFiles.append('\n');
        }
        return notExistFiles.toString();
    }

    public String checkUnavailableHapAnnotFiles(List<String> chroms, String hapV) throws Exception {
        StringBuilder notExistFiles = new StringBuilder();
        for (int i = 0; i < chroms.size(); i++) {
            String chrom = chroms.get(i);
            File anaFile = new File("resources/hapmap/" + hapV + File.separator + chrom);
            if (!anaFile.exists()) {
                notExistFiles.append(chrom);
                notExistFiles.append('\n');
            }
        }
        return notExistFiles.toString();
    }

    public String checkUnavailableHapAnnotFiles(List<String> chroms) throws Exception {
        StringBuilder notExistFiles = new StringBuilder();
        for (int i = 0; i < chroms.size(); i++) {
            String chrom = chroms.get(i);
            if (chrom.equals("XY")) {
                continue;
            }
            File anaFile = new File("resources/hapmap/" + chrom);
            if (!anaFile.exists()) {
                notExistFiles.append(chrom);
                notExistFiles.append('\n');
            }
        }
        return notExistFiles.toString();
    }
}
