/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.cobi.igg3.entity;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.HashMap;
import java.util.Map;
import java.util.StringTokenizer;
import java.util.TreeSet;

/**
 *
 * @author Miaoxin Li
 */
public class MergedRsIDSet {
    //a set to store megered RS id from ftp://ftp.ncbi.nlm.nih.gov/snp/organisms/human_9606/database/organism_data/RsMergeArch.bcp.gz

    public Map<String, TreeSet<String>> rsMergeMap = new HashMap<String, TreeSet<String>>();

    public void readRSIDfromTable(String flatPathRead, TreeSet<String> snpList) throws Exception {
        BufferedReader br = null;
        String line;

        String strOldID;
        String strNewID;
        StringTokenizer tokenizer;
        br = new BufferedReader(new FileReader(flatPathRead), 1024 * 1024 * 10);
        while ((line = br.readLine()) != null) {
            tokenizer = new StringTokenizer(line);
            strOldID = "rs" + tokenizer.nextToken().trim();
            strNewID = "rs" + tokenizer.nextToken().trim();
            TreeSet<String> oldIDList = rsMergeMap.remove(strOldID);
            if (snpList.contains(strOldID) || oldIDList != null) {
                //System.out.println(strOldID);
                if (oldIDList == null) {
                    oldIDList = rsMergeMap.get(strNewID);
                    if (oldIDList == null) {
                        oldIDList = new TreeSet<String>();
                        oldIDList.add(strOldID);
                        rsMergeMap.put(strNewID, oldIDList);
                    } else {
                        oldIDList.add(strOldID);
                    }
                } else {
                    System.out.println("Over Merged: ");
                    oldIDList.add(strOldID);
                    rsMergeMap.put(strNewID, oldIDList);
                }
            }

        }
        System.out.println("There are " + rsMergeMap.size() + " SNP RSIDs");
    }

    public void saveRsMergeMapAndClean(String savePath) throws Exception {
        FileOutputStream objFOut = new FileOutputStream(savePath);
        BufferedOutputStream objOBfs = new BufferedOutputStream(objFOut);
        ObjectOutputStream localObjOut = new ObjectOutputStream(objOBfs);

        localObjOut.writeObject(rsMergeMap);

        localObjOut.flush();
        localObjOut.close();
        objOBfs.flush();
        objOBfs.close();
        objFOut.close();
        rsMergeMap.clear();
    }

    public void readRsMergeMap(String readPath) throws Exception {
        File file = new File(readPath);
        if (!file.exists()) {
            return;
        }
        FileInputStream objFIn = new FileInputStream(readPath);
        BufferedInputStream objIBfs = new BufferedInputStream(objFIn);
        ObjectInputStream localObjIn = new ObjectInputStream(objIBfs);
        this.rsMergeMap = (Map<String, TreeSet<String>>) localObjIn.readObject();

        localObjIn.close();
        objIBfs.close();
        objFIn.close();
    }
}
