/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.cobi.igg3.genetformator;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.HashMap;
import java.util.Map;
import java.util.StringTokenizer;

/**
 *
 * @author Miaoxin Li
 */
public class MergeImputeDatasets {

    private void compareGenotypeFiles(String gtyFile1, String gtyFile2, String outputFile) throws
            Exception {
        Map<String, StringBuffer> gtyLine = new HashMap<String, StringBuffer>();
        String line1 = null;
        String rsID = null;
        StringTokenizer tokenizer;
        BufferedReader br1 = new BufferedReader(new FileReader(gtyFile1));
        StringBuffer tmpBuffer = new StringBuffer();
        while ((line1 = br1.readLine()) != null) {
            tokenizer = new StringTokenizer(line1);
            //skip first column
            tokenizer.nextToken();
            tmpBuffer.delete(0, tmpBuffer.length());
            tmpBuffer.append(tokenizer.nextToken().trim());
            rsID = tmpBuffer.toString();
            //skip three more column
            tokenizer.nextToken();
            tokenizer.nextToken();
            tokenizer.nextToken();
            StringBuffer gtys = new StringBuffer();
            while (tokenizer.hasMoreTokens()) {
                gtys.append(tokenizer.nextToken().trim());
            }
            gtyLine.put(rsID, gtys);
        }
        br1.close();

        int i = 0;
        String gtyString1 = null;
        String gtyString2 = null;
        String infor = null;
        //start to compare
        BufferedReader br2 = new BufferedReader(new FileReader(gtyFile2));
        BufferedWriter bw = new BufferedWriter(new FileWriter(outputFile));
        while ((line1 = br2.readLine()) != null) {
            tokenizer = new StringTokenizer(line1);
            //skip first column
            tokenizer.nextToken();
            tmpBuffer.delete(0, tmpBuffer.length());
            tmpBuffer.append(tokenizer.nextToken().trim());
            rsID = tmpBuffer.toString();
            StringBuffer gtys = gtyLine.get(rsID);
            if (gtys == null) {
                continue;
            }
            //skip three more column
            tokenizer.nextToken();
            tokenizer.nextToken();
            tokenizer.nextToken();

            i = 0;
            while (tokenizer.hasMoreTokens()) {
                gtyString1 = gtys.substring(i, i + 1);
                tmpBuffer.delete(0, tmpBuffer.length());
                tmpBuffer.append(tokenizer.nextToken().trim());
                gtyString2 = tmpBuffer.toString();
                if (!gtyString1.equals(gtyString2)) {
                    infor = "Line " + rsID + " Genotype " + gtyString1 + " != " + gtyString2 + " at individual " + (i + 1);
                    System.out.println(infor);
                    bw.write(infor);
                }
                i++;
            }
            gtyLine.put(rsID, gtys);
        }
        br2.close();
        bw.close();
    }

    public static void main(String[] args) {
        MergeImputeDatasets main = new MergeImputeDatasets();

        String folder = "C:/Documents and Settings/Miaoxin Li/桌面/bin19/";
        String pedFile1 = folder + "test.6.geno";
        String pedFile2 = folder + "testout";

        String outPath = folder + "re.txt";
        try {
            main.compareGenotypeFiles(pedFile1, pedFile2, outPath);
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }
}
