// (c) 2008-2009 Miaoxin Li
// This file is distributed as part of the IGG source code package
// and may not be redistributed in any form, without prior written
// permission from the author. Permission is granted for you to
// modify this file for your own personal use, but modified versions
// must retain this copyright notice and must not be distributed.
// Permission is granted for you to use this file to compile IGG.
// All computer programs have bugs. Use this file at your own risk.
// Saturday, January 17, 2009
/*
 * CreateProjectJDialog.java
 */
package org.cobi.igg3.gui;

import java.io.File;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import org.cobi.igg3.entity.Project;
import org.cobi.igg3.GlobalVariables;
import org.cobi.igg3.entity.PedFile;
import org.jdesktop.application.Action;

/**
 *
 * @author  mxli
 */
public class CreateProjectJDialog extends javax.swing.JDialog {

    private ArrayList<String[]> listTableData = null;
    private ArrayListStringArrayTableModel listTableModel = null;
    private List<String> phenotypeNames;
    String[] columnTitles = {"Pedigree_ID", "Individual_ID", "Father_ID", "Mother_ID", "Gender"};

    /** Creates new form CreateProjectJDialog */
    public CreateProjectJDialog(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
    }

    public CreateProjectJDialog(java.awt.Frame parent) {
        super(parent);
        listTableData = new ArrayList<String[]>();
        String[] tableTitles = new String[columnTitles.length];
        for (int i = 0; i < tableTitles.length; i++) {
            tableTitles[i] = "Column " + (i + 1);
        }
        listTableData.add(columnTitles);
        listTableModel = new ArrayListStringArrayTableModel();
        listTableModel.setTitle(tableTitles);
        listTableModel.setDataList(listTableData);
        initComponents();
        setIconImage(GUIUtil.readImageIcon("igg.png").getImage());
        listTableModel.fireTableDataChanged();
        phenotypeNames = new ArrayList<String>();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        projectNameTextField = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        projectTextField = new javax.swing.JTextField();
        jButton4 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();
        jLabel3 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();
        jButton5 = new javax.swing.JButton();
        jButton6 = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(org.cobi.igg3.gui.IGG3App.class).getContext().getResourceMap(CreateProjectJDialog.class);
        setTitle(resourceMap.getString("Form.title")); // NOI18N
        setName("Form"); // NOI18N
        setResizable(false);

        jPanel1.setName("jPanel1"); // NOI18N

        jLabel1.setText(resourceMap.getString("jLabel1.text")); // NOI18N
        jLabel1.setName("jLabel1"); // NOI18N

        projectNameTextField.setText(resourceMap.getString("projectNameTextField.text")); // NOI18N
        projectNameTextField.setName("projectNameTextField"); // NOI18N

        jLabel4.setText(resourceMap.getString("jLabel4.text")); // NOI18N
        jLabel4.setName("jLabel4"); // NOI18N

        projectTextField.setName("projectTextField"); // NOI18N

        javax.swing.ActionMap actionMap = org.jdesktop.application.Application.getInstance(org.cobi.igg3.gui.IGG3App.class).getContext().getActionMap(CreateProjectJDialog.class, this);
        jButton4.setAction(actionMap.get("choosePath")); // NOI18N
        jButton4.setName("jButton4"); // NOI18N

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel1, javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jLabel4, javax.swing.GroupLayout.Alignment.TRAILING))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(projectTextField, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 313, Short.MAX_VALUE)
                    .addComponent(projectNameTextField, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, 216, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(6, 6, 6)
                .addComponent(jButton4, javax.swing.GroupLayout.PREFERRED_SIZE, 29, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(projectNameTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.CENTER)
                    .addComponent(jLabel4)
                    .addComponent(jButton4)
                    .addComponent(projectTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(100, 100, 100))
        );

        jButton2.setAction(actionMap.get("createProject")); // NOI18N
        jButton2.setName("jButton2"); // NOI18N

        jButton3.setAction(actionMap.get("cancel")); // NOI18N
        jButton3.setName("jButton3"); // NOI18N

        jLabel3.setIcon(resourceMap.getIcon("jLabel3.icon")); // NOI18N
        jLabel3.setName("jLabel3"); // NOI18N

        jScrollPane1.setBorder(javax.swing.BorderFactory.createTitledBorder(resourceMap.getString("jScrollPane1.border.title"))); // NOI18N
        jScrollPane1.setName("jScrollPane1"); // NOI18N

        jTable1.setModel(listTableModel);
        jTable1.setName("jTable1"); // NOI18N
        jScrollPane1.setViewportView(jTable1);

        jButton5.setAction(actionMap.get("addOnePhenotype")); // NOI18N
        jButton5.setToolTipText(resourceMap.getString("jButton5.toolTipText")); // NOI18N
        jButton5.setName("jButton5"); // NOI18N

        jButton6.setAction(actionMap.get("removeOnePhenotype")); // NOI18N
        jButton6.setName("jButton6"); // NOI18N

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addGap(16, 16, 16)
                .addComponent(jLabel3, javax.swing.GroupLayout.PREFERRED_SIZE, 70, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(108, 108, 108))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addGap(134, 134, 134)
                .addComponent(jButton2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 232, Short.MAX_VALUE)
                .addComponent(jButton3)
                .addGap(142, 142, 142))
            .addGroup(layout.createSequentialGroup()
                .addGap(6, 6, 6)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 579, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jButton5, javax.swing.GroupLayout.PREFERRED_SIZE, 29, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton6, javax.swing.GroupLayout.PREFERRED_SIZE, 28, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jButton5, javax.swing.GroupLayout.PREFERRED_SIZE, 26, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jButton6, javax.swing.GroupLayout.PREFERRED_SIZE, 26, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, 60, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel3, javax.swing.GroupLayout.PREFERRED_SIZE, 56, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(8, 8, 8)
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 68, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton3)
                    .addComponent(jButton2))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                CreateProjectJDialog dialog = new CreateProjectJDialog(new javax.swing.JFrame(), true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {

                    @Override
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }

    @Action
    public void choosePath() {
        JFileChooser fDialog = new MyJFileChooser();
        fDialog.setDialogTitle("Choose Project Path");
        fDialog.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        int result = fDialog.showOpenDialog(this);
        if (result == JFileChooser.APPROVE_OPTION) {
            GlobalVariables.lastAccessedPath = fDialog.getSelectedFile().getPath() + File.separator;
            try {
                projectTextField.setText(GlobalVariables.lastAccessedPath);
            } catch (Exception ex) {
                JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), ex.toString(), "Error", JOptionPane.ERROR_MESSAGE);
            }
            if (projectNameTextField.getText().length() > 0) {
                File newFile = new File(projectTextField.getText() + File.separator + projectNameTextField.getText() + ".xml");
                if (newFile.exists()) {
                    JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), "Available project \"" + projectNameTextField.getText() + "\" in this folder!", "Error", JOptionPane.ERROR_MESSAGE);
                }
            }
        }
    }

    @Action
    public void createProject() {
        String name = projectNameTextField.getText().trim();
        String path = projectTextField.getText().trim();

        if (phenotypeNames.isEmpty()) {
            int anwser = JOptionPane.showConfirmDialog(GlobalVariables.currentApplication.getMainFrame(), "You have not yet define any phenotypes! Create a project without any phenotypes?", "Warning", JOptionPane.OK_CANCEL_OPTION);
            if (anwser == 1) {
                return;
            }
        }
        if (name.length() == 0) {
            JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), "No Project Name", "Error", JOptionPane.ERROR_MESSAGE);
            return;
        }

        if (path.length() == 0) {
            JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), "No Project Path", "Error", JOptionPane.ERROR_MESSAGE);
            return;
        }
        File newFile = new File(path + name + ".xml");
        if (newFile.exists()) {
            JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), "Available project \"" + name + "\" in this folder!", "Error", JOptionPane.ERROR_MESSAGE);
            return;
        }
        setVisible(false);
        Project newProject = new Project(name, new Date(), path);
        try {
            GlobalVariables.setCurrentProject(newProject);
            String[] phenotypes = listTableData.get(0);
            phenotypeNames.clear();
            for (int i = 5; i < phenotypes.length; i++) {
                phenotypeNames.add(phenotypes[i]);
            }
            newProject.setPhenotypeNames(phenotypeNames);
            PedFile pedFile = new PedFile();
            pedFile.setTraitNames(phenotypeNames);
            GlobalVariables.currentPedFile = pedFile;

            if (GlobalVariables.mainView.addProject2Tree(newProject)) {
                JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), "Project \"" + name + "\" Created", "Message", JOptionPane.INFORMATION_MESSAGE);
                GlobalVariables.latestAccessedProjects.add(path + name);
            } else {
                JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), "Available Project Name", "Error", JOptionPane.ERROR_MESSAGE);
                setVisible(true);
            }
        } catch (Exception ex) {
            JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), ex.toString(), "Error", JOptionPane.ERROR_MESSAGE);
        }
    }

    @Action
    public void cancel() {
        setVisible(false);
    }

    @Action
    public void addOnePhenotype() {
        String phenotypeName = JOptionPane.showInputDialog("Please give a name for the phenotype to be added!");
        phenotypeNames.add(phenotypeName);
        listTableData.clear();
        String[] newColumnTitles = new String[columnTitles.length + phenotypeNames.size()];
        String[] tableTitles = new String[newColumnTitles.length];
        for (int i = 0; i < tableTitles.length; i++) {
            tableTitles[i] = "Column " + (i + 1);
        }
        for (int i = 0; i < columnTitles.length; i++) {
            newColumnTitles[i] = columnTitles[i];
        }
        for (int i = 0; i < phenotypeNames.size(); i++) {
            newColumnTitles[i + columnTitles.length] = phenotypeNames.get(i);
        }
        listTableData.add(newColumnTitles);
        listTableModel.setTitle(tableTitles);
        listTableModel.fireTableStructureChanged();
    }

    @Action
    public void removeOnePhenotype() {
        if (phenotypeNames.isEmpty()) {
            JOptionPane.showMessageDialog(this, "No specified phenotypes to be deleted", "Error", JOptionPane.ERROR_MESSAGE);
        }
        phenotypeNames.remove(phenotypeNames.size() - 1);
        listTableData.clear();
        String[] newColumnTitles = new String[columnTitles.length + phenotypeNames.size()];
        String[] tableTitles = new String[newColumnTitles.length];
        for (int i = 0; i < tableTitles.length; i++) {
            tableTitles[i] = "Column " + (i + 1);
        }
        System.arraycopy(columnTitles, 0, newColumnTitles, 0, columnTitles.length);
        
        for (int i = 0; i < phenotypeNames.size(); i++) {
            newColumnTitles[i + columnTitles.length] = phenotypeNames.get(i);
        }
        listTableData.add(newColumnTitles);
        listTableModel.setTitle(tableTitles);
        listTableModel.fireTableStructureChanged();
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton4;
    private javax.swing.JButton jButton5;
    private javax.swing.JButton jButton6;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable jTable1;
    private javax.swing.JTextField projectNameTextField;
    private javax.swing.JTextField projectTextField;
    // End of variables declaration//GEN-END:variables
}
