// (c) 2008-2009 Miaoxin Li
// This file is distributed as part of the IGG source code package
// and may not be redistributed in any form, without prior written
// permission from the author. Permission is granted for you to
// modify this file for your own personal use, but modified versions
// must retain this copyright notice and must not be distributed.

// Permission is granted for you to use this file to compile IGG.

// All computer programs have bugs. Use this file at your own risk.
// Saturday, January 17, 2009
/*
 * DownloadChipAnnotationDialog.java
 *
 * Created on 2008�?2�?1�? 下午12:48
 */
package org.cobi.igg3.gui;

import java.io.File;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import javax.swing.JOptionPane;
import javax.swing.SwingWorker;
import javax.swing.table.TableColumn;
import org.apache.http.client.HttpClient;
import org.apache.http.conn.ClientConnectionManager;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.impl.conn.tsccm.ThreadSafeClientConnManager;
import org.cobi.igg3.Constants;
import org.cobi.igg3.GlobalVariables;
import org.cobi.util.download.HttpClient4API;

import org.cobi.util.download.HttpClient4DownloadTaskProgressBar;
import org.cobi.util.download.HttpClient4TaskBeanProgressBar;
import org.cobi.util.thread.TaskQueue;
import org.cobi.util.thread.ThreadPool;
import org.jdesktop.application.Action;
import org.jdesktop.application.Task;

/**
 *
 * @author  mxli
 */
public class DownloadChipAnnotationDialog extends javax.swing.JDialog implements Constants {

    private List<Object[]> listTableData = null;
    private ArrayListObjectArrayTableModel listTableModel = null;
    private boolean loaded = false;

    /** Creates new form DownloadChipAnnotationDialog */
    public DownloadChipAnnotationDialog(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        listTableData = new ArrayList<Object[]>();
        listTableModel = new ArrayListObjectArrayTableModel();
        initComponents();
        setIconImage(GUIUtil.readImageIcon("igg.png").getImage());
        checkLabel.setText("Checking...");
        String[] titles = {"Platform", "Chip Name", "Version", "Size", "Select"};
        listTableModel.setTitle(titles);
        try {
            SwingWorker worker = new SwingWorker() {

                @Override
                protected Object doInBackground() {
                    try {
                        for (int i = 0; i < ILLUMINA_CHIPS.length; i++) {
                            Object[] item = new Object[5];
                            item[0] = "Illumina";
                            item[1] = ILLUMINA_CHIPS[i] + ".txt.zip";
                            item[2] = "-";
                            String urlFile = IGG_RESOURCE_URL + ILLUMINA_CHIPS[i] + ".txt.zip";
                            long urlFileSize = HttpClient4API.getContentLength(urlFile);
                            urlFileSize = urlFileSize / 1024;
                            item[3] = String.valueOf(urlFileSize) + "k";
                            item[4] = (new Boolean(false));
                            listTableData.add(item);
                        }

                        for (int i = 0; i < AFFY_CHIPS.length; i++) {
                            Object[] item = new Object[5];
                            item[0] = "Affymetrix";
                            item[1] = AFFY_CHIPS[i] + ".txt.zip";
                            item[2] = "na29";
                            String urlFile = IGG_RESOURCE_URL + AFFY_CHIPS[i] + ".txt.zip";

                            long urlFileSize = HttpClient4API.getContentLength(urlFile);
                            urlFileSize = urlFileSize / 1024;
                            item[3] = String.valueOf(urlFileSize) + "k";
                            item[4] = (new Boolean(false));
                            listTableData.add(item);
                        }
                    } catch (Exception ex) {
                        JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), ex.toString(), "Error", JOptionPane.ERROR_MESSAGE);
                    }
                    return null;
                }

                @Override
                protected void done() {
                    try {
                        listTableModel.setDataList(listTableData);
                        listTableModel.fireTableStructureChanged();
                        TableColumn firsetColumn = chipAnnoFilesTable.getColumnModel().getColumn(1);
                        firsetColumn.setPreferredWidth(230);
                        firsetColumn.setMaxWidth(230);
                        firsetColumn.setMinWidth(230);
                        checkLabel.setText("Ready");
                        loaded = true;
                    } catch (Exception ex) {
                        JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), ex.toString(), "Error", JOptionPane.ERROR_MESSAGE);
                    }
                }
            };
            if (GlobalVariables.canConnect2Website) {
                worker.execute();
            }

        } catch (Exception ex) {
            JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), ex.toString(), "Error", JOptionPane.ERROR_MESSAGE);
        }
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        chipAnnoFilesTable = new javax.swing.JTable();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        checkLabel = new javax.swing.JLabel();
        jButton3 = new javax.swing.JButton();
        jButton4 = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(org.cobi.igg3.gui.IGG3App.class).getContext().getResourceMap(DownloadChipAnnotationDialog.class);
        setTitle(resourceMap.getString("Form.title")); // NOI18N
        setName("Form"); // NOI18N
        setResizable(false);

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("GeneChip Annotations"));
        jPanel1.setName("jPanel1"); // NOI18N

        jScrollPane1.setName("jScrollPane1"); // NOI18N

        chipAnnoFilesTable.setModel(listTableModel);
        chipAnnoFilesTable.setName("chipAnnoFilesTable"); // NOI18N
        jScrollPane1.setViewportView(chipAnnoFilesTable);

        javax.swing.ActionMap actionMap = org.jdesktop.application.Application.getInstance(org.cobi.igg3.gui.IGG3App.class).getContext().getActionMap(DownloadChipAnnotationDialog.class, this);
        jButton1.setAction(actionMap.get("selectAll")); // NOI18N
        jButton1.setName("jButton1"); // NOI18N

        jButton2.setAction(actionMap.get("unSelectedAll")); // NOI18N
        jButton2.setName("jButton2"); // NOI18N

        checkLabel.setFont(resourceMap.getFont("checkLabel.font")); // NOI18N
        checkLabel.setText(resourceMap.getString("checkLabel.text")); // NOI18N
        checkLabel.setName("checkLabel"); // NOI18N

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jButton2, javax.swing.GroupLayout.Alignment.TRAILING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                    .addComponent(checkLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 195, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jButton1))
                .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 475, javax.swing.GroupLayout.PREFERRED_SIZE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton1)
                    .addComponent(checkLabel))
                .addGap(1, 1, 1)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 322, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButton2))
        );

        jButton3.setAction(actionMap.get("downloadSelectedChipAnnot")); // NOI18N
        jButton3.setName("jButton3"); // NOI18N

        jButton4.setAction(actionMap.get("cancel")); // NOI18N
        jButton4.setName("jButton4"); // NOI18N

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(36, 36, 36)
                .addComponent(jButton3)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 246, Short.MAX_VALUE)
                .addComponent(jButton4)
                .addGap(75, 75, 75))
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton3)
                    .addComponent(jButton4))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                DownloadChipAnnotationDialog dialog = new DownloadChipAnnotationDialog(new javax.swing.JFrame(), true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {

                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }

    public void specifySelection(String annotaionFileNames) {
        if (!loaded) {
            return;
        }
        if (annotaionFileNames == null || annotaionFileNames.trim().length() == 0) {
            return;
        }
        String[] fileNames = annotaionFileNames.split("\n");
        for (int i = 0; i < fileNames.length; i++) {
            fileNames[i] = fileNames[i] + ".txt.zip";
        }
        Arrays.sort(fileNames);

        for (int i = 0; i < listTableData.size(); i++) {
            String fileName = (String) listTableData.get(i)[1];
            if (Arrays.binarySearch(fileNames, fileName) >= 0) {
                (listTableData.get(i)[4]) = new Boolean(true);
            }
        }
        listTableModel.fireTableStructureChanged();

    }

    @Action
    public void selectAll() {
        for (int i = 0; i < listTableData.size(); i++) {
            (listTableData.get(i)[4]) = new Boolean(true);
        }
        listTableModel.fireTableStructureChanged();
        TableColumn firsetColumn = chipAnnoFilesTable.getColumnModel().getColumn(1);
        firsetColumn.setPreferredWidth(230);
        firsetColumn.setMaxWidth(230);
        firsetColumn.setMinWidth(230);
    }

    @Action
    public void unSelectedAll() {
        for (int i = 0; i < listTableData.size(); i++) {
            (listTableData.get(i)[4]) = new Boolean(false);
        }
        listTableModel.fireTableStructureChanged();
        TableColumn firsetColumn = chipAnnoFilesTable.getColumnModel().getColumn(1);
        firsetColumn.setPreferredWidth(230);
        firsetColumn.setMaxWidth(230);
        firsetColumn.setMinWidth(230);
    }

    @Action(block = Task.BlockingScope.ACTION)
    public Task downloadSelectedChipAnnot() {
        return new DownloadSelectedChipAnnotTask(org.jdesktop.application.Application.getInstance(org.cobi.igg3.gui.IGG3App.class));
    }

    private class DownloadSelectedChipAnnotTask extends org.jdesktop.application.Task<Object, Void> {

        long startTime, endTime;
        boolean realSuccess = false;

        DownloadSelectedChipAnnotTask(org.jdesktop.application.Application app) {
            // Runs on the EDT.  Copy GUI state that
            // doInBackground() depends on from parameters
            // to DownloadSelectedChipAnnotTask fields, here.
            super(app);
        }

        @Override
        protected Object doInBackground() {
            // Your Task's code here.  This method runs
            // on a background thread, so don't reference
            // the Swing GUI from here.
            ArrayList<String> updatedFiles = new ArrayList<String>();
            ArrayList<String> noNeedFiles = new ArrayList<String>();
            try {
                for (int i = 0; i < listTableData.size(); i++) {
                    Object[] item = listTableData.get(i);
                    if (((Boolean) item[4]) == false) {
                        continue;
                    }
                    String fileName = (String) item[1];
                    String urlFile = IGG_RESOURCE_URL + fileName;

                    long urlFileSize = HttpClient4API.getContentLength(urlFile);
                    Long fileSize = (Long) GlobalVariables.resourceFileSize.get(fileName);

                    if (fileSize == null || fileSize != urlFileSize) {
                        updatedFiles.add(fileName);
                    } else if (fileSize == urlFileSize) {
                        noNeedFiles.add(fileName);
                    }
                }

                if (noNeedFiles.size() > 0) {
                    StringBuffer msg = new StringBuffer("No need download the following file(s) since you already have the latest version of them!\n");
                    for (int j = 0; j < noNeedFiles.size(); j++) {
                        msg.append(noNeedFiles.get(j));
                        msg.append('\n');
                    }
                    JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), msg.toString(), "Message", JOptionPane.INFORMATION_MESSAGE);
                }
                if (updatedFiles.size() == 0) {
                    JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), "Resources have already been the latest! ", "Message", JOptionPane.INFORMATION_MESSAGE);
                    return null;
                }
                setVisible(false);
                StringBuffer infor = new StringBuffer();
                infor.append("The following ");
                infor.append(" data will be downloaded and updated!\n");
                for (int i = 0; i < updatedFiles.size(); i++) {
                    infor.append(i + 1);
                    infor.append(".  ");
                    infor.append(updatedFiles.get(i));
                    infor.append("\n");
                    updatedFiles.set(i, IGG_RESOURCE_URL + updatedFiles.get(i));
                }
                Object[] options = {"OK", "CANCEL"};
                int response = JOptionPane.showOptionDialog(GlobalVariables.currentApplication.getMainFrame(), infor.toString(), "Message",
                        JOptionPane.DEFAULT_OPTION, JOptionPane.INFORMATION_MESSAGE,
                        null, options, options[0]);
                if (response == 1) {
                    return null;
                }
                startTime = System.currentTimeMillis();
                GlobalVariables.mainView.setBriefRunningIcons("start.gif");
                GlobalVariables.mainView.setStatusMessage("Downloading...");
                GlobalVariables.mainView.setDownloadVisible(true);
                int filesNum = updatedFiles.size();
                File localFileAddress = new File(IGG_RESOURCE_CHIP_FOLDER);
                ClientConnectionManager cm = new ThreadSafeClientConnManager(GlobalVariables.httpParams, GlobalVariables.connectionSchemeRegistry);
                HttpClient httpClient = new DefaultHttpClient(cm, GlobalVariables.httpParams);

                TaskQueue queue = new TaskQueue();
                for (int i = 0; i < filesNum; i++) {
                    HttpClient4TaskBeanProgressBar task = new HttpClient4TaskBeanProgressBar(httpClient);
                    task.setDownURL(updatedFiles.get(i));
                    task.setSaveFile(localFileAddress.getCanonicalPath() + File.separator + updatedFiles.get(i).substring(updatedFiles.get(i).lastIndexOf("/") + 1));
                    task.setSectionCount(FILE_SEGEMENT_NUM);
                    task.setWorkerCount(FILE_SEGEMENT_NUM);
                    task.setDownloadProgressBar(GlobalVariables.mainView.getDownloadProgressBar());
                    task.setInforTextPane(GlobalVariables.mainView.getBreifTextPane());
                    task.setBufferSize(128 * 1024);
                    queue.putTask(new HttpClient4DownloadTaskProgressBar(task));
                }

                ThreadPool pool = new ThreadPool(queue);
                int MAX_THREAD = 2;
                //launtch two thread to do these task
                for (int i = 0; i < MAX_THREAD; i++) {
                    pool.addWorkerThread();
                }

                GlobalVariables.mainView.setBriefRunningInfor("Updating resource files ...", true);
                GlobalVariables.addInforLog("Updating resource files ...");

                pool.jointAllWorkerThread();
                httpClient.getConnectionManager().shutdown();
                realSuccess = true;
            } catch (Exception ex) {
                JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), ex.toString(), "Error", JOptionPane.ERROR_MESSAGE);
            }
            GlobalVariables.mainView.updateChipAnnos();
            GlobalVariables.addInforLog(updatedFiles.size() + " file(s) have been downloaded and updated!");
            GlobalVariables.mainView.setBriefRunningInfor(updatedFiles.size() + " file(s) have been downloaded and updated!", true);
            JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), updatedFiles.size() + " file(s) have been downloaded and updated!", "Message", JOptionPane.INFORMATION_MESSAGE);
            GlobalVariables.mainView.setStatusMessage("Ready");
            GlobalVariables.mainView.setDownloadVisible(false);
            return null;  // return your result

        }

        @Override
        protected void succeeded(Object result) {
            // Runs on the EDT.  Update the GUI based on
            // the result computed by doInBackground().
            if (realSuccess) {
                StringBuffer inforString = new StringBuffer();
                inforString.append("The Overall Lapsed Time: ");
                endTime = System.currentTimeMillis();
                inforString.append((endTime - startTime) / 1000.0);
                inforString.append(" Seconds.\n");

                GlobalVariables.mainView.setBriefRunningIcons("time.gif");
                GlobalVariables.mainView.setBriefRunningInfor("The downloading proccess is finished. " + inforString.toString(), true);
                GlobalVariables.addInforLog(inforString.toString());
            }
        }
    }

    @Action
    public void cancel() {
        setVisible(false);
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel checkLabel;
    private javax.swing.JTable chipAnnoFilesTable;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton4;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    // End of variables declaration//GEN-END:variables
}
