// (c) 2008-2009 Miaoxin Li
// This file is distributed as part of the IGG source code package
// and may not be redistributed in any form, without prior written
// permission from the author. Permission is granted for you to
// modify this file for your own personal use, but modified versions
// must retain this copyright notice and must not be distributed.
// Permission is granted for you to use this file to compile IGG.
// All computer programs have bugs. Use this file at your own risk.
// Saturday, January 17, 2009
/*
 * ExportIntegrateDataJDialog.java
 *
 * Created on 2008�?2�?�? 下午3:28
 */
package org.cobi.igg3.gui;

import java.io.File;
import java.util.List;
import javax.swing.DefaultListModel;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import org.cobi.igg3.controller.RoutineGenetExporter;
import org.cobi.igg3.entity.ExportSetting;
import org.cobi.igg3.entity.Integration;
import org.cobi.igg3.GlobalVariables;
import org.cobi.igg3.entity.PedFile;
import org.jdesktop.application.Action;
import org.jdesktop.application.Task;

/**
 *
 * @author  Miaoxin Li
 */
public class ExportIntegrateDataJDialog extends javax.swing.JDialog {
    
    DefaultListModel unSelectPhenotypeListModel = new DefaultListModel();
    DefaultListModel selectPhenotypeListModel = new DefaultListModel();
    DefaultListModel unSelectHapPhenotypeListModel = new DefaultListModel();
    DefaultListModel selectHapPhenotypeListModel = new DefaultListModel();
    SepcifyExportRegionsJDialog sepcifyExportRegionsJDialog = null;

    /** Creates new form ExportIntegrateDataJDialog */
    public ExportIntegrateDataJDialog(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        setIconImage(GUIUtil.readImageIcon("igg.png").getImage());
        List<String> traitNames = GlobalVariables.currentPedFile.getTraitNames();
        unSelectPhenotypeListModel.removeAllElements();
        unSelectHapPhenotypeListModel.removeAllElements();
        for (int i = 0; i < traitNames.size(); i++) {
            unSelectPhenotypeListModel.addElement(traitNames.get(i));
            unSelectHapPhenotypeListModel.addElement(traitNames.get(i));
        }
        
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel3 = new javax.swing.JLabel();
        jPanel2 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        integratedDatasetComboBox = new javax.swing.JComboBox();
        phenotypeTabbedPane = new javax.swing.JTabbedPane();
        chipPhenoPanel = new javax.swing.JPanel();
        jScrollPane8 = new javax.swing.JScrollPane();
        jList4 = new javax.swing.JList(unSelectPhenotypeListModel);
        jScrollPane9 = new javax.swing.JScrollPane();
        jList3 = new javax.swing.JList(selectPhenotypeListModel);
        jPanel1 = new javax.swing.JPanel();
        jButton5 = new javax.swing.JButton();
        jButton6 = new javax.swing.JButton();
        jComboBox4 = new javax.swing.JComboBox();
        jLabel16 = new javax.swing.JLabel();
        hapPhenoPanel = new javax.swing.JPanel();
        jScrollPane10 = new javax.swing.JScrollPane();
        jList5 = new javax.swing.JList(unSelectPhenotypeListModel);
        jScrollPane11 = new javax.swing.JScrollPane();
        jList6 = new javax.swing.JList(selectPhenotypeListModel);
        jPanel3 = new javax.swing.JPanel();
        jButton7 = new javax.swing.JButton();
        jButton8 = new javax.swing.JButton();
        jComboBox5 = new javax.swing.JComboBox();
        jLabel17 = new javax.swing.JLabel();
        jPanel7 = new javax.swing.JPanel();
        jLabel25 = new javax.swing.JLabel();
        jTextField13 = new javax.swing.JTextField();
        jLabel26 = new javax.swing.JLabel();
        jPanel13 = new javax.swing.JPanel();
        toolComboBox = new javax.swing.JComboBox();
        jLabel11 = new javax.swing.JLabel();
        jLabel12 = new javax.swing.JLabel();
        missingGtyTextField = new javax.swing.JTextField();
        numberAlleleCheckBox = new javax.swing.JCheckBox();
        strandComboBox = new javax.swing.JComboBox();
        jLabel2 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        hapMapGenetMapTextField = new javax.swing.JTextField();
        hapMapRecombFileButton = new javax.swing.JButton();
        jPanel14 = new javax.swing.JPanel();
        jLabel13 = new javax.swing.JLabel();
        pathTextField = new javax.swing.JTextField();
        jButton12 = new javax.swing.JButton();
        jLabel14 = new javax.swing.JLabel();
        prefixNameTextField = new javax.swing.JTextField();
        jPanel4 = new javax.swing.JPanel();
        removeMendelCheckBox = new javax.swing.JCheckBox();
        removeAllMissingCheckBox = new javax.swing.JCheckBox();
        correctFreq = new javax.swing.JCheckBox();
        jLabel28 = new javax.swing.JLabel();
        intervalTextField = new javax.swing.JTextField();
        intervalComboBox = new javax.swing.JComboBox();
        jLabel27 = new javax.swing.JLabel();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jButton4 = new javax.swing.JButton();

        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(org.cobi.igg3.gui.IGG3App.class).getContext().getResourceMap(ExportIntegrateDataJDialog.class);
        jLabel3.setText(resourceMap.getString("jLabel3.text")); // NOI18N
        jLabel3.setName("jLabel3"); // NOI18N

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle(resourceMap.getString("Form.title")); // NOI18N
        setName("Form"); // NOI18N
        setResizable(false);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowOpened(java.awt.event.WindowEvent evt) {
                formWindowOpened(evt);
            }
        });

        jPanel2.setName("jPanel2"); // NOI18N

        jLabel1.setText(resourceMap.getString("jLabel1.text")); // NOI18N
        jLabel1.setName("jLabel1"); // NOI18N

        integratedDatasetComboBox.setModel(GlobalVariables.allIntegrationModel);
        integratedDatasetComboBox.setName("integratedDatasetComboBox"); // NOI18N
        integratedDatasetComboBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                integratedDatasetComboBoxActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(integratedDatasetComboBox, 0, 398, Short.MAX_VALUE)
                .addContainerGap())
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(integratedDatasetComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
        );

        phenotypeTabbedPane.setEnabled(false);
        phenotypeTabbedPane.setName("phenotypeTabbedPane"); // NOI18N

        chipPhenoPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Phenotypes"));
        chipPhenoPanel.setName("chipPhenoPanel"); // NOI18N

        jScrollPane8.setBorder(javax.swing.BorderFactory.createTitledBorder("Available"));
        jScrollPane8.setName("jScrollPane8"); // NOI18N

        jList4.setModel(unSelectPhenotypeListModel);
        jList4.setName("jList4"); // NOI18N
        jScrollPane8.setViewportView(jList4);

        jScrollPane9.setBorder(javax.swing.BorderFactory.createTitledBorder("Selected"));
        jScrollPane9.setName("jScrollPane9"); // NOI18N

        jList3.setModel(selectPhenotypeListModel);
        jList3.setName("jList3"); // NOI18N
        jScrollPane9.setViewportView(jList3);

        jPanel1.setName("jPanel1"); // NOI18N

        javax.swing.ActionMap actionMap = org.jdesktop.application.Application.getInstance(org.cobi.igg3.gui.IGG3App.class).getContext().getActionMap(ExportIntegrateDataJDialog.class, this);
        jButton5.setAction(actionMap.get("selectPhenotypes")); // NOI18N
        jButton5.setName("jButton5"); // NOI18N

        jButton6.setAction(actionMap.get("unSelectPhenotypes")); // NOI18N
        jButton6.setName("jButton6"); // NOI18N

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jButton5, javax.swing.GroupLayout.PREFERRED_SIZE, 28, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addComponent(jButton6, javax.swing.GroupLayout.PREFERRED_SIZE, 27, javax.swing.GroupLayout.PREFERRED_SIZE)
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap(38, Short.MAX_VALUE)
                .addComponent(jButton5)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButton6))
        );

        jComboBox4.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Affection Status", "Quantitative Trait", "Covariate" }));
        jComboBox4.setName("jComboBox4"); // NOI18N

        jLabel16.setText(resourceMap.getString("jLabel16.text")); // NOI18N
        jLabel16.setName("jLabel16"); // NOI18N

        javax.swing.GroupLayout chipPhenoPanelLayout = new javax.swing.GroupLayout(chipPhenoPanel);
        chipPhenoPanel.setLayout(chipPhenoPanelLayout);
        chipPhenoPanelLayout.setHorizontalGroup(
            chipPhenoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(chipPhenoPanelLayout.createSequentialGroup()
                .addGroup(chipPhenoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(chipPhenoPanelLayout.createSequentialGroup()
                        .addComponent(jLabel16)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jComboBox4, javax.swing.GroupLayout.PREFERRED_SIZE, 172, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(chipPhenoPanelLayout.createSequentialGroup()
                        .addComponent(jScrollPane8, javax.swing.GroupLayout.PREFERRED_SIZE, 147, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jScrollPane9, javax.swing.GroupLayout.DEFAULT_SIZE, 310, Short.MAX_VALUE)))
                .addContainerGap())
        );
        chipPhenoPanelLayout.setVerticalGroup(
            chipPhenoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(chipPhenoPanelLayout.createSequentialGroup()
                .addGroup(chipPhenoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel16)
                    .addComponent(jComboBox4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(chipPhenoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jPanel1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jScrollPane9, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 144, Short.MAX_VALUE)
                    .addComponent(jScrollPane8, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, 144, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );

        phenotypeTabbedPane.addTab(resourceMap.getString("chipPhenoPanel.TabConstraints.tabTitle"), chipPhenoPanel); // NOI18N

        hapPhenoPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Phenotypes"));
        hapPhenoPanel.setName("hapPhenoPanel"); // NOI18N

        jScrollPane10.setBorder(javax.swing.BorderFactory.createTitledBorder("Available"));
        jScrollPane10.setName("jScrollPane10"); // NOI18N

        jList5.setModel(unSelectHapPhenotypeListModel);
        jList5.setName("jList5"); // NOI18N
        jScrollPane10.setViewportView(jList5);

        jScrollPane11.setBorder(javax.swing.BorderFactory.createTitledBorder("Selected"));
        jScrollPane11.setName("jScrollPane11"); // NOI18N

        jList6.setModel(selectHapPhenotypeListModel);
        jList6.setName("jList6"); // NOI18N
        jScrollPane11.setViewportView(jList6);

        jPanel3.setName("jPanel3"); // NOI18N

        jButton7.setAction(actionMap.get("selectHapPhenotypes")); // NOI18N
        jButton7.setName("jButton7"); // NOI18N

        jButton8.setAction(actionMap.get("unSelectHapPhenotypes")); // NOI18N
        jButton8.setName("jButton8"); // NOI18N

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jButton7, javax.swing.GroupLayout.PREFERRED_SIZE, 28, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton8, javax.swing.GroupLayout.PREFERRED_SIZE, 27, javax.swing.GroupLayout.PREFERRED_SIZE)))
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel3Layout.createSequentialGroup()
                .addContainerGap(51, Short.MAX_VALUE)
                .addComponent(jButton7)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButton8)
                .addGap(32, 32, 32))
        );

        jComboBox5.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Affection Status", "Quantitative Trait", "Covariate" }));
        jComboBox5.setName("jComboBox5"); // NOI18N

        jLabel17.setText(resourceMap.getString("jLabel17.text")); // NOI18N
        jLabel17.setName("jLabel17"); // NOI18N

        jPanel7.setName("jPanel7"); // NOI18N

        jLabel25.setFont(resourceMap.getFont("jLabel25.font")); // NOI18N
        jLabel25.setForeground(resourceMap.getColor("jLabel25.foreground")); // NOI18N
        jLabel25.setText(resourceMap.getString("jLabel25.text")); // NOI18N
        jLabel25.setName("jLabel25"); // NOI18N

        jTextField13.setText(resourceMap.getString("jTextField13.text")); // NOI18N
        jTextField13.setName("jTextField13"); // NOI18N

        jLabel26.setText(resourceMap.getString("jLabel26.text")); // NOI18N
        jLabel26.setName("jLabel26"); // NOI18N

        javax.swing.GroupLayout jPanel7Layout = new javax.swing.GroupLayout(jPanel7);
        jPanel7.setLayout(jPanel7Layout);
        jPanel7Layout.setHorizontalGroup(
            jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel7Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel25)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jTextField13, javax.swing.GroupLayout.PREFERRED_SIZE, 62, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel26)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel7Layout.setVerticalGroup(
            jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                .addComponent(jTextField13, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addComponent(jLabel26)
                .addComponent(jLabel25))
        );

        javax.swing.GroupLayout hapPhenoPanelLayout = new javax.swing.GroupLayout(hapPhenoPanel);
        hapPhenoPanel.setLayout(hapPhenoPanelLayout);
        hapPhenoPanelLayout.setHorizontalGroup(
            hapPhenoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(hapPhenoPanelLayout.createSequentialGroup()
                .addGroup(hapPhenoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(hapPhenoPanelLayout.createSequentialGroup()
                        .addComponent(jLabel17)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jComboBox5, javax.swing.GroupLayout.PREFERRED_SIZE, 160, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jPanel7, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(hapPhenoPanelLayout.createSequentialGroup()
                        .addComponent(jScrollPane10, javax.swing.GroupLayout.PREFERRED_SIZE, 144, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(2, 2, 2)
                        .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jScrollPane11, 0, 0, Short.MAX_VALUE)))
                .addContainerGap())
        );
        hapPhenoPanelLayout.setVerticalGroup(
            hapPhenoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(hapPhenoPanelLayout.createSequentialGroup()
                .addGroup(hapPhenoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(hapPhenoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(jLabel17)
                        .addComponent(jComboBox5, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jPanel7, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(6, 6, 6)
                .addGroup(hapPhenoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(hapPhenoPanelLayout.createSequentialGroup()
                        .addComponent(jPanel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addContainerGap())
                    .addComponent(jScrollPane11, javax.swing.GroupLayout.DEFAULT_SIZE, 150, Short.MAX_VALUE)
                    .addGroup(hapPhenoPanelLayout.createSequentialGroup()
                        .addGap(8, 8, 8)
                        .addComponent(jScrollPane10, javax.swing.GroupLayout.DEFAULT_SIZE, 142, Short.MAX_VALUE))))
        );

        phenotypeTabbedPane.addTab(resourceMap.getString("hapPhenoPanel.TabConstraints.tabTitle"), hapPhenoPanel); // NOI18N

        jPanel13.setBorder(javax.swing.BorderFactory.createTitledBorder("Format"));
        jPanel13.setName("jPanel13"); // NOI18N

        toolComboBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Mega2", "Plink Binary Format (SNP-major model)", "Plink", "Merlin", "Haploview", "BIMBAM", "Solar", "Linkage", "GeneHunter", "HapMap Genotype Files" }));
        toolComboBox.setName("toolComboBox"); // NOI18N
        toolComboBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                toolComboBoxActionPerformed(evt);
            }
        });

        jLabel11.setText(resourceMap.getString("jLabel11.text")); // NOI18N
        jLabel11.setName("jLabel11"); // NOI18N

        jLabel12.setText(resourceMap.getString("jLabel12.text")); // NOI18N
        jLabel12.setName("jLabel12"); // NOI18N

        missingGtyTextField.setText(resourceMap.getString("missingGtyTextField.text")); // NOI18N
        missingGtyTextField.setName("missingGtyTextField"); // NOI18N

        numberAlleleCheckBox.setText(resourceMap.getString("numberAlleleCheckBox.text")); // NOI18N
        numberAlleleCheckBox.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        numberAlleleCheckBox.setName("numberAlleleCheckBox"); // NOI18N

        strandComboBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Forward/+", "Reverse/-", "Never mind" }));
        strandComboBox.setName("strandComboBox"); // NOI18N

        jLabel2.setText(resourceMap.getString("jLabel2.text")); // NOI18N
        jLabel2.setName("jLabel2"); // NOI18N

        jLabel4.setText(resourceMap.getString("jLabel4.text")); // NOI18N
        jLabel4.setName("jLabel4"); // NOI18N

        hapMapGenetMapTextField.setText(resourceMap.getString("hapMapGenetMapTextField.text")); // NOI18N
        hapMapGenetMapTextField.setToolTipText(resourceMap.getString("hapMapGenetMapTextField.toolTipText")); // NOI18N
        hapMapGenetMapTextField.setName("hapMapGenetMapTextField"); // NOI18N

        hapMapRecombFileButton.setIcon(resourceMap.getIcon("hapMapRecombFileButton.icon")); // NOI18N
        hapMapRecombFileButton.setText(resourceMap.getString("hapMapRecombFileButton.text")); // NOI18N
        hapMapRecombFileButton.setName("hapMapRecombFileButton"); // NOI18N
        hapMapRecombFileButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                hapMapRecombFileButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel13Layout = new javax.swing.GroupLayout(jPanel13);
        jPanel13.setLayout(jPanel13Layout);
        jPanel13Layout.setHorizontalGroup(
            jPanel13Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel13Layout.createSequentialGroup()
                .addGroup(jPanel13Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel13Layout.createSequentialGroup()
                        .addComponent(jLabel11)
                        .addGap(24, 24, 24)
                        .addComponent(toolComboBox, 0, 415, Short.MAX_VALUE))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel13Layout.createSequentialGroup()
                        .addGroup(jPanel13Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel13Layout.createSequentialGroup()
                                .addComponent(jLabel4)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(hapMapGenetMapTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 316, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(jPanel13Layout.createSequentialGroup()
                                .addComponent(jLabel12)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(missingGtyTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 31, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 43, Short.MAX_VALUE)
                                .addComponent(jLabel2)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(strandComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, 121, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(26, 26, 26)
                                .addComponent(numberAlleleCheckBox)))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(hapMapRecombFileButton, javax.swing.GroupLayout.PREFERRED_SIZE, 27, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        jPanel13Layout.setVerticalGroup(
            jPanel13Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel13Layout.createSequentialGroup()
                .addGroup(jPanel13Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel11)
                    .addComponent(toolComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel13Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(jPanel13Layout.createSequentialGroup()
                        .addGroup(jPanel13Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.CENTER)
                            .addComponent(jLabel12)
                            .addComponent(missingGtyTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(numberAlleleCheckBox)
                            .addComponent(strandComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel2))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 6, Short.MAX_VALUE)
                        .addGroup(jPanel13Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel4)
                            .addComponent(hapMapGenetMapTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addComponent(hapMapRecombFileButton))
                .addContainerGap())
        );

        jPanel14.setBorder(javax.swing.BorderFactory.createTitledBorder(resourceMap.getString("jPanel14.border.title"))); // NOI18N
        jPanel14.setName("jPanel14"); // NOI18N

        jLabel13.setText(resourceMap.getString("jLabel13.text")); // NOI18N
        jLabel13.setName("jLabel13"); // NOI18N

        pathTextField.setName("pathTextField"); // NOI18N

        jButton12.setAction(actionMap.get("browsePath")); // NOI18N
        jButton12.setName("jButton12"); // NOI18N

        jLabel14.setText(resourceMap.getString("jLabel14.text")); // NOI18N
        jLabel14.setName("jLabel14"); // NOI18N

        prefixNameTextField.setText(resourceMap.getString("prefixNameTextField.text")); // NOI18N
        prefixNameTextField.setName("prefixNameTextField"); // NOI18N

        javax.swing.GroupLayout jPanel14Layout = new javax.swing.GroupLayout(jPanel14);
        jPanel14.setLayout(jPanel14Layout);
        jPanel14Layout.setHorizontalGroup(
            jPanel14Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel14Layout.createSequentialGroup()
                .addGroup(jPanel14Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel14Layout.createSequentialGroup()
                        .addComponent(jLabel13)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(pathTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 445, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButton12, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanel14Layout.createSequentialGroup()
                        .addComponent(jLabel14)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(prefixNameTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 109, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        jPanel14Layout.setVerticalGroup(
            jPanel14Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel14Layout.createSequentialGroup()
                .addGroup(jPanel14Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.CENTER)
                    .addComponent(jLabel13)
                    .addComponent(pathTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton12))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 9, Short.MAX_VALUE)
                .addGroup(jPanel14Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel14)
                    .addComponent(prefixNameTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
        );

        jPanel4.setBorder(javax.swing.BorderFactory.createTitledBorder(resourceMap.getString("jPanel4.border.title"))); // NOI18N
        jPanel4.setName("jPanel4"); // NOI18N

        removeMendelCheckBox.setText(resourceMap.getString("removeMendelCheckBox.text")); // NOI18N
        removeMendelCheckBox.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        removeMendelCheckBox.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        removeMendelCheckBox.setMargin(new java.awt.Insets(0, 0, 0, 0));
        removeMendelCheckBox.setName("removeMendelCheckBox"); // NOI18N

        removeAllMissingCheckBox.setSelected(true);
        removeAllMissingCheckBox.setText(resourceMap.getString("removeAllMissingCheckBox.text")); // NOI18N
        removeAllMissingCheckBox.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        removeAllMissingCheckBox.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        removeAllMissingCheckBox.setName("removeAllMissingCheckBox"); // NOI18N

        correctFreq.setText(resourceMap.getString("correctFreq.text")); // NOI18N
        correctFreq.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        correctFreq.setName("correctFreq"); // NOI18N

        jLabel28.setText(resourceMap.getString("jLabel28.text")); // NOI18N
        jLabel28.setName("jLabel28"); // NOI18N

        intervalTextField.setText(resourceMap.getString("intervalTextField.text")); // NOI18N
        intervalTextField.setName("intervalTextField"); // NOI18N

        intervalComboBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Physical Map", "Genetic Map" }));
        intervalComboBox.setName("intervalComboBox"); // NOI18N
        intervalComboBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                intervalComboBoxActionPerformed(evt);
            }
        });

        jLabel27.setText(resourceMap.getString("jLabel27.text")); // NOI18N
        jLabel27.setName("jLabel27"); // NOI18N

        javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addComponent(correctFreq)
                .addContainerGap(233, javax.swing.GroupLayout.PREFERRED_SIZE))
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addComponent(removeMendelCheckBox)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 254, Short.MAX_VALUE)
                .addComponent(removeAllMissingCheckBox))
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addComponent(jLabel27)
                .addGap(12, 12, 12)
                .addComponent(intervalComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, 105, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(intervalTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 58, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel28)
                .addContainerGap(220, javax.swing.GroupLayout.PREFERRED_SIZE))
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.CENTER)
                    .addComponent(jLabel27)
                    .addComponent(intervalComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(intervalTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel28))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(removeMendelCheckBox)
                    .addComponent(removeAllMissingCheckBox))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(correctFreq))
        );

        jButton1.setAction(actionMap.get("integrator")); // NOI18N
        jButton1.setName("jButton1"); // NOI18N

        jButton2.setAction(actionMap.get("cancel")); // NOI18N
        jButton2.setName("jButton2"); // NOI18N

        jButton4.setAction(actionMap.get("pickupRegionsDialog")); // NOI18N
        jButton4.setName("jButton4"); // NOI18N

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jPanel13, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel14, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel4, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel2, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(phenotypeTabbedPane, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 524, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                        .addComponent(jButton4)
                        .addGap(89, 89, 89)
                        .addComponent(jButton1)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 145, Short.MAX_VALUE)
                        .addComponent(jButton2)
                        .addGap(51, 51, 51)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(phenotypeTabbedPane, javax.swing.GroupLayout.PREFERRED_SIZE, 227, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jPanel14, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel13, javax.swing.GroupLayout.PREFERRED_SIZE, 96, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton4)
                    .addComponent(jButton1)
                    .addComponent(jButton2))
                .addGap(22, 22, 22))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

private void integratedDatasetComboBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_integratedDatasetComboBoxActionPerformed
// TODO add your handling code here:
    Object item = integratedDatasetComboBox.getSelectedItem();
    if (item != null) {
        Integration integration = (Integration) item;
        boolean isHapMap = integration.isHapMapSet();
        try {
            if (isHapMap) {
                phenotypeTabbedPane.setSelectedIndex(1);
            } else {
                phenotypeTabbedPane.setSelectedIndex(0);
            }
        } catch (Exception ex) {
            JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), ex.toString(), "Error", JOptionPane.ERROR_MESSAGE);
        }
    }
}//GEN-LAST:event_integratedDatasetComboBoxActionPerformed
    
private void toolComboBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_toolComboBoxActionPerformed
// TODO add your handling code here:
    String format = (String) toolComboBox.getSelectedItem();
    if (format.equals("Merlin")) {
        missingGtyTextField.setText("00");
    } else if (format.equals("Solar")) {
        missingGtyTextField.setText("00");
    }
}//GEN-LAST:event_toolComboBoxActionPerformed
    
private void intervalComboBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_intervalComboBoxActionPerformed
// TODO add your handling code here:
    String map = (String) intervalComboBox.getSelectedItem();
    if (map.equals("Physical Map")) {
        jLabel28.setText("kb");
    } else if (map.equals("Genetic Map")) {
        jLabel28.setText("cM");
    }
}//GEN-LAST:event_intervalComboBoxActionPerformed
    
private void formWindowOpened(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowOpened
// TODO add your handling code here:
    Object item = GlobalVariables.allIntegrationModel.getElementAt(0);
    if (item != null) {
        Integration integration = (Integration) item;
        boolean isHapMap = integration.isHapMapSet();
        if (isHapMap) {
            phenotypeTabbedPane.setSelectedIndex(1);
        } else {
            phenotypeTabbedPane.setSelectedIndex(0);
        }
    }
}//GEN-LAST:event_formWindowOpened
    
    private void hapMapRecombFileButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_hapMapRecombFileButtonActionPerformed
        // TODO add your handling code here:
        JFileChooser fDialog = null;
        if ((GlobalVariables.lastAccessedPath != null) && (GlobalVariables.lastAccessedPath.trim().length() > 0)) {
            fDialog = new JFileChooser(GlobalVariables.lastAccessedPath);
        } else {
            fDialog = new JFileChooser();
        }
        
        int result = fDialog.showOpenDialog(this);
        if (result == JFileChooser.APPROVE_OPTION) {
            hapMapGenetMapTextField.setText(fDialog.getSelectedFile().getAbsolutePath());
            GlobalVariables.lastAccessedPath = fDialog.getSelectedFile().getPath();
        }
    }//GEN-LAST:event_hapMapRecombFileButtonActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            
            public void run() {
                ExportIntegrateDataJDialog dialog = new ExportIntegrateDataJDialog(new javax.swing.JFrame(), true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {
                    
                    @Override
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }
    
    @Action(block = Task.BlockingScope.ACTION)
    public Task integrator() {
        if (pathTextField.getText().trim().length() == 0) {
            JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(),
                    "Choose a folder please!",
                    "Error",
                    JOptionPane.ERROR_MESSAGE);
            return null;
        }
        
        if (selectPhenotypeListModel.isEmpty() && selectHapPhenotypeListModel.isEmpty()) {
            Object[] options = {"Yes", "No"};
            int response = JOptionPane.showOptionDialog(this, "You havenot choosen any phenotypes, do you want to continue?", "Phenotype Confirmation",
                    JOptionPane.YES_OPTION, JOptionPane.QUESTION_MESSAGE, null, options, options[0]);
            if (response == 1) {
                return null;
            }
        }
        setVisible(false);
        return new IntegratorTask(org.jdesktop.application.Application.getInstance(org.cobi.igg3.gui.IGG3App.class));
    }
    
    private class IntegratorTask extends org.jdesktop.application.Task<Object, Void> {
        
        boolean realSuccess = false;
        long startTime, endTime;
        
        IntegratorTask(org.jdesktop.application.Application app) {
            // Runs on the EDT.  Copy GUI state that
            // doInBackground() depends on from parameters
            // to IntegratorTask fields, here.

            super(app);
        }
        
        @Override
        protected Object doInBackground() {
            // Your Task's code here.  This method runs
            // on a background thread, so don't reference
            // the Swing GUI from here.
            Integration itegration = (Integration) integratedDatasetComboBox.getSelectedItem();
            boolean isHapSet = itegration.isHapMapSet();
            char strandInfor = '+';
            if (strandComboBox.getSelectedIndex() == 1) {
                strandInfor = '-';
            } else if (strandComboBox.getSelectedIndex() == 2) {
                strandInfor = '0';
            }
            File commPedFile = new File(itegration.getResultPath() + File.separator + "ped");
            try {
                
                ExportSetting exportSetting = new ExportSetting();
                
                if (isHapSet) {
                    for (int j = 0; j < selectHapPhenotypeListModel.size(); j++) {
                        String tempStr = (String) selectHapPhenotypeListModel.get(j);
                        int index = tempStr.indexOf(" as ");
                        String[] cells = new String[3];
                        cells[0] = tempStr.substring(0, index);
                        tempStr = tempStr.substring(index + 4);
                        index = tempStr.indexOf(" assuming ");
                        cells[1] = tempStr.substring(0, index);
                        tempStr = tempStr.substring(index + 10);
                        index = tempStr.indexOf(" for HapMap");
                        cells[2] = tempStr.substring(0, index);
                        exportSetting.addTraitProper(cells);
                    }
                } else {
                    for (int j = 0; j < selectPhenotypeListModel.size(); j++) {
                        String tempStr = (String) selectPhenotypeListModel.get(j);
                        int index = tempStr.indexOf(" as ");
                        String[] cells = new String[3];
                        cells[0] = tempStr.substring(0, index);
                        cells[1] = tempStr.substring(index + 4);
                        cells[2] = "-";
                        exportSetting.addTraitProper(cells);
                    }
                }
                String path = pathTextField.getText();
                path = path + File.separator;
                String prefix = prefixNameTextField.getText();
                String format = (String) toolComboBox.getSelectedItem();
                String missingGenotypes = missingGtyTextField.getText().trim();
                
                if (missingGenotypes.length() == 2) {
                    missingGenotypes = missingGenotypes.substring(0, 1) + " " + missingGenotypes.substring(1);
                } else if (missingGenotypes.length() == 1) {
                    missingGenotypes = missingGenotypes + " " + missingGenotypes;
                }
                if (prefix.length() == 0) {
                    prefix = format;
                }
                exportSetting.setExportPath(path);
                exportSetting.setPrefixFileName(prefix);
                exportSetting.setToolName(format);
                exportSetting.setMissingGty(missingGenotypes);
                exportSetting.setTrimingType(intervalComboBox.getSelectedItem().toString());
                exportSetting.setTrimmingInterval(Double.parseDouble(intervalTextField.getText()));
                exportSetting.setRemoveBadMendel(removeMendelCheckBox.isSelected());
                exportSetting.setRemoveMissingAll(removeAllMissingCheckBox.isSelected());
                exportSetting.setCorrectAnnoFreq(correctFreq.isSelected());
                exportSetting.setNumberAllele(numberAlleleCheckBox.isSelected());
                
                exportSetting.setStrandOut(strandInfor);
                
                if (sepcifyExportRegionsJDialog != null) {
                    exportSetting.setSelectedRegions(sepcifyExportRegionsJDialog.selectedRegionMap);
                }
                setVisible(false);
                startTime = System.currentTimeMillis();
                GlobalVariables.mainView.setBriefRunningIcons("start.gif");
                GlobalVariables.mainView.setBriefRunningInfor("Generating input files for " + format + " \nPlease wait...\n", true);
                GlobalVariables.addInforLog("Generating input files for " + format);
                RoutineGenetExporter generator = new RoutineGenetExporter();
                generator.setExportSetting(exportSetting);
                generator.setIntegrator(itegration);
                generator.setGeneticMapFile(hapMapGenetMapTextField.getText());
                
                if (commPedFile.exists() && GlobalVariables.currentPedFile.getAllIndividuals().isEmpty()) {                    
                    GlobalVariables.currentPedFile.readCommonPedigrees(commPedFile.getCanonicalPath());
                }
                
                
                String comment = "";
                if (format.equals("Plink Binary Format (SNP-major model)")) {
                    comment = generator.exportPlinkBinaryGenotypeFormat();
                } else if (format.equals("Plink")) {
                    comment = generator.exportPlink();
                } else if (format.equals("Merlin")) {
                    comment = generator.exportMerlin();
                } else if (format.equals("Haploview")) {
                    comment = generator.exportHaploview();
                } else if (format.equals("HapMap Genotype Files")) {
                    comment = generator.exportHapMapGenotypeFile();
                } else if (format.equals("Mega2")) {
                    comment = generator.exportMega2();
                } else if (format.equals("Linkage") || format.equals("GeneHunter")) {
                    comment = generator.exportLinkage();
                } else if (format.equals("Solar")) {
                    comment = generator.exportSolar();
                } else if (format.equals("BIMBAM")) {
                    comment = generator.exportBIMBAM();
                }
                if (commPedFile.exists()) {
                    GlobalVariables.currentPedFile.unloadCommonPedigrees();
                }
                //GlobalVariables.mainView.setBriefRunningIcons("save_edit.gif");
                GlobalVariables.mainView.setBriefRunningInfor(comment, true);
                
                realSuccess = true;
            } catch (Exception ex) {
                JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), ex.toString(), "Error", JOptionPane.ERROR_MESSAGE);
            } finally {
                try {
                    if (commPedFile.exists()) {
                        GlobalVariables.currentPedFile.readCommonPedigrees(commPedFile.getCanonicalPath());
                    }
                } catch (Exception ex) {
                    JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), ex.toString(), "Error", JOptionPane.ERROR_MESSAGE);
                }
            }
            return null;  // return your result

        }
        
        @Override
        protected void succeeded(Object result) {
            // Runs on the EDT.  Update the GUI based on
            // the result computed by doInBackground().
            if (realSuccess) {
                // export data with different format
                StringBuilder inforString = new StringBuilder();
                inforString.append("The Overall Lapsed Time: ");
                endTime = System.currentTimeMillis();
                inforString.append((endTime - startTime) / 1000.0);
                inforString.append(" Seconds.\n");
                
                GlobalVariables.mainView.setBriefRunningIcons("time.gif");
                GlobalVariables.mainView.setBriefRunningInfor("The exporting proccess is finished. " + inforString.toString(), true);
                GlobalVariables.addInforLog(inforString.toString());
                JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(),
                        "Successfully Exported!",
                        "Message",
                        JOptionPane.INFORMATION_MESSAGE);
            }
        }
    }
    
    @Action
    public void cancel() {
        setVisible(false);
    }
    
    @Action
    public void selectPhenotypes() {
        int[] selectedIx = jList4.getSelectedIndices();
        for (int i = 0; i < selectedIx.length; i++) {
            selectPhenotypeListModel.addElement(unSelectPhenotypeListModel.getElementAt(selectedIx[i]) + " as " + (String) jComboBox4.getSelectedItem());
        }
        for (int i = selectedIx.length - 1; i >= 0; i--) {
            unSelectPhenotypeListModel.removeElementAt(selectedIx[i]);
        }
    }
    
    @Action
    public void unSelectPhenotypes() {
        int[] selectedIx = jList3.getSelectedIndices();
        String tempStr = null;
        for (int i = 0; i < selectedIx.length; i++) {
            tempStr = (String) selectPhenotypeListModel.getElementAt(selectedIx[i]);
            unSelectPhenotypeListModel.addElement(tempStr.substring(0, tempStr.indexOf(" as ")));
        }
        for (int i = selectedIx.length - 1; i >= 0; i--) {
            selectPhenotypeListModel.removeElementAt(selectedIx[i]);
        }
    }
    
    @Action
    public void selectHapPhenotypes() {
        int[] selectedIx = jList5.getSelectedIndices();
        for (int i = 0; i < selectedIx.length; i++) {
            selectHapPhenotypeListModel.addElement(unSelectHapPhenotypeListModel.getElementAt(selectedIx[i]) + " as " + (String) jComboBox5.getSelectedItem() + " assuming " + jTextField13.getText() + " for HapMap Sample");
        }
        for (int i = selectedIx.length - 1; i >= 0; i--) {
            unSelectHapPhenotypeListModel.removeElementAt(selectedIx[i]);
        }
    }
    
    @Action
    public void unSelectHapPhenotypes() {
        int[] selectedIx = jList6.getSelectedIndices();
        String tempStr = null;
        for (int i = 0; i < selectedIx.length; i++) {
            tempStr = (String) selectHapPhenotypeListModel.getElementAt(selectedIx[i]);
            unSelectHapPhenotypeListModel.addElement(tempStr.substring(0, tempStr.indexOf(" as ")));
        }
        for (int i = selectedIx.length - 1; i >= 0; i--) {
            selectHapPhenotypeListModel.removeElementAt(selectedIx[i]);
        }
    }
    
    @Action
    public void browsePath() {
        JFileChooser fDialog = null;
        if ((GlobalVariables.lastAccessedPath != null) && (GlobalVariables.lastAccessedPath.trim().length() > 0)) {
            fDialog = new JFileChooser(GlobalVariables.lastAccessedPath);
        } else {
            fDialog = new JFileChooser();
        }
        fDialog.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        int result = fDialog.showOpenDialog(this);
        if (result == JFileChooser.APPROVE_OPTION) {
            pathTextField.setText(fDialog.getSelectedFile().getAbsolutePath());
            GlobalVariables.lastAccessedPath = fDialog.getSelectedFile().getPath();
        }
    }
    
    @Action
    public void pickupRegionsDialog() {
        if (sepcifyExportRegionsJDialog == null) {
            sepcifyExportRegionsJDialog = new SepcifyExportRegionsJDialog(GlobalVariables.currentApplication.getMainFrame(), true);
            sepcifyExportRegionsJDialog.setLocationRelativeTo(GlobalVariables.currentApplication.getMainFrame());
        }
        sepcifyExportRegionsJDialog.listRegions((Integration) integratedDatasetComboBox.getSelectedItem());
        IGG3App.getApplication().show(sepcifyExportRegionsJDialog);
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel chipPhenoPanel;
    private javax.swing.JCheckBox correctFreq;
    private javax.swing.JTextField hapMapGenetMapTextField;
    private javax.swing.JButton hapMapRecombFileButton;
    private javax.swing.JPanel hapPhenoPanel;
    private javax.swing.JComboBox integratedDatasetComboBox;
    private javax.swing.JComboBox intervalComboBox;
    private javax.swing.JTextField intervalTextField;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton12;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton4;
    private javax.swing.JButton jButton5;
    private javax.swing.JButton jButton6;
    private javax.swing.JButton jButton7;
    private javax.swing.JButton jButton8;
    private javax.swing.JComboBox jComboBox4;
    private javax.swing.JComboBox jComboBox5;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel16;
    private javax.swing.JLabel jLabel17;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel25;
    private javax.swing.JLabel jLabel26;
    private javax.swing.JLabel jLabel27;
    private javax.swing.JLabel jLabel28;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JList jList3;
    private javax.swing.JList jList4;
    private javax.swing.JList jList5;
    private javax.swing.JList jList6;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel13;
    private javax.swing.JPanel jPanel14;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JScrollPane jScrollPane10;
    private javax.swing.JScrollPane jScrollPane11;
    private javax.swing.JScrollPane jScrollPane8;
    private javax.swing.JScrollPane jScrollPane9;
    private javax.swing.JTextField jTextField13;
    private javax.swing.JTextField missingGtyTextField;
    private javax.swing.JCheckBox numberAlleleCheckBox;
    private javax.swing.JTextField pathTextField;
    private javax.swing.JTabbedPane phenotypeTabbedPane;
    private javax.swing.JTextField prefixNameTextField;
    private javax.swing.JCheckBox removeAllMissingCheckBox;
    private javax.swing.JCheckBox removeMendelCheckBox;
    private javax.swing.JComboBox strandComboBox;
    private javax.swing.JComboBox toolComboBox;
    // End of variables declaration//GEN-END:variables
}
