// (c) 2008-2009 Miaoxin Li
// This file is distributed as part of the IGG source code package
// and may not be redistributed in any form, without prior written
// permission from the author. Permission is granted for you to
// modify this file for your own personal use, but modified versions
// must retain this copyright notice and must not be distributed.

// Permission is granted for you to use this file to compile IGG.

// All computer programs have bugs. Use this file at your own risk.
// Saturday, January 17, 2009
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.cobi.igg3.gui;

import java.io.FileWriter;
import java.net.URL;
import java.util.Enumeration;
import javax.swing.ImageIcon;
import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.TreeNode;
import javax.swing.tree.TreePath;

/**
 *
 * @author MX Li
 */
public class GUIUtil {

    public static ImageIcon readImageIcon(String filename) {
        URL url = GUIUtil.class.getResource("resources/images/" + filename);
        return new ImageIcon(url);
    }

     
    public static void saveStringTreeNode2File(DefaultMutableTreeNode treeRoot, FileWriter fw) throws Exception {
        try {
            String nodeName = (String) treeRoot.getUserObject();
            if (treeRoot.isLeaf()) {
                fw.write("<Node name=\"" + nodeName + "\"/>\n");
            } else {
                fw.write("<Node name=\"" + nodeName + "\">\n");
                for (int i = 0; i < treeRoot.getChildCount(); i++) {
                    DefaultMutableTreeNode childNode = (DefaultMutableTreeNode) treeRoot.getChildAt(i);
                    saveStringTreeNode2File(childNode, fw);
                }
                fw.write("</Node>\n");
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    

    public static void expandTree(JTree tree) {
        TreeNode root = (TreeNode) tree.getModel().getRoot();
        expandAll(tree, new TreePath(root), true);
    }

    private static void expandAll(JTree tree, TreePath parent, boolean expand) {
        //Traverse children
        TreeNode node = (TreeNode) parent.getLastPathComponent();
        if (node.getChildCount() >= 0) {
            for (Enumeration e = node.children(); e.hasMoreElements();) {
                TreeNode n = (TreeNode) e.nextElement();
                TreePath path = parent.pathByAddingChild(n);
                expandAll(tree, path, expand);
            }
        } // Expansion or collapse must be done bottom-up
        if (expand) {
            tree.expandPath(parent);
        } else {
            tree.collapsePath(parent);
        }
    }
}
