// (c) 2008-2009 Miaoxin Li
// This file is distributed as part of the IGG source code package
// and may not be redistributed in any form, without prior written
// permission from the author. Permission is granted for you to
// modify this file for your own personal use, but modified versions
// must retain this copyright notice and must not be distributed.

// Permission is granted for you to use this file to compile IGG.

// All computer programs have bugs. Use this file at your own risk.
// Saturday, January 17, 2009
/*
 * GenerateSampleDialog.java
 *
 * Created on 2008�?2�?�? 下午4:57
 */
package org.cobi.igg3.gui;

import java.util.ArrayList;
import java.util.List;
import javax.swing.DefaultListModel;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import org.cobi.igg3.Constants;
import org.cobi.igg3.controller.ResourceManager;
import org.cobi.igg3.GlobalVariables;
import org.cobi.igg3.util.IGGTestDataGenerator;
import org.jdesktop.application.Action;
import org.jdesktop.application.Task;

/**
 *
 * @author  Miaoxin Li
 */
public class GenerateSampleDialog extends javax.swing.JDialog implements Constants {

    DefaultListModel chipTypeListModel;
    ResourceManager resourceManager = new ResourceManager();

    /** Creates new form GenerateSampleDialog */
    public GenerateSampleDialog(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        chipTypeListModel = new DefaultListModel();
        initComponents();
        setIconImage(GUIUtil.readImageIcon("igg.png").getImage());
        for (int i = 0; i < AFFY_CHIPS.length; i++) {
            chipTypeComboBox.addItem(AFFY_CHIPS[i]);
        }
        for (int i = 0; i < ILLUMINA_CHIPS.length; i++) {
            chipTypeComboBox.addItem(ILLUMINA_CHIPS[i]);
        }
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        subNumberTextField = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        chipTypeComboBox = new javax.swing.JComboBox();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jLabel3 = new javax.swing.JLabel();
        folderTextField = new javax.swing.JTextField();
        jButton3 = new javax.swing.JButton();
        onlyPedigreeCheckBox = new javax.swing.JCheckBox();
        overwriteCheckBox = new javax.swing.JCheckBox();
        jButton4 = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        chipList = new javax.swing.JList();
        jButton5 = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(org.cobi.igg3.gui.IGG3App.class).getContext().getResourceMap(GenerateSampleDialog.class);
        setTitle(resourceMap.getString("Form.title")); // NOI18N
        setName("Form"); // NOI18N
        setResizable(false);

        jLabel1.setText(resourceMap.getString("jLabel1.text")); // NOI18N
        jLabel1.setName("jLabel1"); // NOI18N

        subNumberTextField.setText(resourceMap.getString("subNumberTextField.text")); // NOI18N
        subNumberTextField.setName("subNumberTextField"); // NOI18N

        jLabel2.setText(resourceMap.getString("jLabel2.text")); // NOI18N
        jLabel2.setName("jLabel2"); // NOI18N

        chipTypeComboBox.setName("chipTypeComboBox"); // NOI18N

        javax.swing.ActionMap actionMap = org.jdesktop.application.Application.getInstance(org.cobi.igg3.gui.IGG3App.class).getContext().getActionMap(GenerateSampleDialog.class, this);
        jButton1.setAction(actionMap.get("generate")); // NOI18N
        jButton1.setName("jButton1"); // NOI18N

        jButton2.setAction(actionMap.get("cancel")); // NOI18N
        jButton2.setName("jButton2"); // NOI18N

        jLabel3.setText(resourceMap.getString("jLabel3.text")); // NOI18N
        jLabel3.setName("jLabel3"); // NOI18N

        folderTextField.setText(resourceMap.getString("folderTextField.text")); // NOI18N
        folderTextField.setName("folderTextField"); // NOI18N

        jButton3.setAction(actionMap.get("choosePath")); // NOI18N
        jButton3.setName("jButton3"); // NOI18N

        onlyPedigreeCheckBox.setText(resourceMap.getString("onlyPedigreeCheckBox.text")); // NOI18N
        onlyPedigreeCheckBox.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        onlyPedigreeCheckBox.setName("onlyPedigreeCheckBox"); // NOI18N

        overwriteCheckBox.setText(resourceMap.getString("overwriteCheckBox.text")); // NOI18N
        overwriteCheckBox.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        overwriteCheckBox.setName("overwriteCheckBox"); // NOI18N

        jButton4.setAction(actionMap.get("addTypes")); // NOI18N
        jButton4.setName("jButton4"); // NOI18N

        jScrollPane1.setName("jScrollPane1"); // NOI18N

        chipList.setModel(chipTypeListModel);
        chipList.setName("chipList"); // NOI18N
        jScrollPane1.setViewportView(chipList);

        jButton5.setAction(actionMap.get("removeChipTypes")); // NOI18N
        jButton5.setName("jButton5"); // NOI18N

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(onlyPedigreeCheckBox)
                        .addGap(30, 30, 30)
                        .addComponent(overwriteCheckBox)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 97, Short.MAX_VALUE)
                        .addComponent(jButton5, javax.swing.GroupLayout.PREFERRED_SIZE, 31, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(27, 27, 27))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                                .addComponent(jLabel2)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(chipTypeComboBox, 0, 298, Short.MAX_VALUE))
                            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                                .addComponent(jLabel3)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                    .addGroup(layout.createSequentialGroup()
                                        .addComponent(jButton1)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                        .addComponent(jButton2))
                                    .addComponent(folderTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 295, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addGap(6, 6, 6)
                                .addComponent(jButton3, javax.swing.GroupLayout.PREFERRED_SIZE, 31, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 371, Short.MAX_VALUE)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jLabel1)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(subNumberTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 128, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 162, Short.MAX_VALUE)
                                .addComponent(jButton4, javax.swing.GroupLayout.PREFERRED_SIZE, 26, javax.swing.GroupLayout.PREFERRED_SIZE)))
                        .addGap(26, 26, 26))))
        );

        layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {jButton4, jButton5});

        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(chipTypeComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.CENTER)
                    .addComponent(jLabel1)
                    .addComponent(subNumberTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton4, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 158, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(onlyPedigreeCheckBox)
                        .addComponent(overwriteCheckBox))
                    .addComponent(jButton5, javax.swing.GroupLayout.PREFERRED_SIZE, 24, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.CENTER)
                    .addComponent(jLabel3)
                    .addComponent(folderTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton3))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton1)
                    .addComponent(jButton2))
                .addContainerGap())
        );

        layout.linkSize(javax.swing.SwingConstants.VERTICAL, new java.awt.Component[] {jButton4, jButton5});

        pack();
    }// </editor-fold>//GEN-END:initComponents

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                GenerateSampleDialog dialog = new GenerateSampleDialog(new javax.swing.JFrame(), true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {

                    @Override
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }

        @Action(block = Task.BlockingScope.ACTION)
    public Task generate() {
        return new GenerateTask(org.jdesktop.application.Application.getInstance(org.cobi.igg3.gui.IGG3App.class));
    }

    private class GenerateTask extends org.jdesktop.application.Task<Object, Void> {

        boolean realSuccess = false;
        long startTime, endTime;

        GenerateTask(org.jdesktop.application.Application app) {
            // Runs on the EDT.  Copy GUI state that
            // doInBackground() depends on from parameters
            // to GenerateTask fields, here.
            super(app);
        }

        @Override
        protected Object doInBackground() {
            // Your Task's code here.  This method runs
            // on a background thread, so don't reference
            // the Swing GUI from here.
            try {
                int typeNumber = chipTypeListModel.size();
                if (typeNumber == 0) {
                    JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), "Please add chip types first!", "Error", JOptionPane.ERROR_MESSAGE);
                }
                ArrayList<String[]> types = new ArrayList<String[]>();
                List<String> chipTypes = new ArrayList<String>();
                for (int i = 0; i < typeNumber; i++) {
                    String chipType = chipTypeListModel.get(i).toString();
                    String[] items = chipType.split(" Subjects Number: ");
                    types.add(items);
                    chipTypes.add(items[0].trim());
                }
                if (chipTypes.size() == 0) {
                    JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(),
                            "Please add chip type and subject number first!", "Error", JOptionPane.ERROR_MESSAGE);
                    return null;
                }
                setVisible(false);
                String unAvailableFile = resourceManager.checkUnavailableChipAnnotFiles(chipTypes);
                if (unAvailableFile.length() > 0) {
                    Object[] options = {"Donwload Chip Annotation", "CANCEL"};
                    int response = JOptionPane.showOptionDialog(GlobalVariables.currentApplication.getMainFrame(), "The following annotaion data are not availalbe:\n" + unAvailableFile, "Message",
                            JOptionPane.DEFAULT_OPTION, JOptionPane.INFORMATION_MESSAGE,
                            null, options, options[0]);
                    if (response == 1) {
                        return null;
                    } else {
                        GlobalVariables.mainView.specifyChipAnnotFiles(unAvailableFile);
                        GlobalVariables.mainView.openDonloadChipAnnot();
                        return null;
                    }
                }

                startTime = System.currentTimeMillis();
                GlobalVariables.mainView.setBriefRunningIcons("start.gif");
                String path = folderTextField.getText();
                IGGTestDataGenerator generator = new IGGTestDataGenerator(types);
                generator.generateSimplePedFile(path);
                if (!onlyPedigreeCheckBox.isSelected()) {
                    generator.generateChipFiles(path, overwriteCheckBox.isSelected());
                }
                realSuccess = true;
            } catch (Exception ex) {
                JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), ex.toString(), "Error", JOptionPane.ERROR_MESSAGE);
            }
            return null;  // return your result

        }

        @Override
        protected void succeeded(Object result) {
            // Runs on the EDT.  Update the GUI based on
            // the result computed by doInBackground().
            if (realSuccess) {
                StringBuffer inforString = new StringBuffer();
                inforString.append("The Overall Lapsed Time: ");
                endTime = System.currentTimeMillis();
                inforString.append((endTime - startTime) / 1000.0);
                inforString.append(" Seconds.\n");

                GlobalVariables.mainView.setBriefRunningIcons("time.gif");
                GlobalVariables.mainView.setBriefRunningInfor("The generating proccess is finished. " + inforString.toString(), true);
                GlobalVariables.addInforLog(inforString.toString());
            //  ((IAHGIntegraterView) GlobalVariables.currentApplication.getMainView()).setToOpenExportDialog(true);
            // ((IAHGIntegraterView) GlobalVariables.currentApplication.getMainView()).setToOpenIntegrateHapMapDialog(true);
            }
        }
    }

    @Action
    public void cancel() {
        setVisible(false);
    }

    @Action
    public void choosePath() {
        JFileChooser fDialog = new MyJFileChooser();
        fDialog.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);

        String chipType = (String) chipTypeComboBox.getSelectedItem();
        fDialog.setDialogTitle("Load folder for sample data");

        int result = fDialog.showOpenDialog(this);
        try {
            if (result == JFileChooser.APPROVE_OPTION) {
                folderTextField.setText(fDialog.getSelectedFile().getCanonicalPath());
            }
        } catch (Exception ex) {
            JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), ex.toString(), "Error", JOptionPane.ERROR_MESSAGE);
        }
    }

    @Action
    public void addTypes() {
        String chipType = chipTypeComboBox.getSelectedItem().toString();
        chipTypeListModel.addElement(chipType + " Subjects Number: " + subNumberTextField.getText());
    }

    @Action
    public void removeChipTypes() {
        int[] selectedIx = chipList.getSelectedIndices();
        for (int i = selectedIx.length - 1; i >= 0; i--) {
            chipTypeListModel.removeElementAt(selectedIx[i]);
        }
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JList chipList;
    private javax.swing.JComboBox chipTypeComboBox;
    private javax.swing.JTextField folderTextField;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton4;
    private javax.swing.JButton jButton5;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JCheckBox onlyPedigreeCheckBox;
    private javax.swing.JCheckBox overwriteCheckBox;
    private javax.swing.JTextField subNumberTextField;
    // End of variables declaration//GEN-END:variables
}
