// (c) 2008-2009 Miaoxin Li
// This file is distributed as part of the IGG source code package
// and may not be redistributed in any form, without prior written
// permission from the author. Permission is granted for you to
// modify this file for your own personal use, but modified versions
// must retain this copyright notice and must not be distributed.
// Permission is granted for you to use this file to compile IGG.
// All computer programs have bugs. Use this file at your own risk.
// Saturday, January 17, 2009
/*
 * ImputationExportDialog.java
 *
 * Created on 2008�?2�?4�? 下午9:25
 */
package org.cobi.igg3.gui;

import java.io.File;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.swing.DefaultListModel;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import org.cobi.igg3.controller.ImputationExporter;
import org.cobi.igg3.entity.ExportSetting;
import org.cobi.igg3.entity.Integration;
import org.cobi.igg3.GlobalVariables;
import org.jdesktop.application.Action;
import org.jdesktop.application.Task;

/**
 *
 * @author  mxli
 */
public class ImputationExportDialog extends javax.swing.JDialog {

    DefaultListModel unSelectPhenotypeListModel = new DefaultListModel();
    DefaultListModel selectPhenotypeListModel = new DefaultListModel();
    DefaultListModel unSelectHapPhenotypeListModel = new DefaultListModel();
    DefaultListModel selectHapPhenotypeListModel = new DefaultListModel();
    Map<String, String> toolDescrption = new HashMap<String, String>();
    SepcifyExportRegionsJDialog sepcifyExportRegionsJDialog = null;

    /** Creates new form ImputationExportDialog */
    public ImputationExportDialog(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        List<String> traitNames = GlobalVariables.currentPedFile.getTraitNames();
        unSelectPhenotypeListModel.removeAllElements();
        unSelectHapPhenotypeListModel.removeAllElements();
        for (int i = 0; i < traitNames.size(); i++) {
            unSelectPhenotypeListModel.addElement(traitNames.get(i));
            unSelectHapPhenotypeListModel.addElement(traitNames.get(i));
        }
        setIconImage(GUIUtil.readImageIcon("igg.png").getImage());

        String descrpiton = "http://www.sph.umich.edu/csg/abecasis/MaCH/index.html";
        toolDescrption.put("MACH", descrpiton);
        descrpiton = "https://mathgen.stats.ox.ac.uk/impute/impute.html";
        toolDescrption.put("IMPUTE", descrpiton);
        descrpiton = "http://www.stat.auckland.ac.nz/~browning/beagle/beagle.html";
        toolDescrption.put("BEAGLE", descrpiton);
        descrpiton = "http://depts.washington.edu/ventures/UW_Technology/Express_Licenses/fastPHASE.php";
        toolDescrption.put("fastPhase", descrpiton);
        descrpiton = "http://www.sph.umich.edu/csg/abecasis/Merlin/tour/assoc.html  (Family-based)";
        toolDescrption.put("Merlin", descrpiton);
        toolLabel.setText(toolDescrption.get("IMPUTE"));
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel2 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        integratedDatasetComboBox = new javax.swing.JComboBox();
        phenotypeTabbedPane = new javax.swing.JTabbedPane();
        chipPhenoPanel = new javax.swing.JPanel();
        jScrollPane8 = new javax.swing.JScrollPane();
        jList4 = new javax.swing.JList(unSelectPhenotypeListModel);
        jScrollPane9 = new javax.swing.JScrollPane();
        jList3 = new javax.swing.JList(selectPhenotypeListModel);
        jPanel1 = new javax.swing.JPanel();
        jButton5 = new javax.swing.JButton();
        jButton6 = new javax.swing.JButton();
        jComboBox4 = new javax.swing.JComboBox();
        jLabel16 = new javax.swing.JLabel();
        hapPhenoPanel = new javax.swing.JPanel();
        jScrollPane10 = new javax.swing.JScrollPane();
        jList5 = new javax.swing.JList(unSelectPhenotypeListModel);
        jScrollPane11 = new javax.swing.JScrollPane();
        jList6 = new javax.swing.JList(selectPhenotypeListModel);
        jPanel3 = new javax.swing.JPanel();
        jButton7 = new javax.swing.JButton();
        jButton8 = new javax.swing.JButton();
        jComboBox5 = new javax.swing.JComboBox();
        jLabel17 = new javax.swing.JLabel();
        jPanel7 = new javax.swing.JPanel();
        jLabel25 = new javax.swing.JLabel();
        jTextField13 = new javax.swing.JTextField();
        jLabel26 = new javax.swing.JLabel();
        toolTabbedPane = new javax.swing.JTabbedPane();
        jPanel4 = new javax.swing.JPanel();
        seperateChromCheckBox = new javax.swing.JCheckBox();
        plinkFormatComboBox = new javax.swing.JComboBox();
        jLabel2 = new javax.swing.JLabel();
        jPanel5 = new javax.swing.JPanel();
        jLabel11 = new javax.swing.JLabel();
        toolComboBox = new javax.swing.JComboBox();
        toolLabel = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        jPanel14 = new javax.swing.JPanel();
        jLabel13 = new javax.swing.JLabel();
        pathTextField = new javax.swing.JTextField();
        jButton12 = new javax.swing.JButton();
        jLabel14 = new javax.swing.JLabel();
        prefixNameTextField = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        strandComboBox = new javax.swing.JComboBox();
        jLabel7 = new javax.swing.JLabel();
        genomeVersionComboBox = new javax.swing.JComboBox();
        jButton2 = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();
        jButton4 = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(org.cobi.igg3.gui.IGG3App.class).getContext().getResourceMap(ImputationExportDialog.class);
        setTitle(resourceMap.getString("Form.title")); // NOI18N
        setName("Form"); // NOI18N
        setResizable(false);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowOpened(java.awt.event.WindowEvent evt) {
                formWindowOpened(evt);
            }
        });

        jPanel2.setName("jPanel2"); // NOI18N

        jLabel1.setText(resourceMap.getString("jLabel1.text")); // NOI18N
        jLabel1.setName("jLabel1"); // NOI18N

        integratedDatasetComboBox.setModel(GlobalVariables.allIntegrationModel);
        integratedDatasetComboBox.setName("integratedDatasetComboBox"); // NOI18N
        integratedDatasetComboBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                integratedDatasetComboBoxActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(integratedDatasetComboBox, 0, 266, Short.MAX_VALUE)
                .addContainerGap())
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                .addContainerGap(16, Short.MAX_VALUE)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.CENTER)
                    .addComponent(jLabel1)
                    .addComponent(integratedDatasetComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
        );

        phenotypeTabbedPane.setEnabled(false);
        phenotypeTabbedPane.setName("phenotypeTabbedPane"); // NOI18N

        chipPhenoPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Phenotypes"));
        chipPhenoPanel.setName("chipPhenoPanel"); // NOI18N

        jScrollPane8.setBorder(javax.swing.BorderFactory.createTitledBorder("Available"));
        jScrollPane8.setName("jScrollPane8"); // NOI18N

        jList4.setModel(unSelectPhenotypeListModel);
        jList4.setName("jList4"); // NOI18N
        jScrollPane8.setViewportView(jList4);

        jScrollPane9.setBorder(javax.swing.BorderFactory.createTitledBorder("Selected"));
        jScrollPane9.setName("jScrollPane9"); // NOI18N

        jList3.setModel(selectPhenotypeListModel);
        jList3.setName("jList3"); // NOI18N
        jScrollPane9.setViewportView(jList3);

        jPanel1.setName("jPanel1"); // NOI18N

        javax.swing.ActionMap actionMap = org.jdesktop.application.Application.getInstance(org.cobi.igg3.gui.IGG3App.class).getContext().getActionMap(ImputationExportDialog.class, this);
        jButton5.setAction(actionMap.get("selectPhenotypes")); // NOI18N
        jButton5.setName("jButton5"); // NOI18N

        jButton6.setAction(actionMap.get("unSelectPhenotypes")); // NOI18N
        jButton6.setName("jButton6"); // NOI18N

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jButton5, javax.swing.GroupLayout.PREFERRED_SIZE, 28, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addComponent(jButton6, javax.swing.GroupLayout.PREFERRED_SIZE, 27, javax.swing.GroupLayout.PREFERRED_SIZE)
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap(23, Short.MAX_VALUE)
                .addComponent(jButton5)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButton6))
        );

        jComboBox4.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Affection Status", "Quantitative Trait", "Covariate" }));
        jComboBox4.setName("jComboBox4"); // NOI18N

        jLabel16.setText(resourceMap.getString("jLabel16.text")); // NOI18N
        jLabel16.setName("jLabel16"); // NOI18N

        javax.swing.GroupLayout chipPhenoPanelLayout = new javax.swing.GroupLayout(chipPhenoPanel);
        chipPhenoPanel.setLayout(chipPhenoPanelLayout);
        chipPhenoPanelLayout.setHorizontalGroup(
            chipPhenoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(chipPhenoPanelLayout.createSequentialGroup()
                .addGroup(chipPhenoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(chipPhenoPanelLayout.createSequentialGroup()
                        .addComponent(jLabel16)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jComboBox4, javax.swing.GroupLayout.PREFERRED_SIZE, 172, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(chipPhenoPanelLayout.createSequentialGroup()
                        .addComponent(jScrollPane8, javax.swing.GroupLayout.PREFERRED_SIZE, 147, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jScrollPane9, javax.swing.GroupLayout.DEFAULT_SIZE, 339, Short.MAX_VALUE)))
                .addContainerGap())
        );
        chipPhenoPanelLayout.setVerticalGroup(
            chipPhenoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(chipPhenoPanelLayout.createSequentialGroup()
                .addGroup(chipPhenoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel16)
                    .addComponent(jComboBox4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(chipPhenoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane9, javax.swing.GroupLayout.DEFAULT_SIZE, 116, Short.MAX_VALUE)
                    .addComponent(jScrollPane8, javax.swing.GroupLayout.DEFAULT_SIZE, 116, Short.MAX_VALUE)
                    .addComponent(jPanel1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );

        phenotypeTabbedPane.addTab(resourceMap.getString("chipPhenoPanel.TabConstraints.tabTitle"), chipPhenoPanel); // NOI18N

        hapPhenoPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Phenotypes"));
        hapPhenoPanel.setName("hapPhenoPanel"); // NOI18N

        jScrollPane10.setBorder(javax.swing.BorderFactory.createTitledBorder("Available"));
        jScrollPane10.setName("jScrollPane10"); // NOI18N

        jList5.setModel(unSelectHapPhenotypeListModel);
        jList5.setName("jList5"); // NOI18N
        jScrollPane10.setViewportView(jList5);

        jScrollPane11.setBorder(javax.swing.BorderFactory.createTitledBorder("Selected"));
        jScrollPane11.setName("jScrollPane11"); // NOI18N

        jList6.setModel(selectHapPhenotypeListModel);
        jList6.setName("jList6"); // NOI18N
        jScrollPane11.setViewportView(jList6);

        jPanel3.setName("jPanel3"); // NOI18N

        jButton7.setAction(actionMap.get("selectHapPhenotypes")); // NOI18N
        jButton7.setName("jButton7"); // NOI18N

        jButton8.setAction(actionMap.get("unSelectHapPhenotypes")); // NOI18N
        jButton8.setName("jButton8"); // NOI18N

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jButton7, javax.swing.GroupLayout.PREFERRED_SIZE, 28, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton8, javax.swing.GroupLayout.PREFERRED_SIZE, 27, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap(20, Short.MAX_VALUE)
                .addComponent(jButton7)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButton8))
        );

        jComboBox5.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Affection Status", "Quantitative Trait", "Covariate" }));
        jComboBox5.setName("jComboBox5"); // NOI18N

        jLabel17.setText(resourceMap.getString("jLabel17.text")); // NOI18N
        jLabel17.setName("jLabel17"); // NOI18N

        jPanel7.setName("jPanel7"); // NOI18N

        jLabel25.setFont(resourceMap.getFont("jLabel25.font")); // NOI18N
        jLabel25.setForeground(resourceMap.getColor("jLabel25.foreground")); // NOI18N
        jLabel25.setText(resourceMap.getString("jLabel25.text")); // NOI18N
        jLabel25.setName("jLabel25"); // NOI18N

        jTextField13.setText(resourceMap.getString("jTextField13.text")); // NOI18N
        jTextField13.setName("jTextField13"); // NOI18N

        jLabel26.setText(resourceMap.getString("jLabel26.text")); // NOI18N
        jLabel26.setName("jLabel26"); // NOI18N

        javax.swing.GroupLayout jPanel7Layout = new javax.swing.GroupLayout(jPanel7);
        jPanel7.setLayout(jPanel7Layout);
        jPanel7Layout.setHorizontalGroup(
            jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel7Layout.createSequentialGroup()
                .addComponent(jLabel25)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jTextField13, javax.swing.GroupLayout.PREFERRED_SIZE, 62, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel26)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel7Layout.setVerticalGroup(
            jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                .addComponent(jLabel25)
                .addComponent(jTextField13, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addComponent(jLabel26))
        );

        javax.swing.GroupLayout hapPhenoPanelLayout = new javax.swing.GroupLayout(hapPhenoPanel);
        hapPhenoPanel.setLayout(hapPhenoPanelLayout);
        hapPhenoPanelLayout.setHorizontalGroup(
            hapPhenoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(hapPhenoPanelLayout.createSequentialGroup()
                .addGroup(hapPhenoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(hapPhenoPanelLayout.createSequentialGroup()
                        .addComponent(jLabel17)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jComboBox5, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jPanel7, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(hapPhenoPanelLayout.createSequentialGroup()
                        .addComponent(jScrollPane10, javax.swing.GroupLayout.PREFERRED_SIZE, 137, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jScrollPane11, javax.swing.GroupLayout.DEFAULT_SIZE, 333, Short.MAX_VALUE)))
                .addContainerGap())
        );
        hapPhenoPanelLayout.setVerticalGroup(
            hapPhenoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(hapPhenoPanelLayout.createSequentialGroup()
                .addGroup(hapPhenoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(hapPhenoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(jLabel17)
                        .addComponent(jComboBox5, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jPanel7, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGroup(hapPhenoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(hapPhenoPanelLayout.createSequentialGroup()
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(hapPhenoPanelLayout.createSequentialGroup()
                        .addGap(8, 8, 8)
                        .addGroup(hapPhenoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jScrollPane11, javax.swing.GroupLayout.DEFAULT_SIZE, 114, Short.MAX_VALUE)
                            .addComponent(jScrollPane10, javax.swing.GroupLayout.DEFAULT_SIZE, 114, Short.MAX_VALUE))))
                .addContainerGap())
        );

        phenotypeTabbedPane.addTab(resourceMap.getString("hapPhenoPanel.TabConstraints.tabTitle"), hapPhenoPanel); // NOI18N

        toolTabbedPane.setName("toolTabbedPane"); // NOI18N

        jPanel4.setName("jPanel4"); // NOI18N

        seperateChromCheckBox.setText(resourceMap.getString("seperateChromCheckBox.text")); // NOI18N
        seperateChromCheckBox.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        seperateChromCheckBox.setName("seperateChromCheckBox"); // NOI18N

        plinkFormatComboBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Traditional format", "Binary format" }));
        plinkFormatComboBox.setName("plinkFormatComboBox"); // NOI18N

        jLabel2.setText(resourceMap.getString("jLabel2.text")); // NOI18N
        jLabel2.setName("jLabel2"); // NOI18N

        javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(plinkFormatComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, 155, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(79, 79, 79)
                .addComponent(seperateChromCheckBox)
                .addContainerGap(117, Short.MAX_VALUE))
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(plinkFormatComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(seperateChromCheckBox))
                .addContainerGap(61, Short.MAX_VALUE))
        );

        toolTabbedPane.addTab(resourceMap.getString("jPanel4.TabConstraints.tabTitle"), jPanel4); // NOI18N

        jPanel5.setName("jPanel5"); // NOI18N

        jLabel11.setText(resourceMap.getString("jLabel11.text")); // NOI18N
        jLabel11.setName("jLabel11"); // NOI18N

        toolComboBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "IMPUTE", "MACH", "BEAGLE", "fastPhase", "Merlin" }));
        toolComboBox.setName("toolComboBox"); // NOI18N
        toolComboBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                toolComboBoxActionPerformed(evt);
            }
        });

        toolLabel.setText(resourceMap.getString("toolLabel.text")); // NOI18N
        toolLabel.setName("toolLabel"); // NOI18N

        jLabel3.setText(resourceMap.getString("jLabel3.text")); // NOI18N
        jLabel3.setName("jLabel3"); // NOI18N

        javax.swing.GroupLayout jPanel5Layout = new javax.swing.GroupLayout(jPanel5);
        jPanel5.setLayout(jPanel5Layout);
        jPanel5Layout.setHorizontalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel5Layout.createSequentialGroup()
                .addComponent(jLabel11)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(toolComboBox, 0, 465, Short.MAX_VALUE)
                .addGap(20, 20, 20))
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addComponent(jLabel3)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(toolLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 515, Short.MAX_VALUE)
                .addContainerGap())
        );
        jPanel5Layout.setVerticalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel11)
                    .addComponent(toolComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.CENTER)
                    .addComponent(toolLabel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel3))
                .addContainerGap(37, Short.MAX_VALUE))
        );

        toolTabbedPane.addTab(resourceMap.getString("jPanel5.TabConstraints.tabTitle"), jPanel5); // NOI18N

        jPanel14.setBorder(javax.swing.BorderFactory.createTitledBorder("Files"));
        jPanel14.setName("jPanel14"); // NOI18N

        jLabel13.setText(resourceMap.getString("jLabel13.text")); // NOI18N
        jLabel13.setName("jLabel13"); // NOI18N

        pathTextField.setName("pathTextField"); // NOI18N

        jButton12.setAction(actionMap.get("browsePath")); // NOI18N
        jButton12.setName("jButton12"); // NOI18N

        jLabel14.setText(resourceMap.getString("jLabel14.text")); // NOI18N
        jLabel14.setName("jLabel14"); // NOI18N

        prefixNameTextField.setName("prefixNameTextField"); // NOI18N

        jLabel4.setText(resourceMap.getString("jLabel4.text")); // NOI18N
        jLabel4.setName("jLabel4"); // NOI18N

        strandComboBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Forward/+", "Reverse/-", "Never mind" }));
        strandComboBox.setName("strandComboBox"); // NOI18N

        jLabel7.setText(resourceMap.getString("jLabel7.text")); // NOI18N
        jLabel7.setName("jLabel7"); // NOI18N

        genomeVersionComboBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Build 36", "Build 37", "Build 35" }));
        genomeVersionComboBox.setName("genomeVersionComboBox"); // NOI18N

        javax.swing.GroupLayout jPanel14Layout = new javax.swing.GroupLayout(jPanel14);
        jPanel14.setLayout(jPanel14Layout);
        jPanel14Layout.setHorizontalGroup(
            jPanel14Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel14Layout.createSequentialGroup()
                .addGroup(jPanel14Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel14Layout.createSequentialGroup()
                        .addComponent(jLabel13)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(pathTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 478, Short.MAX_VALUE))
                    .addGroup(jPanel14Layout.createSequentialGroup()
                        .addComponent(jLabel14)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(prefixNameTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 109, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jLabel4)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(strandComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(jLabel7)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(genomeVersionComboBox, 0, 63, Short.MAX_VALUE)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButton12, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        jPanel14Layout.setVerticalGroup(
            jPanel14Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel14Layout.createSequentialGroup()
                .addGroup(jPanel14Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.CENTER)
                    .addComponent(jLabel13)
                    .addComponent(pathTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton12))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(jPanel14Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(jPanel14Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(jLabel14)
                        .addComponent(prefixNameTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanel14Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.CENTER)
                        .addComponent(strandComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(jLabel4)
                        .addGroup(jPanel14Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel7)
                            .addComponent(genomeVersionComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))))
        );

        jButton2.setAction(actionMap.get("export")); // NOI18N
        jButton2.setName("jButton2"); // NOI18N

        jButton3.setAction(actionMap.get("cancel")); // NOI18N
        jButton3.setName("jButton3"); // NOI18N

        jButton4.setAction(actionMap.get("pickupRegionsDialog")); // NOI18N
        jButton4.setName("jButton4"); // NOI18N

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(toolTabbedPane, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 557, Short.MAX_VALUE)
                    .addComponent(phenotypeTabbedPane, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 557, Short.MAX_VALUE)
                    .addComponent(jPanel2, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jPanel14, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                        .addComponent(jButton4)
                        .addGap(96, 96, 96)
                        .addComponent(jButton2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 199, Short.MAX_VALUE)
                        .addComponent(jButton3)
                        .addGap(23, 23, 23)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(phenotypeTabbedPane, javax.swing.GroupLayout.DEFAULT_SIZE, 208, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel14, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(toolTabbedPane, javax.swing.GroupLayout.PREFERRED_SIZE, 122, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton4)
                    .addComponent(jButton2)
                    .addComponent(jButton3))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

private void integratedDatasetComboBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_integratedDatasetComboBoxActionPerformed
// TODO add your handling code here:
    Object item = integratedDatasetComboBox.getSelectedItem();
    if (item != null) {
        Integration integration = (Integration) item;
        boolean isHapMap = integration.isHapMapSet();
        try {
            if (isHapMap) {
                phenotypeTabbedPane.setSelectedIndex(1);
            } else {
                phenotypeTabbedPane.setSelectedIndex(0);
            }
        } catch (Exception ex) {
            JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), ex.toString(), "Error", JOptionPane.ERROR_MESSAGE);
        }
    }
}//GEN-LAST:event_integratedDatasetComboBoxActionPerformed

private void formWindowOpened(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowOpened
// TODO add your handling code here:
    Object item = GlobalVariables.allIntegrationModel.getElementAt(0);
    if (item != null) {
        Integration integration = (Integration) item;
        boolean isHapMap = integration.isHapMapSet();
        if (isHapMap) {
            phenotypeTabbedPane.setSelectedIndex(1);
        } else {
            phenotypeTabbedPane.setSelectedIndex(0);
        }
    }
}//GEN-LAST:event_formWindowOpened

private void toolComboBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_toolComboBoxActionPerformed
// TODO add your handling code here:    
    String format = (String) toolComboBox.getSelectedItem();
    toolLabel.setText(toolDescrption.get(format));
}//GEN-LAST:event_toolComboBoxActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                ImputationExportDialog dialog = new ImputationExportDialog(new javax.swing.JFrame(), true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {

                    @Override
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }

    @Action
    public void selectHapPhenotypes() {
        int[] selectedIx = jList5.getSelectedIndices();
        for (int i = 0; i < selectedIx.length; i++) {
            selectHapPhenotypeListModel.addElement(unSelectHapPhenotypeListModel.getElementAt(selectedIx[i]) + " as " + (String) jComboBox5.getSelectedItem() + " assuming " + jTextField13.getText() + " for HapMap Sample");
        }
        for (int i = selectedIx.length - 1; i >= 0; i--) {
            unSelectHapPhenotypeListModel.removeElementAt(selectedIx[i]);
        }
    }

    @Action
    public void unSelectHapPhenotypes() {
        int[] selectedIx = jList6.getSelectedIndices();
        String tempStr = null;
        for (int i = 0; i < selectedIx.length; i++) {
            tempStr = (String) selectHapPhenotypeListModel.getElementAt(selectedIx[i]);
            unSelectHapPhenotypeListModel.addElement(tempStr.substring(0, tempStr.indexOf(" as ")));
        }
        for (int i = selectedIx.length - 1; i >= 0; i--) {
            selectHapPhenotypeListModel.removeElementAt(selectedIx[i]);
        }
    }

    @Action
    public void selectPhenotypes() {
        int[] selectedIx = jList4.getSelectedIndices();
        for (int i = 0; i < selectedIx.length; i++) {
            selectPhenotypeListModel.addElement(unSelectPhenotypeListModel.getElementAt(selectedIx[i]) + " as " + (String) jComboBox4.getSelectedItem());
        }
        for (int i = selectedIx.length - 1; i >= 0; i--) {
            unSelectPhenotypeListModel.removeElementAt(selectedIx[i]);
        }
    }

    @Action
    public void unSelectPhenotypes() {
        int[] selectedIx = jList3.getSelectedIndices();
        String tempStr = null;
        for (int i = 0; i < selectedIx.length; i++) {
            tempStr = (String) selectPhenotypeListModel.getElementAt(selectedIx[i]);
            unSelectPhenotypeListModel.addElement(tempStr.substring(0, tempStr.indexOf(" as ")));
        }
        for (int i = selectedIx.length - 1; i >= 0; i--) {
            selectPhenotypeListModel.removeElementAt(selectedIx[i]);
        }
    }

    @Action
    public void browsePath() {
        JFileChooser fDialog = null;
        if ((GlobalVariables.lastAccessedPath != null) && (GlobalVariables.lastAccessedPath.trim().length() > 0)) {
            fDialog = new JFileChooser(GlobalVariables.lastAccessedPath);
        } else {
            fDialog = new JFileChooser();
        }
        fDialog.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        int result = fDialog.showOpenDialog(this);
        if (result == JFileChooser.APPROVE_OPTION) {
            pathTextField.setText(fDialog.getSelectedFile().getAbsolutePath());
            GlobalVariables.lastAccessedPath = fDialog.getSelectedFile().getPath();
        }
    }

    @Action(block = Task.BlockingScope.ACTION)
    public Task export() {
        if (pathTextField.getText().trim().length() == 0) {
            JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(),
                    "Choose a folder please!",
                    "Error",
                    JOptionPane.ERROR_MESSAGE);
            return null;
        }

        if (selectPhenotypeListModel.isEmpty() && selectHapPhenotypeListModel.isEmpty()) {
            Object[] options = {"Yes", "No"};
            int response = JOptionPane.showOptionDialog(this, "You havenot choosen any phenotypes, do you want to continue?", "Phenotype Confirmation",
                    JOptionPane.YES_OPTION, JOptionPane.QUESTION_MESSAGE, null, options, options[0]);
            if (response == 1) {
                return null;
            }
        }
        Integration itegration = (Integration) integratedDatasetComboBox.getSelectedItem();
        boolean isHapSet = itegration.isHapMapSet();
        if (!isHapSet) {
            int anwser = JOptionPane.showConfirmDialog(GlobalVariables.currentApplication.getMainFrame(),
                    "This integration \'"+itegration.getName()+"\' does not contain HapMap genotypes and\n"
                    + "may be NOT appropriate to export for imputation!! Do you want to cancel this exporting?", "Warning!", JOptionPane.OK_CANCEL_OPTION);
            if (anwser == 0) {
                return null;
            }
        }

        return new ExportTask(org.jdesktop.application.Application.getInstance(org.cobi.igg3.gui.IGG3App.class));
    }

    private class ExportTask extends org.jdesktop.application.Task<Object, Void> {

        boolean realSuccess = false;
        long startTime, endTime;

        ExportTask(org.jdesktop.application.Application app) {
            // Runs on the EDT.  Copy GUI state that
            // doInBackground() depends on from parameters
            // to ExportTask fields, here.            
            super(app);
        }

        @Override
        protected Object doInBackground() {
            // Your Task's code here.  This method runs
            // on a background thread, so don't reference
            // the Swing GUI from here.
            Integration itegration = (Integration) integratedDatasetComboBox.getSelectedItem();
            boolean isHapSet = itegration.isHapMapSet();
            ExportSetting exportSetting = new ExportSetting();
            char strandInfor = '+';
            File commPedFile = new File(itegration.getResultPath() + File.separator + "ped");

            try {
                if (commPedFile.exists()) {
                    GlobalVariables.currentPedFile.readCommonPedigrees(commPedFile.getCanonicalPath());
                }

                if (isHapSet) {
                    for (int j = 0; j < selectHapPhenotypeListModel.size(); j++) {
                        String tempStr = (String) selectHapPhenotypeListModel.get(j);
                        int index = tempStr.indexOf(" as ");
                        String[] cells = new String[3];
                        cells[0] = tempStr.substring(0, index);
                        tempStr = tempStr.substring(index + 4);
                        index = tempStr.indexOf(" assuming ");
                        cells[1] = tempStr.substring(0, index);
                        tempStr = tempStr.substring(index + 10);
                        index = tempStr.indexOf(" for HapMap");
                        cells[2] = tempStr.substring(0, index);
                        exportSetting.addTraitProper(cells);
                    }
                } else {
                    for (int j = 0; j < selectPhenotypeListModel.size(); j++) {
                        String tempStr = (String) selectPhenotypeListModel.get(j);
                        int index = tempStr.indexOf(" as ");
                        String[] cells = new String[3];
                        cells[0] = tempStr.substring(0, index);
                        cells[1] = tempStr.substring(index + 4);
                        cells[2] = "-";
                        exportSetting.addTraitProper(cells);
                    }
                }
                String path = pathTextField.getText();
                path = path + File.separator;
                String prefix = prefixNameTextField.getText();
                String format = "Plink";
                if (toolTabbedPane.getSelectedIndex() == 1) {
                    format = toolComboBox.getSelectedItem().toString();
                } else {
                    format = "Plink";
                }
                //format.equals("MACH") || format.equals("IMPUTE") ||
                if (toolTabbedPane.getSelectedIndex() == 1 && !itegration.isHapMapPhased() && (format.equals("BEAGLE") || format.equals("fastPhase"))) {
                    JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), "Sorry, I cannot generate input files for " + format
                            + " because the integration you are choosing have no phased genotypes!!", "Error", JOptionPane.ERROR_MESSAGE);
                    return null;
                }
                if (strandComboBox.getSelectedIndex() == 1) {
                    strandInfor = '-';
                } else if (strandComboBox.getSelectedIndex() == 2) {
                    strandInfor = '0';
                }
                exportSetting.setStrandOut(strandInfor);

                String missingGenotypes = "0 0";
                if (missingGenotypes.length() == 2) {
                    missingGenotypes = missingGenotypes.substring(0, 1) + " " + missingGenotypes.substring(1);
                } else if (missingGenotypes.length() == 1) {
                    missingGenotypes = missingGenotypes + " " + missingGenotypes;
                }
                if (prefix.length() == 0) {
                    prefix = format;
                }
                exportSetting.setExportPath(path);
                exportSetting.setPrefixFileName(prefix);
                exportSetting.setToolName(format);
                exportSetting.setMissingGty(missingGenotypes);
                exportSetting.setRemoveBadMendel(true);
                exportSetting.setRemoveMissingAll(true);
                exportSetting.setNumberAllele(true);
                exportSetting.setSeparateByChrom(seperateChromCheckBox.isSelected());
                exportSetting.setCorrectAnnoFreq(false);

                if (sepcifyExportRegionsJDialog != null) {
                    exportSetting.setSelectedRegions(sepcifyExportRegionsJDialog.selectedRegionMap);
                }
                setVisible(false);
                startTime = System.currentTimeMillis();
                GlobalVariables.mainView.setBriefRunningIcons("start.gif");
                GlobalVariables.mainView.setBriefRunningInfor("Generating input files for " + format + " \nPlease wait...\n", true);
                GlobalVariables.addInforLog("Generating input files for " + format);
                ImputationExporter generator = new ImputationExporter();
                generator.setExportSetting(exportSetting);
                generator.setIntegrator(itegration);


                if (genomeVersionComboBox.getSelectedItem().toString().equals("Build 35")) {
                    generator.setExportGenomeVersion(35);
                } else if (genomeVersionComboBox.getSelectedItem().toString().equals("Build 37")) {
                    generator.setExportGenomeVersion(37);
                } else if (genomeVersionComboBox.getSelectedItem().toString().equals("Build 36")) {
                    generator.setExportGenomeVersion(36);
                }

                String comment = "";
                if (toolTabbedPane.getSelectedIndex() == 1) {
                    if (format.equals("Merlin")) {
                        comment = generator.exportMerlin2Imputation();
                    } else if (format.equals("MACH")) {
                        comment = generator.exportMach2Imputation();
                    } else if (format.equals("IMPUTE")) {
                        comment = generator.exportImpute2Imputation();
                    } else if (itegration.isHapMapPhased()) {
                        if (format.equals("BEAGLE")) {
                            comment = generator.exportBEAGLE2Imputation();
                        } else if (format.equals("fastPhase")) {
                            comment = generator.exportPHASE2Imputation();
                        }
                    } else {
                        JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), "Sorry, I cannot generate input files for " + format
                                + " because the integration you are choosing have no phased genotypes!!", "Error", JOptionPane.ERROR_MESSAGE);
                    }

                } else {
                    if (plinkFormatComboBox.getSelectedItem().toString().equals("Traditional format")) {
                        comment = generator.exportPlink2ImputationTraditional();
                    } else {
                        comment = generator.exportPlink2ImputationBinary();
                    }

                    GlobalVariables.mainView.setBriefRunningIcons("save_edit.gif");
                }
                GlobalVariables.mainView.setBriefRunningInfor(comment, true);

                realSuccess = true;
            } catch (Exception ex) {
                JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), ex.toString(), "Error", JOptionPane.ERROR_MESSAGE);
            } finally {
                try {
                    if (commPedFile.exists()) {
                        GlobalVariables.currentPedFile.unloadCommonPedigrees();
                    }
                } catch (Exception ex) {
                    JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), ex.toString(), "Error", JOptionPane.ERROR_MESSAGE);
                }
            }
            return null;  // return your result

        }

        @Override
        protected void succeeded(Object result) {
            // Runs on the EDT.  Update the GUI based on
            // the result computed by doInBackground().
            if (realSuccess) {
                // export data with different format
                StringBuilder inforString = new StringBuilder();
                inforString.append("The Overall Lapsed Time: ");
                endTime = System.currentTimeMillis();
                inforString.append((endTime - startTime) / 1000.0);
                inforString.append(" Seconds.\n");

                GlobalVariables.mainView.setBriefRunningIcons("time.gif");
                GlobalVariables.mainView.setBriefRunningInfor("The exporting proccess is finished. " + inforString.toString(), true);
                GlobalVariables.addInforLog(inforString.toString());
            }
        }
    }

    @Action
    public void cancel() {
        setVisible(false);
    }

    @Action
    public void pickupRegionsDialog() {
        if (sepcifyExportRegionsJDialog == null) {
            sepcifyExportRegionsJDialog = new SepcifyExportRegionsJDialog(GlobalVariables.currentApplication.getMainFrame(), true);
            sepcifyExportRegionsJDialog.setLocationRelativeTo(GlobalVariables.currentApplication.getMainFrame());
        }
        sepcifyExportRegionsJDialog.listRegions((Integration) integratedDatasetComboBox.getSelectedItem());
        IGG3App.getApplication().show(sepcifyExportRegionsJDialog);
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel chipPhenoPanel;
    private javax.swing.JComboBox genomeVersionComboBox;
    private javax.swing.JPanel hapPhenoPanel;
    private javax.swing.JComboBox integratedDatasetComboBox;
    private javax.swing.JButton jButton12;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton4;
    private javax.swing.JButton jButton5;
    private javax.swing.JButton jButton6;
    private javax.swing.JButton jButton7;
    private javax.swing.JButton jButton8;
    private javax.swing.JComboBox jComboBox4;
    private javax.swing.JComboBox jComboBox5;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel16;
    private javax.swing.JLabel jLabel17;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel25;
    private javax.swing.JLabel jLabel26;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JList jList3;
    private javax.swing.JList jList4;
    private javax.swing.JList jList5;
    private javax.swing.JList jList6;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel14;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JScrollPane jScrollPane10;
    private javax.swing.JScrollPane jScrollPane11;
    private javax.swing.JScrollPane jScrollPane8;
    private javax.swing.JScrollPane jScrollPane9;
    private javax.swing.JTextField jTextField13;
    private javax.swing.JTextField pathTextField;
    private javax.swing.JTabbedPane phenotypeTabbedPane;
    private javax.swing.JComboBox plinkFormatComboBox;
    private javax.swing.JTextField prefixNameTextField;
    private javax.swing.JCheckBox seperateChromCheckBox;
    private javax.swing.JComboBox strandComboBox;
    private javax.swing.JComboBox toolComboBox;
    private javax.swing.JTextField toolLabel;
    private javax.swing.JTabbedPane toolTabbedPane;
    // End of variables declaration//GEN-END:variables
}
