// (c) 2008-2009 Miaoxin Li
// This file is distributed as part of the IGG source code package
// and may not be redistributed in any form, without prior written
// permission from the author. Permission is granted for you to
// modify this file for your own personal use, but modified versions
// must retain this copyright notice and must not be distributed.

// Permission is granted for you to use this file to compile IGG.

// All computer programs have bugs. Use this file at your own risk.
// Saturday, January 17, 2009
/*
 * IntegrateGenomeRegionDialog.java
 *
 * Created on 2008�?2�?�? 下午6:01
 */
package org.cobi.igg3.gui;

import java.io.File;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import javax.swing.DefaultListModel;
import javax.swing.JOptionPane;
import org.cobi.igg3.Constants;
import org.cobi.igg3.controller.CommonGenetDatasetIntegrator;
import org.cobi.igg3.controller.RegionGenomeChipIntegrator;
import org.cobi.igg3.controller.ResourceManager;
import org.cobi.igg3.entity.Integration;
import org.cobi.igg3.GlobalVariables;
import org.jdesktop.application.Action;
import org.jdesktop.application.Task;

/**
 *
 * @author  Miaoxin Li
 */
public class IntegrateGenomeRegionDialog extends javax.swing.JDialog implements Constants {

    DefaultListModel unSelectChromListModel = new DefaultListModel();
    DefaultListModel selectChromListModel = new DefaultListModel();

    /** Creates new form IntegrateGenomeRegionDialog */
    public IntegrateGenomeRegionDialog(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        for (int i = 0; i < CHROM_NAME.length; i++) {
            unSelectChromListModel.add(i, CHROM_NAME[i]);
        }
        setIconImage(GUIUtil.readImageIcon("igg.png").getImage());
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel7 = new javax.swing.JPanel();
        jScrollPane6 = new javax.swing.JScrollPane();
        jList1 = new javax.swing.JList(unSelectChromListModel);
        jPanel9 = new javax.swing.JPanel();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jScrollPane7 = new javax.swing.JScrollPane();
        jList2 = new javax.swing.JList(selectChromListModel);
        jPanel12 = new javax.swing.JPanel();
        setGenetRegionCheckBox = new javax.swing.JCheckBox();
        jLabel5 = new javax.swing.JLabel();
        geneticFromTextField = new javax.swing.JTextField();
        jLabel6 = new javax.swing.JLabel();
        geneticToTextField = new javax.swing.JTextField();
        jLabel9 = new javax.swing.JLabel();
        jLabel10 = new javax.swing.JLabel();
        jPanel10 = new javax.swing.JPanel();
        setPhysicalRegionCheckBox = new javax.swing.JCheckBox();
        jLabel3 = new javax.swing.JLabel();
        physicalFromTextField = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        physicalToTextField = new javax.swing.JTextField();
        jLabel7 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        jPanel15 = new javax.swing.JPanel();
        jLabel15 = new javax.swing.JLabel();
        freqPopulationComboBox = new javax.swing.JComboBox();
        jLabel1 = new javax.swing.JLabel();
        integrationNameTextField = new javax.swing.JTextField();
        jButton3 = new javax.swing.JButton();
        jButton4 = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(org.cobi.igg3.gui.IGG3App.class).getContext().getResourceMap(IntegrateGenomeRegionDialog.class);
        setTitle(resourceMap.getString("Form.title")); // NOI18N
        setName("Form"); // NOI18N
        setResizable(false);

        jPanel7.setBorder(javax.swing.BorderFactory.createTitledBorder("Chromosomes of Genome"));
        jPanel7.setToolTipText(resourceMap.getString("jPanel7.toolTipText")); // NOI18N
        jPanel7.setName("jPanel7"); // NOI18N

        jScrollPane6.setBorder(javax.swing.BorderFactory.createTitledBorder("Available"));
        jScrollPane6.setName("jScrollPane6"); // NOI18N

        jList1.setToolTipText(resourceMap.getString("jList1.toolTipText")); // NOI18N
        jList1.setName("jList1"); // NOI18N
        jScrollPane6.setViewportView(jList1);

        jPanel9.setName("jPanel9"); // NOI18N

        javax.swing.ActionMap actionMap = org.jdesktop.application.Application.getInstance(org.cobi.igg3.gui.IGG3App.class).getContext().getActionMap(IntegrateGenomeRegionDialog.class, this);
        jButton1.setAction(actionMap.get("selectChromomsomes")); // NOI18N
        jButton1.setName("jButton1"); // NOI18N

        jButton2.setAction(actionMap.get("unSelectChromosome")); // NOI18N
        jButton2.setName("jButton2"); // NOI18N

        javax.swing.GroupLayout jPanel9Layout = new javax.swing.GroupLayout(jPanel9);
        jPanel9.setLayout(jPanel9Layout);
        jPanel9Layout.setHorizontalGroup(
            jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jButton2, javax.swing.GroupLayout.PREFERRED_SIZE, 31, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addComponent(jButton1, javax.swing.GroupLayout.PREFERRED_SIZE, 31, javax.swing.GroupLayout.PREFERRED_SIZE)
        );
        jPanel9Layout.setVerticalGroup(
            jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel9Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jButton1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 30, Short.MAX_VALUE)
                .addComponent(jButton2)
                .addGap(30, 30, 30))
        );

        jScrollPane7.setBorder(javax.swing.BorderFactory.createTitledBorder("Selected"));
        jScrollPane7.setName("jScrollPane7"); // NOI18N

        jList2.setName("jList2"); // NOI18N
        jScrollPane7.setViewportView(jList2);

        javax.swing.GroupLayout jPanel7Layout = new javax.swing.GroupLayout(jPanel7);
        jPanel7.setLayout(jPanel7Layout);
        jPanel7Layout.setHorizontalGroup(
            jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel7Layout.createSequentialGroup()
                .addComponent(jScrollPane6, javax.swing.GroupLayout.PREFERRED_SIZE, 89, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel9, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(14, 14, 14)
                .addComponent(jScrollPane7, javax.swing.GroupLayout.PREFERRED_SIZE, 87, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        jPanel7Layout.setVerticalGroup(
            jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel7Layout.createSequentialGroup()
                .addGap(60, 60, 60)
                .addComponent(jPanel9, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
            .addComponent(jScrollPane7, javax.swing.GroupLayout.DEFAULT_SIZE, 190, Short.MAX_VALUE)
            .addComponent(jScrollPane6, javax.swing.GroupLayout.DEFAULT_SIZE, 190, Short.MAX_VALUE)
        );

        jPanel12.setBorder(javax.swing.BorderFactory.createTitledBorder("Genetic Map Region"));
        jPanel12.setName("jPanel12"); // NOI18N

        setGenetRegionCheckBox.setAction(actionMap.get("setGenetMapRegion")); // NOI18N
        setGenetRegionCheckBox.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        setGenetRegionCheckBox.setMargin(new java.awt.Insets(0, 0, 0, 0));
        setGenetRegionCheckBox.setName("setGenetRegionCheckBox"); // NOI18N
        setGenetRegionCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                setGenetRegionCheckBoxActionPerformed(evt);
            }
        });

        jLabel5.setText(resourceMap.getString("jLabel5.text")); // NOI18N
        jLabel5.setName("jLabel5"); // NOI18N

        geneticFromTextField.setEnabled(false);
        geneticFromTextField.setFocusCycleRoot(true);
        geneticFromTextField.setName("geneticFromTextField"); // NOI18N

        jLabel6.setText(resourceMap.getString("jLabel6.text")); // NOI18N
        jLabel6.setName("jLabel6"); // NOI18N

        geneticToTextField.setEnabled(false);
        geneticToTextField.setName("geneticToTextField"); // NOI18N

        jLabel9.setText(resourceMap.getString("jLabel9.text")); // NOI18N
        jLabel9.setName("jLabel9"); // NOI18N

        jLabel10.setText(resourceMap.getString("jLabel10.text")); // NOI18N
        jLabel10.setName("jLabel10"); // NOI18N

        javax.swing.GroupLayout jPanel12Layout = new javax.swing.GroupLayout(jPanel12);
        jPanel12.setLayout(jPanel12Layout);
        jPanel12Layout.setHorizontalGroup(
            jPanel12Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel12Layout.createSequentialGroup()
                .addGroup(jPanel12Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(setGenetRegionCheckBox)
                    .addGroup(jPanel12Layout.createSequentialGroup()
                        .addGroup(jPanel12Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel5)
                            .addComponent(jLabel6))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel12Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(geneticToTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 174, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(geneticFromTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 170, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel12Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jLabel9)
                    .addComponent(jLabel10))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jPanel12Layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {geneticFromTextField, geneticToTextField});

        jPanel12Layout.setVerticalGroup(
            jPanel12Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel12Layout.createSequentialGroup()
                .addComponent(setGenetRegionCheckBox)
                .addGap(8, 8, 8)
                .addGroup(jPanel12Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel5)
                    .addComponent(jLabel9)
                    .addComponent(geneticFromTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(5, 5, 5)
                .addGroup(jPanel12Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel6)
                    .addComponent(jLabel10)
                    .addComponent(geneticToTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
        );

        jPanel10.setBorder(javax.swing.BorderFactory.createTitledBorder("Physical Region"));
        jPanel10.setName("jPanel10"); // NOI18N

        setPhysicalRegionCheckBox.setAction(actionMap.get("setPhysicalRegion")); // NOI18N
        setPhysicalRegionCheckBox.setText(resourceMap.getString("setPhysicalRegionCheckBox.text")); // NOI18N
        setPhysicalRegionCheckBox.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        setPhysicalRegionCheckBox.setMargin(new java.awt.Insets(0, 0, 0, 0));
        setPhysicalRegionCheckBox.setName("setPhysicalRegionCheckBox"); // NOI18N
        setPhysicalRegionCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                setPhysicalRegionCheckBoxActionPerformed(evt);
            }
        });

        jLabel3.setText(resourceMap.getString("jLabel3.text")); // NOI18N
        jLabel3.setName("jLabel3"); // NOI18N

        physicalFromTextField.setEnabled(false);
        physicalFromTextField.setName("physicalFromTextField"); // NOI18N

        jLabel4.setText(resourceMap.getString("jLabel4.text")); // NOI18N
        jLabel4.setName("jLabel4"); // NOI18N

        physicalToTextField.setEnabled(false);
        physicalToTextField.setName("physicalToTextField"); // NOI18N

        jLabel7.setText(resourceMap.getString("jLabel7.text")); // NOI18N
        jLabel7.setName("jLabel7"); // NOI18N

        jLabel8.setText(resourceMap.getString("jLabel8.text")); // NOI18N
        jLabel8.setName("jLabel8"); // NOI18N

        javax.swing.GroupLayout jPanel10Layout = new javax.swing.GroupLayout(jPanel10);
        jPanel10.setLayout(jPanel10Layout);
        jPanel10Layout.setHorizontalGroup(
            jPanel10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel10Layout.createSequentialGroup()
                .addGroup(jPanel10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(setPhysicalRegionCheckBox)
                    .addGroup(jPanel10Layout.createSequentialGroup()
                        .addGroup(jPanel10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel3)
                            .addComponent(jLabel4))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(physicalToTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 179, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(physicalFromTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 175, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jLabel7)
                    .addComponent(jLabel8))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jPanel10Layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {physicalFromTextField, physicalToTextField});

        jPanel10Layout.setVerticalGroup(
            jPanel10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel10Layout.createSequentialGroup()
                .addComponent(setPhysicalRegionCheckBox)
                .addGap(8, 8, 8)
                .addGroup(jPanel10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.CENTER)
                    .addComponent(jLabel3)
                    .addComponent(physicalFromTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel7))
                .addGap(5, 5, 5)
                .addGroup(jPanel10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.CENTER)
                    .addComponent(jLabel4)
                    .addComponent(physicalToTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel8)))
        );

        jPanel15.setBorder(javax.swing.BorderFactory.createTitledBorder("Settings"));
        jPanel15.setName("jPanel15"); // NOI18N

        jLabel15.setText(resourceMap.getString("jLabel15.text")); // NOI18N
        jLabel15.setName("jLabel15"); // NOI18N

        freqPopulationComboBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Asian Population", "Caucasian Population", "African Population" }));
        freqPopulationComboBox.setName("freqPopulationComboBox"); // NOI18N

        jLabel1.setText(resourceMap.getString("jLabel1.text")); // NOI18N
        jLabel1.setName("jLabel1"); // NOI18N

        integrationNameTextField.setText(resourceMap.getString("integrationNameTextField.text")); // NOI18N
        integrationNameTextField.setName("integrationNameTextField"); // NOI18N

        javax.swing.GroupLayout jPanel15Layout = new javax.swing.GroupLayout(jPanel15);
        jPanel15.setLayout(jPanel15Layout);
        jPanel15Layout.setHorizontalGroup(
            jPanel15Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel15Layout.createSequentialGroup()
                .addGroup(jPanel15Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel15Layout.createSequentialGroup()
                        .addComponent(jLabel15)
                        .addGap(12, 12, 12)
                        .addComponent(freqPopulationComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, 228, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanel15Layout.createSequentialGroup()
                        .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 38, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(integrationNameTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 324, Short.MAX_VALUE)))
                .addContainerGap())
        );
        jPanel15Layout.setVerticalGroup(
            jPanel15Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel15Layout.createSequentialGroup()
                .addGroup(jPanel15Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(integrationNameTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(jPanel15Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.CENTER)
                    .addComponent(freqPopulationComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, 23, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel15, javax.swing.GroupLayout.PREFERRED_SIZE, 23, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(77, 77, 77))
        );

        jButton3.setAction(actionMap.get("integrate")); // NOI18N
        jButton3.setName("jButton3"); // NOI18N

        jButton4.setAction(actionMap.get("cancelDialog")); // NOI18N
        jButton4.setName("jButton4"); // NOI18N

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jPanel7, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jPanel10, javax.swing.GroupLayout.PREFERRED_SIZE, 248, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jPanel12, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(68, 68, 68)
                        .addComponent(jButton3)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 184, Short.MAX_VALUE)
                        .addComponent(jButton4)
                        .addGap(127, 127, 127))
                    .addComponent(jPanel15, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jPanel10, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jPanel12, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jPanel7, 0, 204, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jPanel15, javax.swing.GroupLayout.PREFERRED_SIZE, 82, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton3)
                    .addComponent(jButton4))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

private void setGenetRegionCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_setGenetRegionCheckBoxActionPerformed
    if (setGenetRegionCheckBox.isSelected()) {
        geneticFromTextField.setEnabled(true);
        geneticToTextField.setEnabled(true);
        setPhysicalRegionCheckBox.setSelected(false);
        physicalFromTextField.setEnabled(false);
        physicalToTextField.setEnabled(false);
    } else {
        geneticFromTextField.setEnabled(false);
        geneticToTextField.setEnabled(false);
    }
}//GEN-LAST:event_setGenetRegionCheckBoxActionPerformed

private void setPhysicalRegionCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_setPhysicalRegionCheckBoxActionPerformed
    if (setPhysicalRegionCheckBox.isSelected()) {
        physicalFromTextField.setEnabled(true);
        physicalToTextField.setEnabled(true);
        setGenetRegionCheckBox.setSelected(false);
        geneticFromTextField.setEnabled(false);
        geneticToTextField.setEnabled(false);
    } else {
        physicalFromTextField.setEnabled(false);
        physicalToTextField.setEnabled(false);
    }
}//GEN-LAST:event_setPhysicalRegionCheckBoxActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                IntegrateGenomeRegionDialog dialog = new IntegrateGenomeRegionDialog(new javax.swing.JFrame(), true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {

                    @Override
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }

    @Action
    public void selectChromomsomes() {
        int[] selectedIx = jList1.getSelectedIndices();
        for (int i = 0; i < selectedIx.length; i++) {
            selectChromListModel.addElement(unSelectChromListModel.getElementAt(selectedIx[i]));
        }
        for (int i = selectedIx.length - 1; i >= 0; i--) {
            unSelectChromListModel.removeElementAt(selectedIx[i]);
        }
    }

    @Action
    public void unSelectChromosome() {
        int[] selectedIx = jList2.getSelectedIndices();
        for (int i = 0; i < selectedIx.length; i++) {
            unSelectChromListModel.addElement(selectChromListModel.getElementAt(selectedIx[i]));
        }
        for (int i = selectedIx.length - 1; i >= 0; i--) {
            selectChromListModel.removeElementAt(selectedIx[i]);
        }
    }

    @Action
    public void setGenetMapRegion() {
        if (setGenetRegionCheckBox.isSelected()) {
            geneticFromTextField.setEnabled(true);
            geneticToTextField.setEnabled(true);
            setPhysicalRegionCheckBox.setSelected(false);
            physicalFromTextField.setEnabled(false);
            physicalToTextField.setEnabled(false);
        } else {
            geneticFromTextField.setEnabled(false);
            geneticToTextField.setEnabled(false);
        }
    }

    @Action
    public void setPhysicalRegion() {
        if (setPhysicalRegionCheckBox.isSelected()) {
            physicalFromTextField.setEnabled(true);
            physicalToTextField.setEnabled(true);
            setGenetRegionCheckBox.setSelected(false);
            geneticFromTextField.setEnabled(false);
            geneticToTextField.setEnabled(false);
        } else {
            physicalFromTextField.setEnabled(false);
            physicalToTextField.setEnabled(false);
        }
    }

    @Action
    public void cancelDialog() {
        setVisible(false);
    }

    @Action(block = Task.BlockingScope.ACTION)
    public Task integrate() {
        return new IntegrateTask(org.jdesktop.application.Application.getInstance(org.cobi.igg3.gui.IGG3App.class));
    }

    private class IntegrateTask extends org.jdesktop.application.Task<Object, Void> {

        boolean realSuccess = false;
        long startTime, endTime;

        IntegrateTask(org.jdesktop.application.Application app) {
            // Runs on the EDT.  Copy GUI state that
            // doInBackground() depends on from parameters
            // to IntegrateTask fields, here.
            super(app);
        }

        @Override
        protected Object doInBackground() {
            // Your Task's code here.  This method runs
            // on a background thread, so don't reference
            // the Swing GUI from here.
            ArrayList<String> chipTypes = new ArrayList<String>();
            ResourceManager resourceManager = new ResourceManager();
            Iterator iter = GlobalVariables.currentProject.getChipFilePathList().keySet().iterator();
            boolean availableName = GlobalVariables.currentProject.isAvailableIntegrationName(integrationNameTextField.getText());
            if (availableName) {
                JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), "Please set a new integration name!", "Error", JOptionPane.ERROR_MESSAGE);
                return null;
            }
            setVisible(false);
            try {
                while (iter.hasNext()) {
                    Object key = iter.next();
                    chipTypes.add(key.toString());
                }
                String unAvailableFile = resourceManager.checkUnavailableChipAnnotFiles(chipTypes);
                if (unAvailableFile.length() > 0) {
                    Object[] options = {"Donwload Chip Annotation", "CANCEL"};
                    int response = JOptionPane.showOptionDialog(GlobalVariables.currentApplication.getMainFrame(), "The following annotaion data are not availalbe:\n" + unAvailableFile, "Message",
                            JOptionPane.DEFAULT_OPTION, JOptionPane.INFORMATION_MESSAGE,
                            null, options, options[0]);
                    if (response == 1) {
                        return null;
                    } else {
                        GlobalVariables.mainView.specifyChipAnnotFiles(unAvailableFile);
                        GlobalVariables.mainView.openDonloadChipAnnot();
                        return null;
                    }
                }
                startTime = System.currentTimeMillis();
                GlobalVariables.mainView.setBriefRunningIcons("start.gif");

                Integration integration = new Integration(integrationNameTextField.getText(),
                        (String) freqPopulationComboBox.getSelectedItem(),
                        GlobalVariables.currentProject.getWorkingPath() +
                        File.separator + integrationNameTextField.getText());

                List<String> chors = new ArrayList<String>();

                if (setGenetRegionCheckBox.isSelected()) {
                    double p1 = Double.parseDouble(geneticFromTextField.getText());
                    double p2 = Double.parseDouble(geneticToTextField.getText());
                    for (int i = 0; i < selectChromListModel.size(); i++) {
                        double[] sdPoint = {p1, p2};
                        integration.addGenetRegionMap(selectChromListModel.get(i).toString(), sdPoint);
                        chors.add(selectChromListModel.get(i).toString());
                    }
                } else if (setPhysicalRegionCheckBox.isSelected()) {
                    long p1 = Long.parseLong(physicalFromTextField.getText());
                    long p2 = Long.parseLong(physicalToTextField.getText());
                    for (int i = 0; i < selectChromListModel.size(); i++) {
                        long[] sdPoint = {p1, p2};
                        integration.addPhysicalRegionMap(selectChromListModel.get(i).toString(), sdPoint);
                        chors.add(selectChromListModel.get(i).toString());
                    }
                } else {
                    for (int i = 0; i < selectChromListModel.size(); i++) {
                        long[] sdPoint = {-9, -9};
                        integration.addPhysicalRegionMap(selectChromListModel.get(i).toString(), sdPoint);
                        chors.add(selectChromListModel.get(i).toString());
                    }
                }

                if (GlobalVariables.currentProject.getCommonGenetFileSetList().size() > 0) {
                    unAvailableFile = resourceManager.checkUnavailableHapAnnotFiles(chors);
                    if (unAvailableFile.length() > 0) {
                        Object[] options = {"Donwload dbSNP Annotation", "CANCEL"};
                        int response = JOptionPane.showOptionDialog(GlobalVariables.currentApplication.getMainFrame(), "The following chromsomes have no annotaion data:\n" + unAvailableFile, "Message",
                                JOptionPane.DEFAULT_OPTION, JOptionPane.INFORMATION_MESSAGE,
                                null, options, options[0]);
                        if (response == 1) {
                            return null;
                        } else {
                            GlobalVariables.mainView.specifyHapMapFiles(unAvailableFile);
                            GlobalVariables.mainView.openDownloadHapDialog();
                            return null;
                        }
                    }
                }


                if (GlobalVariables.currentProject.getChipFilePathList().size() > 0) {
                    RegionGenomeChipIntegrator integrator = new RegionGenomeChipIntegrator();
                    integrator.integrateChipFiles(integration);
                }
                if (GlobalVariables.currentProject.getCommonGenetFileSetList().size() > 0) {
                    CommonGenetDatasetIntegrator comonSetIntegrator = new CommonGenetDatasetIntegrator();
                    comonSetIntegrator.integrateCommonGenetDataset(integration);
                }

                GlobalVariables.currentProject.addAIntegration(integration);
                GlobalVariables.mainView.setBriefRunningInfor("Genotypes of these questionable SNPs (detailed in Log files) are ignored!\n");
                GlobalVariables.mainView.addIntegrationNodes(integration);
                realSuccess = true;
                GlobalVariables.mainView.switchExort(true);
                GlobalVariables.mainView.switchHapIntegration(true);
            } catch (Exception ex) {
                JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), ex.toString(), "Error", JOptionPane.ERROR_MESSAGE);
            }
            return null;  // return your result

        }

        @Override
        protected void succeeded(Object result) {
            // Runs on the EDT.  Update the GUI based on
            // the result computed by doInBackground().
            if (realSuccess) {
                StringBuffer inforString = new StringBuffer();
                inforString.append("The Overall Lapsed Time: ");
                endTime = System.currentTimeMillis();
                inforString.append((endTime - startTime) / 1000.0);
                inforString.append(" Seconds.\n");

                GlobalVariables.mainView.setBriefRunningIcons("time.gif");
                GlobalVariables.mainView.setBriefRunningInfor("The integration proccess is finished. " + inforString.toString(), true);
                GlobalVariables.addInforLog(inforString.toString());
            }
        }
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JComboBox freqPopulationComboBox;
    private javax.swing.JTextField geneticFromTextField;
    private javax.swing.JTextField geneticToTextField;
    private javax.swing.JTextField integrationNameTextField;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton4;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel15;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JList jList1;
    private javax.swing.JList jList2;
    private javax.swing.JPanel jPanel10;
    private javax.swing.JPanel jPanel12;
    private javax.swing.JPanel jPanel15;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JPanel jPanel9;
    private javax.swing.JScrollPane jScrollPane6;
    private javax.swing.JScrollPane jScrollPane7;
    private javax.swing.JTextField physicalFromTextField;
    private javax.swing.JTextField physicalToTextField;
    private javax.swing.JCheckBox setGenetRegionCheckBox;
    private javax.swing.JCheckBox setPhysicalRegionCheckBox;
    // End of variables declaration//GEN-END:variables
}
