// (c) 2008-2009 Miaoxin Li
// This file is distributed as part of the IGG source code package
// and may not be redistributed in any form, without prior written
// permission from the author. Permission is granted for you to
// modify this file for your own personal use, but modified versions
// must retain this copyright notice and must not be distributed.
// Permission is granted for you to use this file to compile IGG.
// All computer programs have bugs. Use this file at your own risk.
// Saturday, January 17, 2009
/*
 * IntegrateHapMapDialog.java
 *
 * Created on 2008�?2�?�? 下午1:37
 */
package org.cobi.igg3.gui;

import java.io.File;
import java.util.ArrayList;
import java.util.List;
import java.util.TreeSet;
import javax.swing.DefaultListModel;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import org.cobi.igg3.Constants;
import org.cobi.igg3.controller.HapMapGenotypeIntegrator;
import org.cobi.igg3.controller.ResourceManager;
import org.cobi.igg3.entity.Integration;
import org.cobi.igg3.GlobalVariables;
import org.jdesktop.application.Action;
import org.jdesktop.application.Task;

/**
 *
 * @author  mxli
 */
public class IntegrateHapMapDialog extends javax.swing.JDialog implements Constants {

    DefaultListModel hapmapGenotypeFileListModel = new DefaultListModel();
    String strandLabel = "fwd";

    /** Creates new form IntegrateHapMapDialog */
    public IntegrateHapMapDialog(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        setIconImage(GUIUtil.readImageIcon("igg.png").getImage());
        Object item = GlobalVariables.chipIntegrationModel.getElementAt(0);
        if (item != null) {
            Integration intgr = (Integration) item;
            StringBuilder strRegion = new StringBuilder();
            try {
                List<String> chrList = intgr.getChromResult();
                if (intgr.getPhysicalRegionMap().size() > 0) {
                    for (int i = 0; i < chrList.size(); i++) {
                        String chroInfo = chrList.get(i);
                        strRegion.append("Chr");
                        strRegion.append(chroInfo);
                        long[] physicalRegions = intgr.getPhysicalRegionMap().get(chroInfo.substring(0, chroInfo.indexOf(' ')));
                        int regionNum = physicalRegions.length / 2;

                        for (int j = 0; j < regionNum; j++) {
                            if (physicalRegions[j * 2] != -9 || physicalRegions[j * 2 + 1] != -9) {

                                if (physicalRegions[j * 2 + 1] == -9) {
                                    physicalRegions[1] = Long.MAX_VALUE;
                                }
                                strRegion.append(" [");
                                strRegion.append(physicalRegions[j * 2]);
                                strRegion.append(",");
                                strRegion.append(physicalRegions[j * 2+1]);
                                strRegion.append("]bp");
                            } else {
                                strRegion.append(" whole chrom.");
                            }
                        }
                        strRegion.append('\n');
                    }
                    regionsTextArea.setText(strRegion.toString());
                }
            } catch (Exception ex) {
                JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), ex.toString(), "Error", JOptionPane.ERROR_MESSAGE);
            }
        }
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel2 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        integratedDatasetComboBox = new javax.swing.JComboBox();
        jLabel3 = new javax.swing.JLabel();
        integrationNameTextField = new javax.swing.JTextField();
        jPanel39 = new javax.swing.JPanel();
        jScrollPane21 = new javax.swing.JScrollPane();
        genotypeFileList = new javax.swing.JList(hapmapGenotypeFileListModel);
        jButton3 = new javax.swing.JButton();
        jButton4 = new javax.swing.JButton();
        jButton5 = new javax.swing.JButton();
        jLabel2 = new javax.swing.JLabel();
        matchComboBox = new javax.swing.JComboBox();
        jLabel5 = new javax.swing.JLabel();
        strandComboBox = new javax.swing.JComboBox();
        jLabel4 = new javax.swing.JLabel();
        genomeVersionComboBox = new javax.swing.JComboBox();
        jScrollPane1 = new javax.swing.JScrollPane();
        regionsTextArea = new javax.swing.JTextArea();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(org.cobi.igg3.gui.IGG3App.class).getContext().getResourceMap(IntegrateHapMapDialog.class);
        setTitle(resourceMap.getString("Form.title")); // NOI18N
        setName("Form"); // NOI18N
        setResizable(false);

        jPanel2.setName("jPanel2"); // NOI18N

        jLabel1.setText(resourceMap.getString("jLabel1.text")); // NOI18N
        jLabel1.setName("jLabel1"); // NOI18N

        integratedDatasetComboBox.setModel(GlobalVariables.allIntegrationModel);
        integratedDatasetComboBox.setName("integratedDatasetComboBox"); // NOI18N
        integratedDatasetComboBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                integratedDatasetComboBoxActionPerformed(evt);
            }
        });

        jLabel3.setText(resourceMap.getString("jLabel3.text")); // NOI18N
        jLabel3.setName("jLabel3"); // NOI18N

        integrationNameTextField.setText(resourceMap.getString("integrationNameTextField.text")); // NOI18N
        integrationNameTextField.setName("integrationNameTextField"); // NOI18N

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addComponent(jLabel1)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(integratedDatasetComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, 327, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addContainerGap())
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addComponent(jLabel3, javax.swing.GroupLayout.PREFERRED_SIZE, 38, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(integrationNameTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 333, Short.MAX_VALUE)
                        .addGap(95, 95, 95))))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(integrationNameTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(integratedDatasetComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
        );

        jPanel39.setBorder(javax.swing.BorderFactory.createTitledBorder(resourceMap.getString("jPanel39.border.title"))); // NOI18N
        jPanel39.setName("jPanel39"); // NOI18N

        jScrollPane21.setBorder(javax.swing.BorderFactory.createTitledBorder(""));
        jScrollPane21.setName("jScrollPane21"); // NOI18N

        genotypeFileList.setName("genotypeFileList"); // NOI18N
        jScrollPane21.setViewportView(genotypeFileList);

        javax.swing.ActionMap actionMap = org.jdesktop.application.Application.getInstance(org.cobi.igg3.gui.IGG3App.class).getContext().getActionMap(IntegrateHapMapDialog.class, this);
        jButton3.setAction(actionMap.get("addFile")); // NOI18N
        jButton3.setToolTipText(resourceMap.getString("jButton3.toolTipText")); // NOI18N
        jButton3.setName("jButton3"); // NOI18N

        jButton4.setAction(actionMap.get("removeFile")); // NOI18N
        jButton4.setName("jButton4"); // NOI18N

        jButton5.setAction(actionMap.get("dwonloadHapMap")); // NOI18N
        jButton5.setToolTipText(resourceMap.getString("jButton5.toolTipText")); // NOI18N
        jButton5.setName("jButton5"); // NOI18N

        jLabel2.setText(resourceMap.getString("jLabel2.text")); // NOI18N
        jLabel2.setName("jLabel2"); // NOI18N

        matchComboBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Match Available Regions", "Match Available SNPs" }));
        matchComboBox.setName("matchComboBox"); // NOI18N

        jLabel5.setText(resourceMap.getString("jLabel5.text")); // NOI18N
        jLabel5.setName("jLabel5"); // NOI18N

        strandComboBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "All Forward/+", "All Reverse/-" }));
        strandComboBox.setName("strandComboBox"); // NOI18N
        strandComboBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                strandComboBoxActionPerformed(evt);
            }
        });

        jLabel4.setText(resourceMap.getString("jLabel4.text")); // NOI18N
        jLabel4.setName("jLabel4"); // NOI18N

        genomeVersionComboBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Build 36", "Build 37", "Build 35" }));
        genomeVersionComboBox.setName("genomeVersionComboBox"); // NOI18N

        javax.swing.GroupLayout jPanel39Layout = new javax.swing.GroupLayout(jPanel39);
        jPanel39.setLayout(jPanel39Layout);
        jPanel39Layout.setHorizontalGroup(
            jPanel39Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel39Layout.createSequentialGroup()
                .addGroup(jPanel39Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel39Layout.createSequentialGroup()
                        .addComponent(jScrollPane21)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel39Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jButton4, javax.swing.GroupLayout.PREFERRED_SIZE, 28, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jButton3, javax.swing.GroupLayout.PREFERRED_SIZE, 29, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jButton5, javax.swing.GroupLayout.PREFERRED_SIZE, 30, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addGroup(jPanel39Layout.createSequentialGroup()
                        .addComponent(jLabel2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(matchComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, 148, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jLabel5)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(strandComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, 121, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jLabel4)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(genomeVersionComboBox, 0, 77, Short.MAX_VALUE)))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel39Layout.setVerticalGroup(
            jPanel39Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel39Layout.createSequentialGroup()
                .addGroup(jPanel39Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(matchComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel5)
                    .addComponent(strandComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel4)
                    .addComponent(genomeVersionComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGroup(jPanel39Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel39Layout.createSequentialGroup()
                        .addGap(29, 29, 29)
                        .addComponent(jButton5)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 81, Short.MAX_VALUE)
                        .addComponent(jButton3, javax.swing.GroupLayout.PREFERRED_SIZE, 26, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(48, 48, 48)
                        .addComponent(jButton4, javax.swing.GroupLayout.PREFERRED_SIZE, 26, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(41, 41, 41))
                    .addGroup(jPanel39Layout.createSequentialGroup()
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jScrollPane21, javax.swing.GroupLayout.DEFAULT_SIZE, 273, Short.MAX_VALUE))))
        );

        jScrollPane1.setBorder(javax.swing.BorderFactory.createTitledBorder(resourceMap.getString("jScrollPane1.border.title"))); // NOI18N
        jScrollPane1.setName("jScrollPane1"); // NOI18N

        regionsTextArea.setColumns(20);
        regionsTextArea.setRows(5);
        regionsTextArea.setName("regionsTextArea"); // NOI18N
        jScrollPane1.setViewportView(regionsTextArea);

        jButton1.setAction(actionMap.get("integrateHapMap")); // NOI18N
        jButton1.setName("jButton1"); // NOI18N

        jButton2.setAction(actionMap.get("cancel")); // NOI18N
        jButton2.setName("jButton2"); // NOI18N

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(81, 81, 81)
                        .addComponent(jButton1)
                        .addGap(142, 142, 142)
                        .addComponent(jButton2))
                    .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jPanel39, javax.swing.GroupLayout.DEFAULT_SIZE, 609, Short.MAX_VALUE)
                    .addComponent(jScrollPane1))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel39, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton1)
                    .addComponent(jButton2))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

private void integratedDatasetComboBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_integratedDatasetComboBoxActionPerformed
// TODO add your handling code here:
    Object item = integratedDatasetComboBox.getSelectedItem();
    if (item != null) {
        Integration intgr = (Integration) item;
        StringBuilder strRegion = new StringBuilder();
        try {
            List<String> chrList = intgr.getChromResult();
            if (intgr.getPhysicalRegionMap().size() > 0) {
                for (int i = 0; i < chrList.size(); i++) {
                    String chroInfo = chrList.get(i);
                    strRegion.append("Chr");
                    strRegion.append(chroInfo);
                    long[] physicalRegions = intgr.getPhysicalRegionMap().get(chroInfo.substring(0, chroInfo.indexOf(' ')));
                    int regionNum = physicalRegions.length / 2;

                    for (int j = 0; j < regionNum; j++) {
                        if (physicalRegions[j * 2] != -9 || physicalRegions[j * 2 + 1] != -9) {

                            if (physicalRegions[j * 2 + 1] == -9) {
                                physicalRegions[1] = Long.MAX_VALUE;
                            }
                            strRegion.append(" [");
                            strRegion.append(physicalRegions[j * 2]);
                            strRegion.append(",");
                            strRegion.append(physicalRegions[j * 2+1]);
                            strRegion.append("]bp");
                        } else {
                            strRegion.append(" whole chrom.");
                        }
                    }
                    strRegion.append('\n');
                }
                regionsTextArea.setText(strRegion.toString());
            }
        } catch (Exception ex) {
            JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), ex.toString(), "Error", JOptionPane.ERROR_MESSAGE);
        }
    }
}//GEN-LAST:event_integratedDatasetComboBoxActionPerformed

private void strandComboBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_strandComboBoxActionPerformed
    // TODO add your handling code here:
    if (strandComboBox.getSelectedIndex() == 1) {
        strandLabel = "rs";
    } else {
        strandLabel = "fwd";
    }
}//GEN-LAST:event_strandComboBoxActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                IntegrateHapMapDialog dialog = new IntegrateHapMapDialog(new javax.swing.JFrame(), true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {

                    @Override
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }

    @Action
    public void cancel() {

        setVisible(false);
    }

    @Action
    public void addFile() {
        JFileChooser fDialog = null;
        if ((GlobalVariables.lastAccessedPath != null) && (GlobalVariables.lastAccessedPath.trim().length() > 0)) {
            fDialog = new JFileChooser(GlobalVariables.lastAccessedPath);
        } else {
            fDialog = new JFileChooser();
        }
        fDialog.setMultiSelectionEnabled(true);
        fDialog.setDialogTitle("Load HapMap genotype files");

        int result = fDialog.showOpenDialog(this);
        if (result == JFileChooser.APPROVE_OPTION) {
            // GlobalVariables.lastAccessedPath = fDialog.getSelectedFile().getPath();
            //  GlobalVariables.lastAccessedPath = GlobalVariables.lastAccessedPath.substring(0, GlobalVariables.lastAccessedPath.lastIndexOf(File.separator) + 1);
            try {
                final File[] files = fDialog.getSelectedFiles();
                int fileLength = files.length;

                StringBuilder badFileName = new StringBuilder();
                StringBuilder discordantVersion = new StringBuilder();
                StringBuilder fwdInfor = new StringBuilder();
                badFileName.append("The following files may be not HapMap genotype file(s) and will not be parsed:\n");
                int orgLen = badFileName.length();
                for (int i = 0; i < fileLength; i++) {
                    hapmapGenotypeFileListModel.addElement(files[i].getCanonicalPath());
                }
                TreeSet<String> extendNames = new TreeSet<String>();
                if (hapmapGenotypeFileListModel.size() > 0) {
                    String fileName = (String) hapmapGenotypeFileListModel.get(0);
                    fileName = fileName.substring(fileName.lastIndexOf(File.separator) + 1);

                    if (fileName.indexOf(strandLabel) < 0) {
                        fwdInfor.append(fileName);
                        fwdInfor.append('\n');
                    }
                    boolean found = false;
                    for (int i = 0; i < HAPMAP_POPULATIONS.length; i++) {
                        int pos = fileName.indexOf(HAPMAP_POPULATIONS[i]);
                        if (pos >= 0) {
                            found = true;
                            if (!extendNames.contains(fileName.substring(pos))) {
                                extendNames.add(fileName.substring(pos));
                            }
                            break;
                        }
                    }
                    if (!found) {
                        badFileName.append(fileName);
                        badFileName.append('\n');
                    }
                }
                if (orgLen < badFileName.length()) {
                    JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), badFileName.toString(), "Error", JOptionPane.ERROR_MESSAGE);
                }
                if (extendNames.size() > 1) {
                    String info = extendNames.size() + " different versions of genotype files are found!\n More than 1 version at a time may lead to inconsistant integration!!";
                    JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), info, "Error", JOptionPane.ERROR_MESSAGE);
                } else if (discordantVersion.length() > 0) {
                    JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), "The version of the following file may be discordant with you select:\n" + discordantVersion.toString(), "Warning", JOptionPane.WARNING_MESSAGE);
                } else if (fwdInfor.length() > 0) {
                    JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), "The following files are not forward format, which may result in wrong integration:\n" + fwdInfor.toString(), "Warning", JOptionPane.WARNING_MESSAGE);
                } else {
                    JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), "File(s) Loaded", "Message", JOptionPane.INFORMATION_MESSAGE);
                }
            } catch (Exception ex) {
                JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), ex.toString(), "Error", JOptionPane.ERROR_MESSAGE);
            }
        } else {
            JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), "Loading Cancelled", "Message", JOptionPane.INFORMATION_MESSAGE);
        }
    }

    public void addHapMapPhaseFile(File file) {
        try {
            StringBuilder badFileName = new StringBuilder();
            StringBuilder discordantVersion = new StringBuilder();
            StringBuilder fwdInfor = new StringBuilder();
            badFileName.append("The following files may be not HapMap genotype file(s) and will not be parsed:\n");
            int orgLen = badFileName.length();

            hapmapGenotypeFileListModel.addElement(file.getCanonicalPath());

            TreeSet<String> extendNames = new TreeSet<String>();
            if (hapmapGenotypeFileListModel.size() > 0) {
                String fileName = (String) hapmapGenotypeFileListModel.get(0);
                fileName = fileName.substring(fileName.lastIndexOf(File.separator) + 1);

                if (fileName.indexOf(strandLabel) < 0) {
                    fwdInfor.append(fileName);
                    fwdInfor.append('\n');
                }
                boolean found = false;
                for (int i = 0; i < HAPMAP_POPULATIONS.length; i++) {
                    int pos = fileName.indexOf(HAPMAP_POPULATIONS[i]);
                    if (pos >= 0) {
                        found = true;
                        if (!extendNames.contains(fileName.substring(pos))) {
                            extendNames.add(fileName.substring(pos));
                        }
                        break;
                    }
                }
                if (!found) {
                    badFileName.append(fileName);
                    badFileName.append('\n');
                }
            }
            if (orgLen < badFileName.length()) {
                JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), badFileName.toString(), "Error", JOptionPane.ERROR_MESSAGE);
            }
            if (extendNames.size() > 1) {
                String info = extendNames.size() + " different versions of genotype files are found!\n More than 1 version at a time may lead to inconsistant integration!!";
                JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), info, "Error", JOptionPane.ERROR_MESSAGE);
            } else if (discordantVersion.length() > 0) {
                JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), "The version of the following file may be discordant with you select:\n" + discordantVersion.toString(), "Warning", JOptionPane.WARNING_MESSAGE);
            } else if (fwdInfor.length() > 0) {
                JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), "The following files are not forward format, which may result in wrong integration:\n" + fwdInfor.toString(), "Warning", JOptionPane.WARNING_MESSAGE);
            } else {
                JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), file.getName() + " Loaded", "Message", JOptionPane.INFORMATION_MESSAGE);
            }
        } catch (Exception ex) {
            JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), ex.toString(), "Error", JOptionPane.ERROR_MESSAGE);
        }
    }

    @Action
    public void removeFile() {
        int[] selectedIx = genotypeFileList.getSelectedIndices();
        for (int i = selectedIx.length - 1; i >= 0; i--) {
            hapmapGenotypeFileListModel.removeElementAt(selectedIx[i]);
        }
    }

    @Action(block = Task.BlockingScope.ACTION)
    public Task integrateHapMap() {
        return new IntegrateHapMapTask(org.jdesktop.application.Application.getInstance(org.cobi.igg3.gui.IGG3App.class));
    }

    private class IntegrateHapMapTask extends org.jdesktop.application.Task<Object, Void> {

        private boolean realSuccess = false;
        private long startTime = 0;
        private long endTime = 0;

        IntegrateHapMapTask(org.jdesktop.application.Application app) {
            // Runs on the EDT.  Copy GUI state that
            // doInBackground() depends on from parameters
            // to IntegrateHapMapTask fields, here.
            super(app);
        }

        @Override
        protected Object doInBackground() {
            // Your Task's code here.  This method runs
            // on a background thread, so don't reference
            // the Swing GUI from here.
            String curFS = System.getProperty("file.separator");
            Integration intgr = (Integration) integratedDatasetComboBox.getSelectedItem();
            boolean toMatchRegion = matchComboBox.getSelectedItem().toString().equals("Match Available Regions");
            boolean isForward = true;
            if (strandLabel.equals("rs")) {
                isForward = false;
            }
            if (intgr.isHapMapSet()) {
                JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), intgr.getName() + " is not a pure chip file integration!", "Error", JOptionPane.ERROR_MESSAGE);
            }
            try {
                Integration newIngetrate = (Integration) intgr.clone();
                newIngetrate.setName(integrationNameTextField.getText());
                newIngetrate.setHapMapSet(true);
                newIngetrate.getChromResult().clear();
                String newPath = newIngetrate.getResultPath();
                newPath = newPath.substring(0, newPath.lastIndexOf(curFS));
                newIngetrate.setResultPath(newPath + curFS + newIngetrate.getName());

                List<String> chroms = new ArrayList<String>();

                List<String> fileList = new ArrayList<String>();
                for (int i = 0; i < hapmapGenotypeFileListModel.size(); i++) {
                    fileList.add((String) hapmapGenotypeFileListModel.get(i));
                }
                boolean availableName = GlobalVariables.currentProject.isAvailableIntegrationName(integrationNameTextField.getText());
                if (availableName) {
                    JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), "Please set a new integration name!", "Error", JOptionPane.ERROR_MESSAGE);
                    return null;
                }
                StringBuilder msg = new StringBuilder();
                HapMapGenotypeIntegrator integrator = new HapMapGenotypeIntegrator(newIngetrate, intgr);
                if (integrator.checkGenotyeFileCompletion(fileList, msg, chroms)) {
                    JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), msg.toString(), "Information", JOptionPane.INFORMATION_MESSAGE);
                } else {
                    JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), msg.toString(), "Error", JOptionPane.ERROR_MESSAGE);
                    Object[] options = {"Yes, and go on", "Stop now!"};
                    int response = JOptionPane.showOptionDialog(GlobalVariables.currentApplication.getMainFrame(), "Ignore chromosomes with missing files?", "Message",
                            JOptionPane.DEFAULT_OPTION, JOptionPane.INFORMATION_MESSAGE,
                            null, options, options[0]);
                    if (response == 1) {
                        return null;
                    }
                }
                setVisible(false);

                ResourceManager resourceManager = new ResourceManager();
                String unAvailableFile = resourceManager.checkUnavailableHapAnnotFiles(chroms);
                if (unAvailableFile.length() > 0) {
                    Object[] options = {"Donwload dbSNP Annotation", "CANCEL"};
                    int response = JOptionPane.showOptionDialog(GlobalVariables.currentApplication.getMainFrame(), "The following chromsomes have no annotaion data:\n" + unAvailableFile, "Message",
                            JOptionPane.DEFAULT_OPTION, JOptionPane.INFORMATION_MESSAGE,
                            null, options, options[0]);
                    if (response == 1) {
                        return null;
                    } else {
                        GlobalVariables.mainView.specifyHapMapFiles(unAvailableFile);
                        GlobalVariables.mainView.openDownloadHapDialog();
                        return null;
                    }
                }
                startTime = System.currentTimeMillis();
                GlobalVariables.mainView.setBriefRunningIcons("start.gif");

                GlobalVariables.mainView.setBriefRunningInfor("Integrating HapMap genotype. Please wait...\n");
                GlobalVariables.addInforLog("Integrating HapMap genotype. Please wait...\n");
                if (genomeVersionComboBox.getSelectedItem().toString().equals("Build 35")) {
                    integrator.setReferenceGenomeVersion(35);
                } else if (genomeVersionComboBox.getSelectedItem().toString().equals("Build 37")) {
                    integrator.setReferenceGenomeVersion(37);
                } else if (genomeVersionComboBox.getSelectedItem().toString().equals("Build 36")) {
                    integrator.setReferenceGenomeVersion(36);
                }
                integrator.integrate(toMatchRegion, isForward);
                GlobalVariables.mainView.setBriefRunningInfor("Genotypes of these questionable SNPs (detailed in Log files) are ignored!\n");
                GlobalVariables.currentProject.addAIntegration(newIngetrate);
                GlobalVariables.mainView.addIntegrationNodes(newIngetrate);
                realSuccess = true;
            } catch (Exception ex) {
                JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), ex.toString(), "Error", JOptionPane.ERROR_MESSAGE);
            }
            return null;  // return your result

        }

        @Override
        protected void succeeded(Object result) {
            // Runs on the EDT.  Update the GUI based on
            // the result computed by doInBackground().
            if (realSuccess) {
                StringBuilder inforString = new StringBuilder();
                inforString.append("The Overall Lapsed Time: ");
                endTime = System.currentTimeMillis();
                inforString.append((endTime - startTime) / 1000.0);
                inforString.append(" Seconds.\n");
                GlobalVariables.mainView.setBriefRunningIcons("time.gif");
                GlobalVariables.mainView.setBriefRunningInfor("The integration proccess is finished. " + inforString.toString());
                GlobalVariables.addInforLog(inforString.toString());
                // GlobalVariables.mainView.setToOpenExportDialog(true);

            }
        }
    }

    @Action
    public void dwonloadHapMap() {
        if (webBrowserDialog == null) {
            webBrowserDialog = new WebBrowserDialog(GlobalVariables.currentApplication.getMainFrame(), true, this);
            webBrowserDialog.setLocationRelativeTo(GlobalVariables.currentApplication.getMainFrame());
        }

        IGG3App.getApplication().show(webBrowserDialog);
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JComboBox genomeVersionComboBox;
    private javax.swing.JList genotypeFileList;
    private javax.swing.JComboBox integratedDatasetComboBox;
    private javax.swing.JTextField integrationNameTextField;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton4;
    private javax.swing.JButton jButton5;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel39;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane21;
    private javax.swing.JComboBox matchComboBox;
    private javax.swing.JTextArea regionsTextArea;
    private javax.swing.JComboBox strandComboBox;
    // End of variables declaration//GEN-END:variables
    JDialog webBrowserDialog;
}
