// (c) 2008-2009 Miaoxin Li
// This file is distributed as part of the IGG source code package
// and may not be redistributed in any form, without prior written
// permission from the author. Permission is granted for you to
// modify this file for your own personal use, but modified versions
// must retain this copyright notice and must not be distributed.
// Permission is granted for you to use this file to compile IGG.
// All computer programs have bugs. Use this file at your own risk.
// Saturday, January 17, 2009
/*
 * IntegrateWholeGenomeDialog.java
 *
 * Created on 2008�?1�?7�? 下午2:26
 */
package org.cobi.igg3.gui;

import java.io.File;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import javax.swing.JOptionPane;
import org.cobi.igg3.Constants;
import org.cobi.igg3.controller.CommonGenetDatasetIntegrator;
import org.cobi.igg3.controller.ResourceManager;
import org.cobi.igg3.controller.WholeGenomeChipIntegrator;
import org.cobi.igg3.entity.Integration;
import org.cobi.igg3.GlobalVariables;
import org.jdesktop.application.Action;
import org.jdesktop.application.Task;

/**
 *
 * @author  Miaoxin Li
 */
public class IntegrateWholeGenomeDialog extends javax.swing.JDialog implements Constants {

    ResourceManager resourceManager = new ResourceManager();

    /** Creates new form IntegrateWholeGenomeDialog */
    public IntegrateWholeGenomeDialog(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        setChromosome(true);
        setIconImage(GUIUtil.readImageIcon("igg.png").getImage());
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel15 = new javax.swing.JPanel();
        jLabel15 = new javax.swing.JLabel();
        freqPopulationComboBox = new javax.swing.JComboBox();
        jLabel1 = new javax.swing.JLabel();
        integrationNameTextField = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        bufferSubjectTextField = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jPanel1 = new javax.swing.JPanel();
        all = new javax.swing.JCheckBox();
        none = new javax.swing.JCheckBox();
        c1 = new javax.swing.JCheckBox();
        c2 = new javax.swing.JCheckBox();
        c3 = new javax.swing.JCheckBox();
        c4 = new javax.swing.JCheckBox();
        c5 = new javax.swing.JCheckBox();
        c6 = new javax.swing.JCheckBox();
        c7 = new javax.swing.JCheckBox();
        c8 = new javax.swing.JCheckBox();
        c9 = new javax.swing.JCheckBox();
        c10 = new javax.swing.JCheckBox();
        c11 = new javax.swing.JCheckBox();
        c12 = new javax.swing.JCheckBox();
        c13 = new javax.swing.JCheckBox();
        c14 = new javax.swing.JCheckBox();
        c15 = new javax.swing.JCheckBox();
        c16 = new javax.swing.JCheckBox();
        c17 = new javax.swing.JCheckBox();
        c18 = new javax.swing.JCheckBox();
        c19 = new javax.swing.JCheckBox();
        c20 = new javax.swing.JCheckBox();
        c21 = new javax.swing.JCheckBox();
        c22 = new javax.swing.JCheckBox();
        cx = new javax.swing.JCheckBox();
        cy = new javax.swing.JCheckBox();
        cmt = new javax.swing.JCheckBox();
        cxy = new javax.swing.JCheckBox();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(org.cobi.igg3.gui.IGG3App.class).getContext().getResourceMap(IntegrateWholeGenomeDialog.class);
        setTitle(resourceMap.getString("Form.title")); // NOI18N
        setName("Form"); // NOI18N
        setResizable(false);

        jPanel15.setBorder(javax.swing.BorderFactory.createTitledBorder(resourceMap.getString("jPanel15.border.title"))); // NOI18N
        jPanel15.setName("jPanel15"); // NOI18N

        jLabel15.setText(resourceMap.getString("jLabel15.text")); // NOI18N
        jLabel15.setName("jLabel15"); // NOI18N

        freqPopulationComboBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Asian Population", "Caucasian Population", "African Population" }));
        freqPopulationComboBox.setName("freqPopulationComboBox"); // NOI18N

        jLabel1.setText(resourceMap.getString("jLabel1.text")); // NOI18N
        jLabel1.setName("jLabel1"); // NOI18N

        integrationNameTextField.setText(resourceMap.getString("integrationNameTextField.text")); // NOI18N
        integrationNameTextField.setName("integrationNameTextField"); // NOI18N

        jLabel2.setText(resourceMap.getString("jLabel2.text")); // NOI18N
        jLabel2.setName("jLabel2"); // NOI18N

        bufferSubjectTextField.setText(resourceMap.getString("bufferSubjectTextField.text")); // NOI18N
        bufferSubjectTextField.setName("bufferSubjectTextField"); // NOI18N

        jLabel3.setText(resourceMap.getString("jLabel3.text")); // NOI18N
        jLabel3.setName("jLabel3"); // NOI18N

        javax.swing.GroupLayout jPanel15Layout = new javax.swing.GroupLayout(jPanel15);
        jPanel15.setLayout(jPanel15Layout);
        jPanel15Layout.setHorizontalGroup(
            jPanel15Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel15Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel15Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(jPanel15Layout.createSequentialGroup()
                        .addComponent(jLabel2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(bufferSubjectTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 54, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel3))
                    .addGroup(jPanel15Layout.createSequentialGroup()
                        .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 56, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(integrationNameTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 233, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanel15Layout.createSequentialGroup()
                        .addComponent(jLabel15)
                        .addGap(12, 12, 12)
                        .addComponent(freqPopulationComboBox, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                .addContainerGap(17, Short.MAX_VALUE))
        );
        jPanel15Layout.setVerticalGroup(
            jPanel15Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel15Layout.createSequentialGroup()
                .addGroup(jPanel15Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(integrationNameTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel15Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.CENTER)
                    .addComponent(jLabel15, javax.swing.GroupLayout.PREFERRED_SIZE, 23, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(freqPopulationComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, 23, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel15Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(jLabel3)
                    .addComponent(bufferSubjectTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );

        javax.swing.ActionMap actionMap = org.jdesktop.application.Application.getInstance(org.cobi.igg3.gui.IGG3App.class).getContext().getActionMap(IntegrateWholeGenomeDialog.class, this);
        jButton1.setAction(actionMap.get("integrate")); // NOI18N
        jButton1.setName("jButton1"); // NOI18N

        jButton2.setAction(actionMap.get("cancel")); // NOI18N
        jButton2.setName("jButton2"); // NOI18N

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(resourceMap.getString("jPanel1.border.title"))); // NOI18N
        jPanel1.setName("jPanel1"); // NOI18N

        all.setAction(actionMap.get("allChromosome")); // NOI18N
        all.setText(resourceMap.getString("all.text")); // NOI18N
        all.setName("all"); // NOI18N

        none.setAction(actionMap.get("noneChromosome")); // NOI18N
        none.setText(resourceMap.getString("none.text")); // NOI18N
        none.setName("none"); // NOI18N

        c1.setText(resourceMap.getString("c1.text")); // NOI18N
        c1.setName("c1"); // NOI18N

        c2.setText(resourceMap.getString("c2.text")); // NOI18N
        c2.setName("c2"); // NOI18N

        c3.setText(resourceMap.getString("c3.text")); // NOI18N
        c3.setName("c3"); // NOI18N

        c4.setText(resourceMap.getString("c4.text")); // NOI18N
        c4.setName("c4"); // NOI18N

        c5.setText(resourceMap.getString("c5.text")); // NOI18N
        c5.setName("c5"); // NOI18N

        c6.setText(resourceMap.getString("c6.text")); // NOI18N
        c6.setName("c6"); // NOI18N

        c7.setText(resourceMap.getString("c7.text")); // NOI18N
        c7.setName("c7"); // NOI18N

        c8.setText(resourceMap.getString("c8.text")); // NOI18N
        c8.setName("c8"); // NOI18N

        c9.setText(resourceMap.getString("c9.text")); // NOI18N
        c9.setName("c9"); // NOI18N

        c10.setText(resourceMap.getString("c10.text")); // NOI18N
        c10.setName("c10"); // NOI18N

        c11.setText(resourceMap.getString("c11.text")); // NOI18N
        c11.setName("c11"); // NOI18N

        c12.setText(resourceMap.getString("c12.text")); // NOI18N
        c12.setName("c12"); // NOI18N

        c13.setText(resourceMap.getString("c13.text")); // NOI18N
        c13.setName("c13"); // NOI18N

        c14.setText(resourceMap.getString("c14.text")); // NOI18N
        c14.setName("c14"); // NOI18N

        c15.setText(resourceMap.getString("c15.text")); // NOI18N
        c15.setName("c15"); // NOI18N

        c16.setText(resourceMap.getString("c16.text")); // NOI18N
        c16.setName("c16"); // NOI18N

        c17.setText(resourceMap.getString("c17.text")); // NOI18N
        c17.setName("c17"); // NOI18N

        c18.setText(resourceMap.getString("c18.text")); // NOI18N
        c18.setName("c18"); // NOI18N

        c19.setText(resourceMap.getString("c19.text")); // NOI18N
        c19.setName("c19"); // NOI18N

        c20.setText(resourceMap.getString("c20.text")); // NOI18N
        c20.setName("c20"); // NOI18N

        c21.setText(resourceMap.getString("c21.text")); // NOI18N
        c21.setName("c21"); // NOI18N

        c22.setText(resourceMap.getString("c22.text")); // NOI18N
        c22.setName("c22"); // NOI18N

        cx.setText(resourceMap.getString("cx.text")); // NOI18N
        cx.setName("cx"); // NOI18N

        cy.setText(resourceMap.getString("cy.text")); // NOI18N
        cy.setName("cy"); // NOI18N

        cmt.setText(resourceMap.getString("cmt.text")); // NOI18N
        cmt.setName("cmt"); // NOI18N

        cxy.setText(resourceMap.getString("cxy.text")); // NOI18N
        cxy.setName("cxy"); // NOI18N

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(all)
                            .addComponent(c1))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel1Layout.createSequentialGroup()
                                        .addComponent(c18)
                                        .addGap(6, 6, 6)
                                        .addComponent(c19)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(c20)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(c21))
                                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel1Layout.createSequentialGroup()
                                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addComponent(c10)
                                            .addComponent(c2))
                                        .addGap(6, 6, 6)
                                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addComponent(c11)
                                            .addComponent(c3))
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addComponent(c12)
                                            .addComponent(c4))
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addComponent(c5)
                                            .addComponent(c13))))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(c6)
                                    .addComponent(c14)
                                    .addComponent(c22)))
                            .addComponent(none)))
                    .addComponent(c9)
                    .addComponent(c17))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(cmt)
                    .addComponent(c7)
                    .addComponent(c15)
                    .addComponent(cx))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(c8)
                    .addComponent(cxy)
                    .addComponent(cy)
                    .addComponent(c16))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.CENTER)
                    .addComponent(all)
                    .addComponent(none)
                    .addComponent(cmt)
                    .addComponent(cxy))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.CENTER)
                    .addComponent(c1)
                    .addComponent(c3)
                    .addComponent(c4)
                    .addComponent(c5)
                    .addComponent(c6)
                    .addComponent(c7)
                    .addComponent(c8)
                    .addComponent(c2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.CENTER)
                    .addComponent(c9)
                    .addComponent(c11)
                    .addComponent(c12)
                    .addComponent(c13)
                    .addComponent(c14)
                    .addComponent(c15)
                    .addComponent(c16)
                    .addComponent(c10))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.CENTER)
                    .addComponent(c17)
                    .addComponent(c19)
                    .addComponent(c20)
                    .addComponent(c21)
                    .addComponent(c22)
                    .addComponent(cx)
                    .addComponent(cy)
                    .addComponent(c18))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(52, 52, 52)
                .addComponent(jButton1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 85, Short.MAX_VALUE)
                .addComponent(jButton2)
                .addGap(59, 59, 59))
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addComponent(jPanel15, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel15, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton1)
                    .addComponent(jButton2))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                IntegrateWholeGenomeDialog dialog = new IntegrateWholeGenomeDialog(new javax.swing.JFrame(), true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {

                    @Override
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }

    @Action
    public void cancel() {
        setVisible(false);
    }

    @Action(block = Task.BlockingScope.ACTION)
    public Task integrate() {
        return new IntegrateTask(org.jdesktop.application.Application.getInstance(org.cobi.igg3.gui.IGG3App.class));
    }

    private void setChromosome(boolean c) {
        c1.setSelected(c);
        c2.setSelected(c);
        c3.setSelected(c);
        c4.setSelected(c);
        c5.setSelected(c);
        c6.setSelected(c);
        c7.setSelected(c);
        c8.setSelected(c);
        c9.setSelected(c);
        c10.setSelected(c);
        c11.setSelected(c);
        c12.setSelected(c);
        c13.setSelected(c);
        c14.setSelected(c);
        c15.setSelected(c);
        c16.setSelected(c);
        c17.setSelected(c);
        c18.setSelected(c);
        c19.setSelected(c);
        c20.setSelected(c);
        c21.setSelected(c);
        c22.setSelected(c);
        cx.setSelected(c);
        cy.setSelected(c);
        cmt.setSelected(c);
        cxy.setSelected(c);
    }

    private List<String> getSelectedChromosome() {
        List<String> chros = new ArrayList<String>();
        if (c1.isSelected()) {
            chros.add(CHROM_NAME[0]);
        }
        if (c2.isSelected()) {
            chros.add(CHROM_NAME[1]);
        }
        if (c3.isSelected()) {
            chros.add(CHROM_NAME[2]);
        }
        if (c4.isSelected()) {
            chros.add(CHROM_NAME[3]);
        }
        if (c5.isSelected()) {
            chros.add(CHROM_NAME[4]);
        }
        if (c6.isSelected()) {
            chros.add(CHROM_NAME[5]);
        }
        if (c7.isSelected()) {
            chros.add(CHROM_NAME[6]);
        }
        if (c8.isSelected()) {
            chros.add(CHROM_NAME[7]);
        }
        if (c9.isSelected()) {
            chros.add(CHROM_NAME[8]);
        }
        if (c10.isSelected()) {
            chros.add(CHROM_NAME[9]);
        }
        if (c11.isSelected()) {
            chros.add(CHROM_NAME[10]);
        }
        if (c12.isSelected()) {
            chros.add(CHROM_NAME[11]);
        }
        if (c13.isSelected()) {
            chros.add(CHROM_NAME[12]);
        }
        if (c14.isSelected()) {
            chros.add(CHROM_NAME[13]);
        }
        if (c15.isSelected()) {
            chros.add(CHROM_NAME[14]);
        }
        if (c16.isSelected()) {
            chros.add(CHROM_NAME[15]);
        }
        if (c17.isSelected()) {
            chros.add(CHROM_NAME[16]);
        }
        if (c18.isSelected()) {
            chros.add(CHROM_NAME[17]);
        }
        if (c19.isSelected()) {
            chros.add(CHROM_NAME[18]);
        }
        if (c20.isSelected()) {
            chros.add(CHROM_NAME[19]);
        }
        if (c21.isSelected()) {
            chros.add(CHROM_NAME[20]);
        }
        if (c22.isSelected()) {
            chros.add(CHROM_NAME[21]);
        }
        if (cx.isSelected()) {
            chros.add(CHROM_NAME[22]);
        }
        if (cy.isSelected()) {
            chros.add(CHROM_NAME[23]);
        }
        if (cxy.isSelected()) {
            chros.add(CHROM_NAME[24]);
        }
        if (cmt.isSelected()) {
            chros.add(CHROM_NAME[25]);
        }

        return chros;
    }

    private class IntegrateTask extends org.jdesktop.application.Task<Object, Void> {

        boolean realSuccess = false;
        long startTime, endTime;

        IntegrateTask(org.jdesktop.application.Application app) {
            // Runs on the EDT.  Copy GUI state that
            // doInBackground() depends on from parameters
            // to IntegrateTask fields, here.
            super(app);
        }

        @Override
        protected Object doInBackground() {
            // Your Task's code here.  This method runs
            // on a background thread, so don't reference
            // the Swing GUI from here.

            //check the availabity of annation file
            ArrayList<String> chipTypes = new ArrayList<String>();

            Iterator iter = GlobalVariables.currentProject.getChipFilePathList().keySet().iterator();
            List<String> chors = getSelectedChromosome();
            if (chors.isEmpty()) {
                JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), "No Chromsomes selected!!", "Error", JOptionPane.ERROR_MESSAGE);
                return null;
            }
            boolean availableName = GlobalVariables.currentProject.isAvailableIntegrationName(integrationNameTextField.getText());
            if (availableName) {
                JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), "Please set a new integration name!", "Error", JOptionPane.ERROR_MESSAGE);
                return null;
            }

            setVisible(false);
            try {
                while (iter.hasNext()) {
                    Object key = iter.next();
                    chipTypes.add(key.toString());
                }
                String unAvailableFile = resourceManager.checkUnavailableChipAnnotFiles(chipTypes);
                if (unAvailableFile.length() > 0) {
                    Object[] options = {"Donwload Chip Annotation", "CANCEL"};
                    int response = JOptionPane.showOptionDialog(GlobalVariables.currentApplication.getMainFrame(), "The following annotaion data are not availalbe:\n" + unAvailableFile, "Message",
                            JOptionPane.DEFAULT_OPTION, JOptionPane.INFORMATION_MESSAGE,
                            null, options, options[0]);
                    if (response == 1) {
                        return null;
                    } else {
                        GlobalVariables.mainView.specifyChipAnnotFiles(unAvailableFile);
                        GlobalVariables.mainView.openDonloadChipAnnot();
                        return null;
                    }
                }

                startTime = System.currentTimeMillis();
                GlobalVariables.mainView.setBriefRunningIcons("start.gif");

                Integration integration = new Integration(integrationNameTextField.getText(),
                        (String) freqPopulationComboBox.getSelectedItem(),
                        GlobalVariables.currentProject.getWorkingPath()
                        + File.separator + integrationNameTextField.getText());


                for (int i = 0; i < chors.size(); i++) {
                    long[] sdPoint = {-9, -9};
                    integration.addPhysicalRegionMap(chors.get(i), sdPoint);
                }

                if (GlobalVariables.currentProject.getCommonGenetFileSetList().size() > 0) {
                    ResourceManager resourceManager = new ResourceManager();
                    unAvailableFile = resourceManager.checkUnavailableHapAnnotFiles(chors);
                    if (unAvailableFile.length() > 0) {
                        Object[] options = {"Donwload dbSNP Annotation", "CANCEL"};
                        int response = JOptionPane.showOptionDialog(GlobalVariables.currentApplication.getMainFrame(), "The following chromsomes have no annotaion data:\n" + unAvailableFile, "Message",
                                JOptionPane.DEFAULT_OPTION, JOptionPane.INFORMATION_MESSAGE,
                                null, options, options[0]);
                        if (response == 1) {
                            return null;
                        } else {
                            GlobalVariables.mainView.specifyHapMapFiles(unAvailableFile);
                            GlobalVariables.mainView.openDownloadHapDialog();
                            return null;
                        }
                    }
                }

                if (GlobalVariables.currentProject.getChipFilePathList().size() > 0) {
                    WholeGenomeChipIntegrator encodedChipIntegrator = new WholeGenomeChipIntegrator(Integer.parseInt(bufferSubjectTextField.getText()));
                    encodedChipIntegrator.integrateChipFiles(integration);
                }
                if (GlobalVariables.currentProject.getCommonGenetFileSetList().size() > 0) {
                    CommonGenetDatasetIntegrator comonSetIntegrator = new CommonGenetDatasetIntegrator();
                    comonSetIntegrator.integrateCommonGenetDataset(integration);
                }

                GlobalVariables.currentProject.addAIntegration(integration);
                GlobalVariables.mainView.setBriefRunningInfor("Genotypes of these questionable SNPs (detailed in Log files) are ignored!\n");
                GlobalVariables.mainView.addIntegrationNodes(integration);
                GlobalVariables.mainView.switchExort(true);
                GlobalVariables.mainView.switchHapIntegration(true);
                realSuccess = true;
            } catch (Exception ex) {
                JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), ex.toString(), "Error", JOptionPane.ERROR_MESSAGE);
            }
            return null;  // return your result
        }

        @Override
        protected void succeeded(Object result) {
            // Runs on the EDT.  Update the GUI based on
            // the result computed by doInBackground().
            if (realSuccess) {
                StringBuffer inforString = new StringBuffer();
                inforString.append("The Overall Lapsed Time: ");
                endTime = System.currentTimeMillis();
                inforString.append((endTime - startTime) / 1000.0);
                inforString.append(" Seconds.\n");

                GlobalVariables.mainView.setBriefRunningIcons("time.gif");
                GlobalVariables.mainView.setBriefRunningInfor("The integration proccess is finished. " + inforString.toString(), true);
                GlobalVariables.addInforLog(inforString.toString());
                System.gc();
            }
        }
    }

    @Action
    public void allChromosome() {
        none.setSelected(false);
        setChromosome(true);
    }

    @Action
    public void noneChromosome() {
        setChromosome(false);
        all.setSelected(false);
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JCheckBox all;
    private javax.swing.JTextField bufferSubjectTextField;
    private javax.swing.JCheckBox c1;
    private javax.swing.JCheckBox c10;
    private javax.swing.JCheckBox c11;
    private javax.swing.JCheckBox c12;
    private javax.swing.JCheckBox c13;
    private javax.swing.JCheckBox c14;
    private javax.swing.JCheckBox c15;
    private javax.swing.JCheckBox c16;
    private javax.swing.JCheckBox c17;
    private javax.swing.JCheckBox c18;
    private javax.swing.JCheckBox c19;
    private javax.swing.JCheckBox c2;
    private javax.swing.JCheckBox c20;
    private javax.swing.JCheckBox c21;
    private javax.swing.JCheckBox c22;
    private javax.swing.JCheckBox c3;
    private javax.swing.JCheckBox c4;
    private javax.swing.JCheckBox c5;
    private javax.swing.JCheckBox c6;
    private javax.swing.JCheckBox c7;
    private javax.swing.JCheckBox c8;
    private javax.swing.JCheckBox c9;
    private javax.swing.JCheckBox cmt;
    private javax.swing.JCheckBox cx;
    private javax.swing.JCheckBox cxy;
    private javax.swing.JCheckBox cy;
    private javax.swing.JComboBox freqPopulationComboBox;
    private javax.swing.JTextField integrationNameTextField;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel15;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel15;
    private javax.swing.JCheckBox none;
    // End of variables declaration//GEN-END:variables
}
