// (c) 2008-2009 Miaoxin Li
// This file is distributed as part of the IGG source code package
// and may not be redistributed in any form, without prior written
// permission from the author. Permission is granted for you to
// modify this file for your own personal use, but modified versions
// must retain this copyright notice and must not be distributed.

// Permission is granted for you to use this file to compile IGG.

// All computer programs have bugs. Use this file at your own risk.
// Saturday, January 17, 2009
/*
 * SepcifyExportRegionsJDialog.java
 *
 * Created on 2008�?2�?9�? 下午9:35
 */
package org.cobi.igg3.gui;

import cern.colt.list.LongArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.swing.DefaultComboBoxModel;
import javax.swing.DefaultListModel;
import javax.swing.JOptionPane;
import org.cobi.igg3.entity.Integration;
import org.cobi.igg3.GlobalVariables;
import org.jdesktop.application.Action;

/**
 *
 * @author  mxli
 */
public class SepcifyExportRegionsJDialog extends javax.swing.JDialog {

    DefaultListModel selectedRegionListModel = new DefaultListModel();
    DefaultComboBoxModel regionsModel = new DefaultComboBoxModel();
    Integration curIntegration;
    Map<String, LongArrayList> selectedRegionMap = new HashMap<String, LongArrayList>();

    /** Creates new form SepcifyExportRegionsJDialog */
    public SepcifyExportRegionsJDialog(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        setIconImage(GUIUtil.readImageIcon("igg.png").getImage());
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        regionsComboBox = new javax.swing.JComboBox();
        jLabel3 = new javax.swing.JLabel();
        fromTextField = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        toTextField = new javax.swing.JTextField();
        jLabel1 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        selectedRegionList = new javax.swing.JList();
        jButton3 = new javax.swing.JButton();
        jButton4 = new javax.swing.JButton();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(org.cobi.igg3.gui.IGG3App.class).getContext().getResourceMap(SepcifyExportRegionsJDialog.class);
        setTitle(resourceMap.getString("Form.title")); // NOI18N
        setName("Form"); // NOI18N
        setResizable(false);

        jPanel1.setName("jPanel1"); // NOI18N

        jLabel2.setText(resourceMap.getString("jLabel2.text")); // NOI18N
        jLabel2.setName("jLabel2"); // NOI18N

        regionsComboBox.setEditable(true);
        regionsComboBox.setModel(regionsModel);
        regionsComboBox.setName("regionsComboBox"); // NOI18N

        jLabel3.setText(resourceMap.getString("jLabel3.text")); // NOI18N
        jLabel3.setName("jLabel3"); // NOI18N

        fromTextField.setText(resourceMap.getString("fromTextField.text")); // NOI18N
        fromTextField.setName("fromTextField"); // NOI18N

        jLabel4.setText(resourceMap.getString("jLabel4.text")); // NOI18N
        jLabel4.setName("jLabel4"); // NOI18N

        toTextField.setText(resourceMap.getString("toTextField.text")); // NOI18N
        toTextField.setName("toTextField"); // NOI18N

        jLabel1.setText(resourceMap.getString("jLabel1.text")); // NOI18N
        jLabel1.setName("jLabel1"); // NOI18N

        jLabel5.setText(resourceMap.getString("jLabel5.text")); // NOI18N
        jLabel5.setName("jLabel5"); // NOI18N

        jScrollPane1.setBorder(javax.swing.BorderFactory.createTitledBorder(resourceMap.getString("jScrollPane1.border.title"))); // NOI18N
        jScrollPane1.setName("jScrollPane1"); // NOI18N
        jScrollPane1.setPreferredSize(new java.awt.Dimension(270, 150));

        selectedRegionList.setModel(selectedRegionListModel);
        selectedRegionList.setName("selectedRegionList"); // NOI18N
        jScrollPane1.setViewportView(selectedRegionList);

        javax.swing.ActionMap actionMap = org.jdesktop.application.Application.getInstance(org.cobi.igg3.gui.IGG3App.class).getContext().getActionMap(SepcifyExportRegionsJDialog.class, this);
        jButton3.setAction(actionMap.get("addRegion")); // NOI18N
        jButton3.setToolTipText(resourceMap.getString("jButton3.toolTipText")); // NOI18N
        jButton3.setFocusPainted(false);
        jButton3.setName("jButton3"); // NOI18N

        jButton4.setAction(actionMap.get("removeRegions")); // NOI18N
        jButton4.setName("jButton4"); // NOI18N

        jButton1.setAction(actionMap.get("addWholeChrom")); // NOI18N
        jButton1.setToolTipText(resourceMap.getString("jButton1.toolTipText")); // NOI18N
        jButton1.setName("jButton1"); // NOI18N

        jButton2.setAction(actionMap.get("cancel")); // NOI18N
        jButton2.setName("jButton2"); // NOI18N

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel2)
                            .addComponent(jLabel3)
                            .addComponent(jLabel4))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(regionsComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, 209, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(toTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 98, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(fromTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 181, Short.MAX_VALUE))
                                .addGap(10, 10, 10)
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                    .addComponent(jLabel1)
                                    .addComponent(jLabel5)))))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                        .addGap(18, 18, 18)
                        .addComponent(jButton4, javax.swing.GroupLayout.PREFERRED_SIZE, 28, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(41, 41, 41)
                        .addComponent(jButton3, javax.swing.GroupLayout.PREFERRED_SIZE, 29, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 39, Short.MAX_VALUE)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jButton2)
                            .addComponent(jButton1))
                        .addGap(16, 16, 16)))
                .addContainerGap())
        );

        jPanel1Layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {fromTextField, toTextField});

        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addContainerGap()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel2)
                            .addComponent(regionsComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel3)
                            .addComponent(jLabel1)
                            .addComponent(fromTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel4)
                            .addComponent(jLabel5)
                            .addComponent(toTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jButton4, javax.swing.GroupLayout.PREFERRED_SIZE, 26, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jButton3, javax.swing.GroupLayout.PREFERRED_SIZE, 26, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jButton1))
                        .addGap(18, 18, 18)
                        .addComponent(jButton2))
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                SepcifyExportRegionsJDialog dialog = new SepcifyExportRegionsJDialog(new javax.swing.JFrame(), true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {

                    @Override
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }

    public void listRegions(Integration intgr) {
        if (intgr != null) {
            if (curIntegration != null && curIntegration.getName().equals(intgr.getName())) {
                return;
            }
            curIntegration = intgr;
            StringBuffer strRegion = new StringBuffer();
            regionsModel.removeAllElements();
            selectedRegionListModel.removeAllElements();
            selectedRegionMap.clear();
            try {
                List<String> chrList = intgr.getChromResult();
                if (intgr.getPhysicalRegionMap().size() > 0) {
                    for (int i = 0; i < chrList.size(); i++) {
                        String chroInfo = chrList.get(i);
                        strRegion.append("Chr");
                        strRegion.append(chroInfo);
                        long[] physicalRegions = intgr.getPhysicalRegionMap().get(chroInfo.substring(0, chroInfo.indexOf(' ')));
                        int regionNum = physicalRegions.length / 2;

                        for (int j = 0; j < regionNum; j++) {
                            if (physicalRegions[j * 2] != -9 || physicalRegions[j * 2 + 1] != -9) {
                                if (physicalRegions[j * 2 + 1] == -9) {
                                    physicalRegions[1] = Long.MAX_VALUE;
                                }
                                strRegion.append(" [");
                                strRegion.append(physicalRegions[j * 2]);
                                strRegion.append(",");
                                strRegion.append(physicalRegions[j * 2+1]);
                                strRegion.append("]bp");
                            } else {
                                strRegion.append(" whole chrom.");
                            }
                            regionsModel.addElement(strRegion.toString());
                            strRegion.delete(0, strRegion.length());
                        }
                    }
                }
            } catch (Exception ex) {
                JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), ex.toString(), "Error", JOptionPane.ERROR_MESSAGE);
            }
        }
    }

    @Action
    public void removeRegions() {
        int[] selectedIx = selectedRegionList.getSelectedIndices();
        for (int i = selectedIx.length - 1; i >= 0; i--) {
            String allInfo = selectedRegionListModel.remove(selectedIx[i]).toString();
            String chroInfo = allInfo.substring(3, allInfo.indexOf(' '));
            if (allInfo.indexOf("All available SNPs") >= 0) {
                LongArrayList region = selectedRegionMap.get(chroInfo);
                if (region != null) {
                    int rgSize = region.size() / 2 - 1;
                    for (int j = rgSize; j >= 0; j--) {
                        if (region.get(j * 2) == -9 && region.get(j * 2 + 1) == Long.MAX_VALUE) {
                            region.remove(j * 2 + 1);
                            region.remove(j * 2);
                        }
                    }
                    if (region.size() == 0) {
                        selectedRegionMap.remove(chroInfo);
                    }
                }
            } else {
                long fromPos = Long.parseLong(allInfo.substring(allInfo.indexOf('[') + 1, allInfo.indexOf(',')).trim());
                long toPos = Long.parseLong(allInfo.substring(allInfo.indexOf(',') + 1, allInfo.indexOf(']')).trim());
                LongArrayList region = selectedRegionMap.get(chroInfo);
                if (region != null) {
                    int rgSize = region.size() / 2 - 1;
                    for (int j = rgSize; j >= 0; j--) {
                        if (region.get(j * 2) == fromPos && region.get(j * 2 + 1) == toPos) {
                            region.remove(j * 2 + 1);
                            region.remove(j * 2);
                        }
                    }
                    if (region.size() == 0) {
                        selectedRegionMap.remove(chroInfo);
                    }
                }
            }
        }
    }

    @Action
    public void addRegion() {
        String chroInfo = regionsComboBox.getSelectedItem().toString();
        chroInfo = chroInfo.substring(3, chroInfo.indexOf(' '));
        long fromPos = Long.parseLong(fromTextField.getText().trim());
        long toPos = Long.parseLong(toTextField.getText().trim());
        long[] physicalRegions = curIntegration.getPhysicalRegionMap().get(chroInfo);
        if (physicalRegions[0] != -9 || physicalRegions[1] != -9) {
            if (physicalRegions[0] > fromPos || physicalRegions[1] < toPos) {
                JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), "Your specified region is beyond the available region!", "Error", JOptionPane.ERROR_MESSAGE);
                return;
            }
        }

        LongArrayList region = selectedRegionMap.get(chroInfo);
        if (region == null) {
            region = new LongArrayList();
            selectedRegionMap.put(chroInfo, region);
        }
        region.add(fromPos);
        region.add(toPos);
        selectedRegionListModel.addElement("Chr" + chroInfo + " [" + fromPos + "," + toPos + "]bp");
        fromTextField.setText("");
    }

    @Action
    public void cancel() {
        String infor = "It seems that you have not yet added the region your specified. Add it?";
        Object[] options = {"Yes", "No"};

        if (fromTextField.getText().trim().length() != 0 && toTextField.getText().trim().length() != 0) {
            int response = JOptionPane.showOptionDialog(GlobalVariables.currentApplication.getMainFrame(), infor, "Warning",
                    JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE,
                    null, options, options[0]);
            if (response == 1) {
                setVisible(false);
            } else {
                addRegion();
            }
        } else {
            setVisible(false);
        }

    }

    @Action
    public void addWholeChrom() {
        String chroInfo = regionsComboBox.getSelectedItem().toString();
        chroInfo = chroInfo.substring(3, chroInfo.indexOf(' '));

        LongArrayList region = selectedRegionMap.get(chroInfo);
        if (region == null) {
            region = new LongArrayList();
            selectedRegionMap.put(chroInfo, region);
        }
        region.add(-9);
        region.add(Long.MAX_VALUE);
        selectedRegionListModel.addElement("Chr" + chroInfo + " All available SNPs");
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTextField fromTextField;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton4;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JComboBox regionsComboBox;
    private javax.swing.JList selectedRegionList;
    private javax.swing.JTextField toTextField;
    // End of variables declaration//GEN-END:variables
}
