// (c) 2008-2009 Miaoxin Li
// This file is distributed as part of the IGG source code package
// and may not be redistributed in any form, without prior written
// permission from the author. Permission is granted for you to
// modify this file for your own personal use, but modified versions
// must retain this copyright notice and must not be distributed.

// Permission is granted for you to use this file to compile IGG.

// All computer programs have bugs. Use this file at your own risk.
// Saturday, January 17, 2009
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.cobi.igg3.gui;

import java.awt.Component;
import javax.swing.Icon;
import javax.swing.JTree;
import javax.swing.tree.DefaultTreeCellRenderer;

/**
 *
 * @author MX Li
 */
public class TreeIconRender extends DefaultTreeCellRenderer {

    private Icon leafSelectedIcon;
    private Icon leafUnSelectedIcon;
    private Icon folderOpen;
    private Icon folderClose;

    @Override
    public Component getTreeCellRendererComponent(JTree tree,
            Object value,
            boolean selected,
            boolean expanded,
            boolean leaf,
            int row,
            boolean hasFocus) {
        super.getTreeCellRendererComponent(tree, value, selected, expanded,
                leaf, row, hasFocus);

        if (leaf && selected) {
            setIcon(this.leafSelectedIcon);
        } else if (leaf) {
            setIcon(this.leafUnSelectedIcon);
        }

        return this;
    }

    public TreeIconRender(String folderOpenName, String folderCloseName, String leafUnselectName, String leafSelectName) {
        super();
        leafSelectedIcon = GUIUtil.readImageIcon(leafSelectName);
        leafUnSelectedIcon = GUIUtil.readImageIcon(leafUnselectName);
        folderOpen = GUIUtil.readImageIcon(folderOpenName);
        folderClose = GUIUtil.readImageIcon(folderCloseName);
        this.setLeafIcon(leafUnSelectedIcon);
        this.setOpenIcon(folderOpen);
        this.setClosedIcon(folderClose);

    }
}
