/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * UpdateItselfDialog.java
 *
 * Created on 2010-12-1, 8:56:31
 */
package org.cobi.igg3.gui;

import java.awt.Color;
import java.io.File;
import java.util.ArrayList;
import java.util.List;
import javax.swing.JDialog;
import javax.swing.JOptionPane;
import javax.swing.SwingWorker;
import javax.swing.text.AttributeSet;
import javax.swing.text.BadLocationException;
import javax.swing.text.Document;
import javax.swing.text.SimpleAttributeSet;
import javax.swing.text.StyleConstants;
import org.apache.http.client.HttpClient;
import org.apache.http.conn.ClientConnectionManager;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.impl.conn.tsccm.ThreadSafeClientConnManager;
import org.cobi.igg3.Constants;
import org.cobi.igg3.GlobalVariables;
import org.cobi.util.download.HttpClient4API;
import org.cobi.util.download.HttpClient4DownloadTaskProgressBar;
import org.cobi.util.download.HttpClient4TaskBeanProgressBar;
import org.cobi.util.download.Utils;
import org.cobi.util.thread.TaskQueue;
import org.cobi.util.thread.ThreadPool;

/**
 *
 * @author mxli
 */
public class UpdateItselfDialog extends javax.swing.JDialog implements Constants {

    /** Creates new form UpdateItselfDialog */
    public UpdateItselfDialog(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        GlobalVariables.buildInternetConnection();
        initComponents();
        setIconImage(GUIUtil.readImageIcon("igg.png").getImage());
        SwingWorker swingWorker = new MySwingWorker(this);
        swingWorker.execute();
    }

    private void checkLibFileVersion() throws Exception {

        List<String> updatedFiles = new ArrayList<String>();
        List<String> updatedURLFiles = new ArrayList<String>();
        for (int i = 0; i < LOCAL_FILE_PATHES.length; i++) {
            File newLibFile = new File(LOCAL_COPY_FOLDER + File.separator + LOCAL_FILE_PATHES[i]);
            if (!newLibFile.exists()) {
                updatedFiles.add(LOCAL_FILE_PATHES[i]);
                updatedURLFiles.add(URL_FILE_PATHES[i]);
            } else {
                long fileSize = newLibFile.length();
                String url = URL_FOLDER + URL_FILE_PATHES[i];

                long netFileLen = HttpClient4API.getContentLength(url);
                if (netFileLen <= 0) {
                    updatedFiles.add(LOCAL_FILE_PATHES[i]);
                    updatedURLFiles.add(URL_FILE_PATHES[i]);
                }
                if (fileSize != netFileLen) {
                    updatedFiles.add(LOCAL_FILE_PATHES[i]);
                    updatedURLFiles.add(URL_FILE_PATHES[i]);
                }
            }
        }

        if (!updatedFiles.isEmpty()) {            
            insertString2Panel("Updating libraries ...");
            int filesNum = updatedFiles.size();
            GlobalVariables.buildInternetConnection();
            ClientConnectionManager cm = new ThreadSafeClientConnManager(GlobalVariables.httpParams, GlobalVariables.connectionSchemeRegistry);
            HttpClient httpClient = new DefaultHttpClient(cm, GlobalVariables.httpParams);

            TaskQueue queue = new TaskQueue();
            for (int i = 0; i < filesNum; i++) {
                HttpClient4TaskBeanProgressBar task = new HttpClient4TaskBeanProgressBar();
                task.setHttpClient(httpClient);
                task.setDownloadProgressBar(downloadProgressBar);
                task.setInforTextPane(inforTextPane);
                task.setDownURL(URL_FOLDER + updatedURLFiles.get(i));
                task.setSectionCount(5);
                task.setWorkerCount(5);
                task.setBufferSize(128 * 1024);
                File newLibFile = new File(LOCAL_COPY_FOLDER + File.separator + updatedFiles.get(i));
                File libFolder = newLibFile.getParentFile();
                if (!libFolder.exists()) {
                    libFolder.mkdirs();
                }
                task.setSaveFile(newLibFile.getCanonicalPath());
                queue.putTask(new HttpClient4DownloadTaskProgressBar(task));
            }
            ThreadPool pool = new ThreadPool(queue);
            //launtch two thread to do these taskBean
            for (int i = 0; i < 1; i++) {
                pool.addWorkerThread();
            }
            pool.jointAllWorkerThread();
            insertString2Panel("The library has been updated successfully!\n Please re-initiate this application!");
            Utils.updateLocal();
        }
    }

    public void insertString2Panel(String str) {
        SimpleAttributeSet attrset = new SimpleAttributeSet();
        StyleConstants.setForeground(attrset, Color.BLACK);

        //StyleConstants.setForeground(attrset, Color.BLUE.brighter());
        //StyleConstants.setBold(attrset, true);
        StyleConstants.setFontFamily(attrset, "Courier New");
        StyleConstants.setFontSize(attrset, 13);
        insert(str, attrset);
    }

    private void insert(String str, AttributeSet attrset) {
        Document docs = inforTextPane.getDocument();
        str = str + "\n";
        try {
            docs.insertString(docs.getLength(), str, attrset);
        } catch (BadLocationException ble) {
            JOptionPane.showMessageDialog(this, "BadLocationException:" + ble, "Error", JOptionPane.ERROR_MESSAGE);
        }
    }

    class MySwingWorker extends SwingWorker {

        JDialog parantDialog;

        public MySwingWorker(JDialog parantDialog) {
            this.parantDialog = parantDialog;
        }

        @Override
        protected Object doInBackground() {
            try {
                checkLibFileVersion();
            } catch (Exception ex) {
                JOptionPane.showMessageDialog(parantDialog, ex.toString(), "Error", JOptionPane.ERROR_MESSAGE);
            }
            return null;
        }

        @Override
        protected void done() {
            try {
            } catch (Exception ex) {
                JOptionPane.showMessageDialog(parantDialog, ex.toString(), "Error", JOptionPane.ERROR_MESSAGE);
            }
        }
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        downloadProgressBar = new javax.swing.JProgressBar();
        jScrollPane1 = new javax.swing.JScrollPane();
        inforTextPane = new javax.swing.JTextPane();
        exitButton = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new LinkLabel ("IGG Website", "http://bioinfo1.hku.hk:13080/iggweb/download.htm");

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(org.cobi.igg3.gui.IGG3App.class).getContext().getResourceMap(UpdateItselfDialog.class);
        setTitle(resourceMap.getString("Form.title")); // NOI18N
        setName("Form"); // NOI18N
        setResizable(false);

        jPanel1.setBorder(javax.swing.BorderFactory.createEtchedBorder(resourceMap.getColor("jPanel1.border.highlightColor"), resourceMap.getColor("jPanel1.border.shadowColor"))); // NOI18N
        jPanel1.setName("jPanel1"); // NOI18N

        downloadProgressBar.setName("downloadProgressBar"); // NOI18N

        jScrollPane1.setName("jScrollPane1"); // NOI18N

        inforTextPane.setEditable(false);
        inforTextPane.setName("inforTextPane"); // NOI18N
        jScrollPane1.setViewportView(inforTextPane);

        exitButton.setText(resourceMap.getString("exitButton.text")); // NOI18N
        exitButton.setAutoscrolls(true);
        exitButton.setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        exitButton.setName("exitButton"); // NOI18N
        exitButton.setNextFocusableComponent(exitButton);
        exitButton.setSelected(true);
        exitButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                exitButtonActionPerformed(evt);
            }
        });

        jLabel1.setText(resourceMap.getString("jLabel1.text")); // NOI18N
        jLabel1.setName("jLabel1"); // NOI18N

        jLabel2.setText(resourceMap.getString("jLabel2.text")); // NOI18N
        jLabel2.setName("jLabel2"); // NOI18N

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 433, Short.MAX_VALUE)
                    .addComponent(downloadProgressBar, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 433, Short.MAX_VALUE)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 154, Short.MAX_VALUE)
                        .addComponent(exitButton)))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(downloadProgressBar, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 225, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(exitButton)
                    .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void exitButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_exitButtonActionPerformed
        // TODO add your handling code here:
        System.exit(0);
}//GEN-LAST:event_exitButtonActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                UpdateItselfDialog dialog = new UpdateItselfDialog(new javax.swing.JFrame(), true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {

                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JProgressBar downloadProgressBar;
    private javax.swing.JButton exitButton;
    private javax.swing.JTextPane inforTextPane;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    // End of variables declaration//GEN-END:variables
}
