/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * WebBrowserDialog.java
 *
 * Created on 2009-10-17, 20:31:58
 */
package org.cobi.igg3.gui;

import java.awt.Color;
import java.awt.Component;
import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;
import java.io.File;
import java.net.URL;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Random;
import javax.swing.AbstractAction;
import javax.swing.Icon;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.JPopupMenu;
import javax.swing.JSeparator;
import javax.swing.JTable;
import javax.swing.RowFilter;
import javax.swing.SwingWorker;
import javax.swing.event.HyperlinkEvent;
import javax.swing.table.TableCellRenderer;
import javax.swing.table.TableColumn;
import javax.swing.table.TableRowSorter;
import javax.swing.text.AttributeSet;
import javax.swing.text.BadLocationException;
import javax.swing.text.Document;
import javax.swing.text.SimpleAttributeSet;
import javax.swing.text.StyleConstants;
import javax.swing.text.html.HTMLDocument;
import javax.swing.text.html.HTMLFrameHyperlinkEvent;
import org.apache.http.client.HttpClient;
import org.apache.http.conn.ClientConnectionManager;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.impl.conn.tsccm.ThreadSafeClientConnManager;
import org.cobi.igg3.Constants;
import org.cobi.igg3.GlobalVariables;
import org.cobi.util.download.HttpClient4TaskAssignTableModel;
import org.cobi.util.download.HttpClient4TaskBean;
import org.jdesktop.application.Action;
import org.jdesktop.application.Task;

/**
 *
 * @author MX Li
 */
public class WebBrowserDialog extends javax.swing.JDialog implements Constants {

    IntegrateHapMapPhaseDialog phaseDialog;
    IntegrateHapMapDialog unphaseDialog;
    private List<String> pageList = new ArrayList<String>();
    ClientConnectionManager cm;
    HttpClient httpClient;
    MyProgressBarTableModel downloadTableModel = new MyProgressBarTableModel();
    private TableRowSorter sorter = null;
    private static final Color evenColor = new Color(250, 250, 250);
    private final HashSet set = new HashSet();

    /** Creates new form WebBrowserDialog */
    public WebBrowserDialog(java.awt.Frame parent, boolean modal, IntegrateHapMapPhaseDialog pareDialog) {
        super(parent, modal);
        setIconImage(GUIUtil.readImageIcon("igg.png").getImage());
        downloadTableModel = new MyProgressBarTableModel();
        sorter = new TableRowSorter(downloadTableModel);
        initComponents();
        this.phaseDialog = pareDialog;
        this.setTitle("Dwonload HapMap Phased Genotypes");
        folderTextField.setText(GlobalVariables.lastAccessedPath);
        try {
            URL url = new URL("http://hapmap.ncbi.nlm.nih.gov/downloads/phasing/?N=D");
            htmlEditorPane.setEditable(false);
            showPage(url, true);
        } catch (Exception ex) {
            JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), ex.toString(), "Error", JOptionPane.ERROR_MESSAGE);
        }
        initOtherComponents();
    }

    /** Creates new form WebBrowserDialog */
    public WebBrowserDialog(java.awt.Frame parent, boolean modal, IntegrateHapMapDialog pareDialog) {
        super(parent, modal);
        setIconImage(GUIUtil.readImageIcon("igg.png").getImage());
        downloadTableModel = new MyProgressBarTableModel();
        sorter = new TableRowSorter(downloadTableModel);
        initComponents();
        this.unphaseDialog = pareDialog;
        this.setTitle("Dwonload HapMap UnPhased Genotypes");
        folderTextField.setText(GlobalVariables.lastAccessedPath);
        try {
            URL url = new URL("http://hapmap.ncbi.nlm.nih.gov/downloads/genotypes/?N=D");
            htmlEditorPane.setEditable(false);
            showPage(url, true);
        } catch (Exception ex) {
            JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), ex.toString(), "Error", JOptionPane.ERROR_MESSAGE);
        }
        initOtherComponents();
    }
    /*
    
    public WebBrowserDialog(java.awt.Frame parent, boolean modal) {
    super(parent, modal);
    setIconImage(GUIUtil.readImageIcon("igg.png").getImage());
    downloadTableModel = new MyProgressBarTableModel();
    sorter = new TableRowSorter(downloadTableModel);
    initComponents();
    folderTextField.setText(GlobalVariables.lastAccessedPath);
    try {
    URL url = new URL("http://hapmap.ncbi.nlm.nih.gov/downloads/phasing/?N=D");
    htmlEditorPane.setEditable(false);
    showPage(url, true);

    } catch (Exception ex) {
    JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), ex.toString(), "Error", JOptionPane.ERROR_MESSAGE);
    }

    initOtherComponents();

    }
     */

    private void initOtherComponents() {
        cm = new ThreadSafeClientConnManager(GlobalVariables.httpParams, GlobalVariables.connectionSchemeRegistry);
        httpClient = new DefaultHttpClient(cm, GlobalVariables.httpParams);
        addWindowListener(new java.awt.event.WindowAdapter() {

            @Override
            public void windowClosing(java.awt.event.WindowEvent e) {
                httpClient.getConnectionManager().shutdown();
            }
        });

        downloadTable.setRowSorter(sorter);
// 弹出菜单
        downloadTable.setComponentPopupMenu(new JPopupMenu());
// 是否始终大到足以填充封闭视口的高度

        downloadTable.setFillsViewportHeight(true);
// 将单元格间距的高度和宽度设置为指定的Dimension

        downloadTable.setIntercellSpacing(new Dimension());
// 是否绘制单元格间的水平线

        downloadTable.setShowHorizontalLines(true);
// 是否绘制单元格间的垂直线

        downloadTable.setShowVerticalLines(false);
// 停止编辑时重新定义焦点，避免TableCellEditor丢失数据

        downloadTable.putClientProperty("terminateEditOnFocusLost", Boolean.TRUE);
// 表示JTable中列的所有属性，如宽度、大小可调整性、最小和最大宽度等。

        TableColumn column = downloadTable.getColumnModel().getColumn(0);
        column.setMaxWidth(30);
        column.setMinWidth(30);
        column.setResizable(false);

        /*
        column = downloadTable.getColumnModel().getColumn(1);
        column.setMaxWidth(100);
        column.setMinWidth(100);
        column.setResizable(false);
         */
        column = downloadTable.getColumnModel().getColumn(2);
// 绘制此列各值的TableCellRenderer
        column.setCellRenderer(new ProgressRenderer());
    }

    private JPopupMenu makePopup() {
        JPopupMenu pop = new JPopupMenu();

        AbstractAction act = new CancelAction("Cancel", null);
        int[] selection = downloadTable.getSelectedRows();
        if (selection == null || selection.length <= 0) {
            act.setEnabled(false);
        }
        pop.add(act);
// 分割线
        pop.add(new JSeparator());
        act = new DeleteAction("Delelte", null);
        if (selection == null || selection.length <= 0) {
            act.setEnabled(false);
        }
        pop.add(act);
        return pop;
    }

    class CancelAction extends AbstractAction {

        private static final long serialVersionUID = 1L;

        public CancelAction(String label, Icon icon) {
            super(label, icon);
        }

        public void actionPerformed(ActionEvent evt) {
            cancelActionPerformed(evt);
        }
    }

    /** */
    /**
     * 取消进度
     * @param evt
     */
    public synchronized void cancelActionPerformed(ActionEvent evt) {
        int[] selection = downloadTable.getSelectedRows();
        if (selection == null || selection.length <= 0) {
            return;
        }
        for (int i = 0; i < selection.length; i++) {
            int midx = downloadTable.convertRowIndexToModel(selection[i]);
            SwingWorker worker = downloadTableModel.getSwingWorker(midx);
            if (worker != null && !worker.isDone()) {
                worker.cancel(true);
            }
            worker = null;
        }
        downloadTable.repaint();
    }

    /** */
    /**
     * 取消下载进程
     *
     * @author chenpeng
     *
     */
    class DeleteAction extends AbstractAction {

        private static final long serialVersionUID = 1L;

        public DeleteAction(String label, Icon icon) {
            super(label, icon);
        }

        public void actionPerformed(ActionEvent evt) {
            deleteActionPerformed(evt);
        }
    }

    public synchronized void deleteActionPerformed(ActionEvent evt) {
        int[] selection = downloadTable.getSelectedRows();
        if (selection == null || selection.length <= 0) {
            return;
        }
        for (int i = 0; i < selection.length; i++) {
            int midx = downloadTable.convertRowIndexToModel(selection[i]);
            set.add(midx);
            SwingWorker worker = downloadTableModel.getSwingWorker(midx);
            if (worker != null && !worker.isDone()) {
                worker.cancel(true);
            }
            worker = null;
        }
// JTable过滤器

        final RowFilter<MyProgressBarTableModel, Integer> filter = new RowFilter<MyProgressBarTableModel, Integer>() {

            public boolean include(Entry<? extends MyProgressBarTableModel, ? extends Integer> entry) {
                Integer midx = entry.getIdentifier();
                return !set.contains(midx);
            }
        };
        sorter.setRowFilter(filter);
        downloadTable.repaint();
    }

    /** */
    /**
     * 创建事件
     * @param evt
     */
    private void createNewActionPerformed(ActionEvent evt) {
        final int key = downloadTableModel.getRowCount();
//在jdk1.6后，当一个Swing程序需要执行一个多线程任务时，可以通过javax.swing.SwingWorker实例进行实现。
//SwingWorker的process可以定义约束属性。更改这些属性将触发事件，并从事件调度线程上引起事件处理方法的调用。
//SwingWorker的done方法，在后台任务完成时自动的在事件调度线程上被调用。

        SwingWorker<Integer, Integer> worker = new SwingWorker<Integer, Integer>() {
// 随机sleep

            private int sleepDummy = new Random().nextInt(100) + 1;
// 最大任务数量
            private int taskSize = 200;

            protected Integer doInBackground() {
                int current = 0;
                while (current < taskSize && !isCancelled()) {
                    current++;
                    try {
                        Thread.sleep(sleepDummy);
                    } catch (InterruptedException ie) {
                        publish(-1);
                        break;
                    }
                    publish(100 * current / taskSize);
                }
                return sleepDummy * taskSize;
            }

            /** */
            /**
             * 进行中处理
             */
            @Override
            protected void process(java.util.List<Integer> data) {
                for (Integer value : data) {
                    // 把数据填入对应的行列
                    downloadTableModel.setValueAt(value, key, 2);
                }
// 传送变更事件给指定行列
                downloadTableModel.fireTableCellUpdated(key, 2);
            }

            /** */
            /**
             * 完成后处理
             */
            @Override
            protected void done() {
            }
        };
        downloadTableModel.addDownloadTask(new MyDownloadTask("Test", 0), worker);
        worker.execute();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        htmlEditorPane = new javax.swing.JEditorPane();
        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        textFieldURL = new javax.swing.JTextField();
        jButton1 = new javax.swing.JButton();
        backButton = new javax.swing.JButton();
        forwardButton = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        folderTextField = new javax.swing.JTextField();
        jButton2 = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();
        jPanel3 = new javax.swing.JPanel();
        jSplitPane1 = new javax.swing.JSplitPane();
        jScrollPane2 = new javax.swing.JScrollPane();
        downloadTable = new JTable(downloadTableModel) {
            private static final long serialVersionUID = 1L;
            @Override
            public Component prepareRenderer( TableCellRenderer tableCellRenderer, int row, int column) {
                Component component = super.prepareRenderer(tableCellRenderer, row, column);
                //背景色及字体设置
                if (isRowSelected(row)) {
                    component.setForeground(getSelectionForeground());
                    component.setBackground(getSelectionBackground());
                } else {
                    component.setForeground(getForeground());
                    component.setBackground((row % 2 == 0) ? evenColor : downloadTable.getBackground());
                }
                return component;
            }

            @Override
            public JPopupMenu getComponentPopupMenu() {
                return makePopup();
            }
        };
        jScrollPane3 = new javax.swing.JScrollPane();
        messageTextPane = new javax.swing.JTextPane();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setName("Form"); // NOI18N
        setResizable(false);

        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(org.cobi.igg3.gui.IGG3App.class).getContext().getResourceMap(WebBrowserDialog.class);
        jScrollPane1.setBorder(javax.swing.BorderFactory.createTitledBorder(resourceMap.getString("jScrollPane1.border.title"))); // NOI18N
        jScrollPane1.setName("jScrollPane1"); // NOI18N

        htmlEditorPane.setName("htmlEditorPane"); // NOI18N
        htmlEditorPane.addHyperlinkListener(new javax.swing.event.HyperlinkListener() {
            public void hyperlinkUpdate(javax.swing.event.HyperlinkEvent evt) {
                htmlEditorPaneHyperlinkUpdate(evt);
            }
        });
        jScrollPane1.setViewportView(htmlEditorPane);

        jPanel1.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jPanel1.setName("jPanel1"); // NOI18N

        jLabel1.setFont(resourceMap.getFont("jLabel1.font")); // NOI18N
        jLabel1.setText(resourceMap.getString("jLabel1.text")); // NOI18N
        jLabel1.setName("jLabel1"); // NOI18N

        textFieldURL.setText(resourceMap.getString("textFieldURL.text")); // NOI18N
        textFieldURL.setName("textFieldURL"); // NOI18N
        textFieldURL.setPreferredSize(new java.awt.Dimension(59, 24));
        textFieldURL.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                textFieldURLKeyReleased(evt);
            }
        });

        javax.swing.ActionMap actionMap = org.jdesktop.application.Application.getInstance(org.cobi.igg3.gui.IGG3App.class).getContext().getActionMap(WebBrowserDialog.class, this);
        jButton1.setAction(actionMap.get("goPage")); // NOI18N
        jButton1.setName("jButton1"); // NOI18N

        backButton.setAction(actionMap.get("goBack")); // NOI18N
        backButton.setName("backButton"); // NOI18N
        backButton.setPreferredSize(new java.awt.Dimension(24, 24));

        forwardButton.setAction(actionMap.get("goForward")); // NOI18N
        forwardButton.setName("forwardButton"); // NOI18N

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(backButton, javax.swing.GroupLayout.PREFERRED_SIZE, 30, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(forwardButton, javax.swing.GroupLayout.PREFERRED_SIZE, 28, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(textFieldURL, javax.swing.GroupLayout.DEFAULT_SIZE, 563, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButton1, javax.swing.GroupLayout.PREFERRED_SIZE, 37, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        jPanel1Layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {backButton, forwardButton});

        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.CENTER)
                .addComponent(backButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addComponent(forwardButton)
                .addComponent(jLabel1)
                .addComponent(textFieldURL, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addComponent(jButton1, javax.swing.GroupLayout.PREFERRED_SIZE, 33, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        jPanel1Layout.linkSize(javax.swing.SwingConstants.VERTICAL, new java.awt.Component[] {backButton, forwardButton});

        jPanel2.setName("jPanel2"); // NOI18N

        jLabel2.setFont(resourceMap.getFont("jLabel2.font")); // NOI18N
        jLabel2.setText(resourceMap.getString("jLabel2.text")); // NOI18N
        jLabel2.setName("jLabel2"); // NOI18N

        folderTextField.setText(resourceMap.getString("folderTextField.text")); // NOI18N
        folderTextField.setName("folderTextField"); // NOI18N

        jButton2.setAction(actionMap.get("browseFolder")); // NOI18N
        jButton2.setName("jButton2"); // NOI18N

        jButton3.setAction(actionMap.get("cancel")); // NOI18N
        jButton3.setName("jButton3"); // NOI18N

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(folderTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 475, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jButton2, javax.swing.GroupLayout.PREFERRED_SIZE, 31, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 32, Short.MAX_VALUE)
                .addComponent(jButton3)
                .addContainerGap())
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(folderTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 24, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton2)
                    .addComponent(jButton3))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jPanel3.setName("jPanel3"); // NOI18N
        jPanel3.setLayout(new java.awt.GridLayout());

        jSplitPane1.setDividerLocation(356);
        jSplitPane1.setName("jSplitPane1"); // NOI18N

        jScrollPane2.setBorder(javax.swing.BorderFactory.createTitledBorder(resourceMap.getString("jScrollPane2.border.title"))); // NOI18N
        jScrollPane2.setName("jScrollPane2"); // NOI18N

        downloadTable.setName("downloadTable"); // NOI18N
        jScrollPane2.setViewportView(downloadTable);

        jSplitPane1.setLeftComponent(jScrollPane2);

        jScrollPane3.setBorder(javax.swing.BorderFactory.createTitledBorder(resourceMap.getString("jScrollPane3.border.title"))); // NOI18N
        jScrollPane3.setName("jScrollPane3"); // NOI18N

        messageTextPane.setName("messageTextPane"); // NOI18N
        jScrollPane3.setViewportView(messageTextPane);

        jSplitPane1.setRightComponent(jScrollPane3);

        jPanel3.add(jSplitPane1);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 739, Short.MAX_VALUE)
                    .addComponent(jPanel3, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 739, Short.MAX_VALUE)
                    .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 335, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel3, javax.swing.GroupLayout.DEFAULT_SIZE, 213, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    public class Dwonloader extends SwingWorker<Void, Void> {

        HttpClient4TaskAssignTableModel taskAssigner;
        HttpClient4TaskBean taskBean;

        public Dwonloader(HttpClient4TaskAssignTableModel taskAssigner, HttpClient4TaskBean taskBean) {
            this.taskAssigner = taskAssigner;
            this.taskBean = taskBean;
        }

        @Override
        protected Void doInBackground() {
            try {
                taskAssigner.work(taskBean);
            } catch (Exception ex) {
                JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), ex.toString(), "Error", JOptionPane.ERROR_MESSAGE);
            }
            return null;
        }

        @Override
        protected void done() {
            File file = new File(taskBean.getSaveFile());
            if (phaseDialog != null) {
                phaseDialog.addHapMapPhaseFile(file);
            }else{
                unphaseDialog.addHapMapPhaseFile(file);
            }
            insertString2Panel("Have added " + file.getName());
        }
    }

    public void insertString2Panel(String str) {
        SimpleAttributeSet attrset = new SimpleAttributeSet();
        StyleConstants.setForeground(attrset, Color.BLACK);

        // StyleConstants.setForeground(attrset, Color.BLUE.brighter());
        // StyleConstants.setBold(attrset, true);
        StyleConstants.setFontFamily(attrset, "Courier New");
        StyleConstants.setFontSize(attrset, 13);
        insert(str, attrset);
    }

    private void insert(String str, AttributeSet attrset) {
        Document docs = messageTextPane.getDocument();
        str = str + "\n";
        try {
            docs.insertString(docs.getLength(), str, attrset);
        } catch (BadLocationException ble) {
            System.err.println("BadLocationException:" + ble);
        }
    }

    private void htmlEditorPaneHyperlinkUpdate(javax.swing.event.HyperlinkEvent evt) {//GEN-FIRST:event_htmlEditorPaneHyperlinkUpdate
        // TODO add your handling code here:
        HyperlinkEvent.EventType eventType = evt.getEventType();
        if (eventType == HyperlinkEvent.EventType.ACTIVATED) {
            if (evt instanceof HTMLFrameHyperlinkEvent) {
                HTMLFrameHyperlinkEvent linkEvent = (HTMLFrameHyperlinkEvent) evt;
                HTMLDocument document = (HTMLDocument) htmlEditorPane.getDocument();
                document.processHTMLFrameHyperlinkEvent(linkEvent);
            } else {
                URL url = evt.getURL();
                String urlString = evt.getURL().toString();

                if (urlString.endsWith(".gz")) {
                    String fileName = urlString.substring(urlString.lastIndexOf("/") + 1);
                    int answer = JOptionPane.showConfirmDialog(GlobalVariables.currentApplication.getMainFrame(), "Download " + fileName + "?",
                            "Message", JOptionPane.YES_NO_OPTION);

                    if (answer == 1) {
                        return;
                    }
                    File localFolder = new File(folderTextField.getText());
                    if (!localFolder.exists()) {
                        localFolder.mkdir();
                    }
                    try {
                        HttpClient4TaskBean task = new HttpClient4TaskBean(httpClient);
                        task.setDownURL(urlString);
                        task.setSaveFile(localFolder.getCanonicalPath() + File.separator + fileName);
                        task.setSectionCount(FILE_SEGEMENT_NUM);
                        task.setWorkerCount(FILE_SEGEMENT_NUM);
                        task.setBufferSize(128 * 1024);
                        HttpClient4TaskAssignTableModel hta = new HttpClient4TaskAssignTableModel(downloadTableModel, messageTextPane);
                        SwingWorker dwonloadWorker = new Dwonloader(hta, task);
                        dwonloadWorker.execute();
                        //DownloadFileTask dwonloadWorker = new DownloadFileTask(org.jdesktop.application.Application.getInstance(org.cobi.igg3.gui.IGG3App.class), hta, task);
                        //dwonloadWorker.execute();
                        //downloadFile(hta, task).execute();
                    } catch (Exception ex) {
                        JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), ex.toString(), "Error", JOptionPane.ERROR_MESSAGE);
                    }
                } else {
                    showPage(url, true);
                }
            }
        }
    }//GEN-LAST:event_htmlEditorPaneHyperlinkUpdate

    private void textFieldURLKeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_textFieldURLKeyReleased
        // TODO add your handling code here:
        if (evt.getKeyCode() == KeyEvent.VK_ENTER) {
            goPage();
        }
    }//GEN-LAST:event_textFieldURLKeyReleased

    /**
     * @param args the command line arguments
     */
    /*
    public static void main(String args[]) {
    java.awt.EventQueue.invokeLater(new Runnable() {

    public void run() {
    WebBrowserDialog dialog = new WebBrowserDialog(new javax.swing.JFrame(), true);
    dialog.addWindowListener(new java.awt.event.WindowAdapter() {

    @Override
    public void windowClosing(java.awt.event.WindowEvent e) {
    System.exit(0);
    }
    });
    dialog.setVisible(true);
    }

    });
    }
     */
    @Action
    public void goPage() {
        URL verifiedUrl = verifyUrl(textFieldURL.getText());
        if (verifiedUrl != null) {
            pageList.clear();
            showPage(verifiedUrl, true);
        } else {
            showError("Invalid URL");
        }
    }

    @Action
    public void goBack() {
        URL currentUrl = htmlEditorPane.getPage();
        int pageIndex = pageList.indexOf(currentUrl.toString());
        try {
            showPage(new URL((String) pageList.get(pageIndex - 1)), false);
        } catch (Exception e) {
        }
    }

    @Action
    public void goForward() {
        URL currentUrl = htmlEditorPane.getPage();
        int pageIndex = pageList.indexOf(currentUrl.toString());
        try {
            showPage(new URL((String) pageList.get(pageIndex + 1)), false);
        } catch (Exception e) {
        }
    }

    // Verify URL format.
    private URL verifyUrl(String url) {
        // Only allow HTTP URLs.
        if (!url.toLowerCase().startsWith("http://")) {
            return null;
        }
        // Verify format of URL.
        URL verifiedUrl = null;
        try {
            verifiedUrl = new URL(url);
        } catch (Exception e) {
            return null;
        }
        return verifiedUrl;
    }

// Show dialog box with error message.
    private void showError(String errorMessage) {
        JOptionPane.showMessageDialog(this, errorMessage,
                "Error", JOptionPane.ERROR_MESSAGE);
    }
    /* Show the specified page and add it to
    the page list if specified. */

    private void showPage(URL pageUrl, boolean addToList) {
        // Show hour glass cursor while crawling is under way.
        setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
        try {
            // Get URL of page currently being displayed.
            URL currentUrl = htmlEditorPane.getPage();
            // Load and display specified page.
            htmlEditorPane.setPage(pageUrl);
            // Get URL of new page being displayed.
            URL newUrl = htmlEditorPane.getPage();

            // Add page to list if specified.
            if (addToList) {
                int listSize = pageList.size();
                if (listSize > 0) {
                    int pageIndex = pageList.indexOf(currentUrl.toString());
                    if (pageIndex < listSize - 1) {
                        for (int i = listSize - 1; i > pageIndex; i--) {
                            pageList.remove(i);
                        }
                    }
                }
                pageList.add(newUrl.toString());
            }

            // Update location text field with URL of current page.
            textFieldURL.setText(newUrl.toString());
            // Update buttons based on the page being displayed.
            updateButtons();
        } catch (Exception e) {
            showError("Cannot display this page");
        } finally {
            // Return to default cursor.
            setCursor(Cursor.getDefaultCursor());
        }
    }

    /* Update back and forward buttons based on
    the page being displayed. */
    private void updateButtons() {
        if (pageList.size() < 2) {
            backButton.setEnabled(false);
            forwardButton.setEnabled(false);
        } else {
            URL currentUrl = htmlEditorPane.getPage();
            int pageIndex = pageList.indexOf(currentUrl.toString());
            backButton.setEnabled(pageIndex > 0);
            forwardButton.setEnabled(pageIndex < (pageList.size() - 1));
        }
    }

    @Action
    public void browseFolder() {
        JFileChooser fDialog = null;
        if ((GlobalVariables.lastAccessedPath != null) && (GlobalVariables.lastAccessedPath.trim().length() > 0)) {
            fDialog = new JFileChooser(GlobalVariables.lastAccessedPath);
        } else {
            fDialog = new JFileChooser();
        }
        fDialog.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        int result = fDialog.showOpenDialog(this);
        if (result == JFileChooser.APPROVE_OPTION) {
            folderTextField.setText(fDialog.getSelectedFile().getAbsolutePath());
            GlobalVariables.lastAccessedPath = fDialog.getSelectedFile().getPath();
        }
    }

    @Action
    public void cancel() {
        setVisible(false);
    }

    @Action
    public Task downloadFile(HttpClient4TaskAssignTableModel taskAssigner, HttpClient4TaskBean taskBean) {
        return new DownloadFileTask(org.jdesktop.application.Application.getInstance(org.cobi.igg3.gui.IGG3App.class),
                taskAssigner, taskBean);
    }

    private class DownloadFileTask extends org.jdesktop.application.Task<Object, Void> {

        HttpClient4TaskAssignTableModel taskAssigner;
        HttpClient4TaskBean taskBean;

        DownloadFileTask(org.jdesktop.application.Application app, HttpClient4TaskAssignTableModel taskAssigner, HttpClient4TaskBean taskBean) {
            super(app);
            this.taskAssigner = taskAssigner;
            this.taskBean = taskBean;
        }

        DownloadFileTask(org.jdesktop.application.Application app) {
            // Runs on the EDT.  Copy GUI state that
            // doInBackground() depends on from parameters
            // to DownloadFileTask fields, here.
            super(app);
        }

        @Override
        protected Object doInBackground() {
            // Your Task's code here.  This method runs
            // on a background thread, so don't reference
            // the Swing GUI from here.
            try {
                taskAssigner.work(taskBean);
            } catch (Exception ex) {
                JOptionPane.showMessageDialog(GlobalVariables.currentApplication.getMainFrame(), ex.toString(), "Error", JOptionPane.ERROR_MESSAGE);
            }
            return null;  // return your result
        }

        @Override
        protected void succeeded(Object result) {
            // Runs on the EDT.  Update the GUI based on
            // the result computed by doInBackground().
            File file = new File(taskBean.getSaveFile());
            if (phaseDialog != null) {
                phaseDialog.addHapMapPhaseFile(file);
            }else{
                unphaseDialog.addHapMapPhaseFile(file);
            }
            insertString2Panel("Have added " + file.getName());
        }
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton backButton;
    private javax.swing.JTable downloadTable;
    private javax.swing.JTextField folderTextField;
    private javax.swing.JButton forwardButton;
    private javax.swing.JEditorPane htmlEditorPane;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JSplitPane jSplitPane1;
    private javax.swing.JTextPane messageTextPane;
    private javax.swing.JTextField textFieldURL;
    // End of variables declaration//GEN-END:variables
}
