// (c) 2008-2009 Miaoxin Li
// This file is distributed as part of the IGG source code package
// and may not be redistributed in any form, without prior written
// permission from the author. Permission is granted for you to
// modify this file for your own personal use, but modified versions
// must retain this copyright notice and must not be distributed.
// Permission is granted for you to use this file to compile IGG.
// All computer programs have bugs. Use this file at your own risk.
// Saturday, January 17, 2009
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.cobi.util.file;

import java.io.BufferedReader;
import java.io.FileReader;
import java.util.ArrayList;
import java.util.List;
import java.util.StringTokenizer;

/**
 *
 * @author mxli
 */
public class LocalFile {

    /**
     * retrieve data from a text file it is based on tokenizor, but the order in the indices will
     * be changed to the order of the files. it is a consideration of speed.
     * @param FileName
     * @param indices
     * @param arry
     * @throws java.lang.Exception
     * @return
     */
    static public boolean retrieveData(String fileName, ArrayList<String[]> arry, int[] orgIndices,
            String delimiter) throws Exception {
        BufferedReader br = new BufferedReader(new FileReader(fileName));
        String line = null;
        String[] cells = null;
        String[] row = null;
        int selectedColNum = orgIndices.length;
        int i;

        while ((line = br.readLine()) != null) {
            line = line.trim();
            if (line.trim().length() == 0) {
                continue;
            }
            cells = line.split(delimiter, -1);
            row = new String[selectedColNum];
            for (i = 0; i < selectedColNum; i++) {
                row[i] = cells[orgIndices[i]];
            }
            arry.add(row);
        }
        br.close();
        return true;
    }

    static public boolean retrieveData(String fileName, List<String> arry, int indices,
            String delim) throws Exception {
        String delmiliter = "\t  ,";
        if (delim != null) {
            delmiliter = delim;        //usually some files donot start with data but with breif annoation, so we need filter the latter.

        }
        BufferedReader br = new BufferedReader(new FileReader(fileName));
        String line = null;
        StringBuffer tmpBuffer = new StringBuffer();
        while ((line = br.readLine()) != null) {
            StringTokenizer tokenizer = new StringTokenizer(line, delmiliter);
            for (int i = 0; i < indices; i++) {
                tokenizer.nextToken();
            }
            tmpBuffer.delete(0, tmpBuffer.length());
            tmpBuffer.append(tokenizer.nextToken().trim());
            arry.add(tmpBuffer.toString());
        }
        br.close();
        return true;
    }

    static public void retrieveAsOneColumn(String fileName, ArrayList<String[]> arry,
            int limitedRowNumber) throws Exception {
        BufferedReader br = new BufferedReader(new FileReader(fileName));
        String line = "";
        String[] row = null;
        int linenumber = 0;
        while ((line = br.readLine()) != null) {
            row = new String[1];
            line = line.replaceAll("\t", " ");
            row[0] = line;
            arry.add(row);
            linenumber++;
            if (linenumber > limitedRowNumber) {
                break;
            }
        }
    }

    /**
     * retrieve data from a text file whith limited rows
     * @param FileName
     * @param indices
     * @param arry
     * @throws java.lang.Exception
     * @return
     */
    static public boolean retrieveData(String fileName, ArrayList<String[]> arry,
            int limitedRowNumber, String delimi, String startLabel, boolean isTokenizer) throws Exception {
        BufferedReader br = new BufferedReader(new FileReader(fileName));
        String line = "";
        String[] row = null;
        int linenumber = 0;

        String delmilit = "\t\" \"\n";
        if (delimi != null) {
            delmilit = delimi;        //usually some files donot start with data but with breif annoation, so we need filter the latter.

        }
        if (startLabel != null) {
            while ((line = br.readLine()) != null) {
                if (line.trim().startsWith(startLabel)) {
                    break;
                }
            }
        }
        //stat to retreive the data
        if (delmilit.equals("NO_DELIMITER")) {
            do {
                row = new String[1];
                row[0] = line;
                arry.add(row);
                linenumber++;
                if (linenumber > limitedRowNumber) {
                    break;
                }
            } while ((line = br.readLine()) != null);
            return true;
        }
        StringBuffer tmpBuffer = new StringBuffer();
        if (isTokenizer) {
            int colNum = -1;
            int i;
            do {
                // System.out.println(line);
                if (line.trim().length() == 0) {
                    continue;
                }
                StringTokenizer tokenizer = new StringTokenizer(line, delmilit);
                if (colNum < 0) {
                    colNum = tokenizer.countTokens();
                }
                row = new String[colNum];
                for (i = 0; i < colNum; i++) {
                    tmpBuffer.delete(0, tmpBuffer.length());
                    tmpBuffer.append(tokenizer.nextToken().trim());
                    row[i] = tmpBuffer.toString();
                }
                arry.add(row);

                linenumber++;
                if (linenumber > limitedRowNumber) {
                    break;
                }
            } while ((line = br.readLine()) != null);
        } else {
            if (delmilit.equals("\t\" \"\n")) {
                delmilit = "[" + delmilit + "]";
            }
            do {
                if (line.trim().length() == 0) {
                    continue;
                }
                arry.add(line.split(delmilit, -1));
                linenumber++;
                if (linenumber > limitedRowNumber) {
                    break;
                }
            } while ((line = br.readLine()) != null);
        }
        br.close();
        return true;
    }

    /**
     * simply retrieve data from a  file
     * @param FileName   
     * @param arry
     * @throws java.lang.Exception
     * @return
     */
    static public boolean retrieveData(String fileName, StringBuffer tmpBf) throws Exception {
        BufferedReader br = new BufferedReader(new FileReader(fileName));
        String line = null;
        while ((line = br.readLine()) != null) {
            line = line.trim();
            tmpBf.append(line);
            tmpBf.append('\n');
        }
        br.close();
        return true;
    }
}
